1540.	[func]		fdupont
	Added a new method deleteSharedNetworkSubnets4 in the config
	backend API to delete all subnets belonging to a shared network.
	(Gitlab #512,!256, git 76991c42d115641c7fdcd0f215137be578fb39a0)

1539.	[build]		fdupont
	Obsolete dns++.pc file for pkg-config was removed.
	(Gitlab #498,!274, git 93cd62c99f69cc379c08cd06791db522c1fb0aca)

1538.	[func]		marcin
	DHCP configuration parsers correctly handle unspecified parameters.
	This change was required for the MySQL Config Backend to record
	unspecified parameters as NULL in the database.
	(Gitlab #488,!259, git d3b33058651036be34200f16d2da230267415056)

1537.	[func]		godfryd
	Improved handling unix sockets in unit tests. Now by default
	they are created in temporary folder under /tmp folder. This
	fixes the issue with creating sockets with too long path
	in the case when source folder is deeply nested.
	(Gitlab #357,!258, git a45e2f68d7d1848adb0cf755954a3d76c9dff338)

1536.	[build]		tomek
	Many changes in keactrl, kea-admin, cql_config and sysrepo_config
	scripts. ISC is now using shellcheck to verify portability of
	our scripts.
	(Gitlab #480,!245, git 8818ba0260ba36710b88db6401069f9fe4f3a73a)

1535.	[func]		godfryd
	Added checking required Vagrant version by Hammer.
	Removed Hammer from EXTRA_DIST.
	(Gitlab #518,!257, git ea0006f6eb948d7d4a034b413c5086cbe483eb75)

1534.	[func]		marcin
	MySQL config backend correctly handles the optional values for
	subnets and shared networks. Also, updated the MySQL config
	backend to store and fetch T1 and T2 percentage settings.
	(Gitlab #489,!250, git 01fc4d5bb4105b90c7025e8ca8131c3c15203848)

1533.	[doc]		sgoldlust,stephen
	Kea User's Guide significantly updated.
	(Gitlab #362,!182, git 4b7a8df6054d18f2c90fe61d93533466f89e6324)

1532.	[func]*		marcin
	Renamed OptionalValue C++ object to Optional and modified its
	API. This object is now used to represent optional values in
	subnets and shared networks. This is an internal Kea logic
	change but it may impact existing user hooks libraries.
	(Gitlab #487,!232, git 1c58e0ce9b9fd6fc8864dbfb2335bc5841c78ff3)

1531.	[func]		tmark
	When fetching configuration data from configured backends,
	kea-dhcp4 will now merge option definitions.
	(Gitlab #400,!243, git 0c5d1417031e49bd0c247889989e187db2dd8f4b)

1530.	[bug] 		adwol
	Potential syntax error in keactrl fixed. Thanks to Adam Osuchowski
	from Silesian University of Technology for providing a patch.
	(Gitlab #162,!241, git b1a1137f252432aa956ed6fea3da21c740857333)

1529.	[func]		tmark
	When fetching configuration data from configured backends,
	kea-dhcp4 will now merge global parameters.
	(Gitlab #402,!224, git dadaf76f8dd61b8bb3405aa5dc80029f09b2d4ec)

1528.	[func]		fdupont
	Aligned DHCPv4 and DHCPv6 specific tables used by the MySQL Config
	Backend. Extended MySQL schema to implement audit trail for the
	DHCPv6 Config Backend.
	(Gitlab #460,!232,!236, git 57f945f917db522773281c9e95ec8027afae6205)

1527.	[build]		adwol,fdupont,tomek
	Default Kea installation directory has been changed to
	${prefix}/lib/kea/hooks.
	(Gitlab #161,!240, git cfaf16cf02191bf5b7172cade3f58a626288b5f0)

1526.	[func]		tmark
	In addition to subnets, when fetching configuration data from
	configured backends, kea-dhcp4 will now merge shared-networks.
	(Gitlab #399,!215, git 6b57b6b5d678c91b6b380fbe08beafd06b0e7b1d)

1525.	[func]		fdupont
	Defined API for the DHCPv6 Configuration Backend.
	(Gitlab #458,!231, git f16e03d9bf1c10903c16b2614223b10880f73d50)

1524.	[func]		tomek
	Support for vendor options improved in DHCPv4 and DHCPv6. Kea is now
	able to send back vendor suboptions, even if the client packet didn't
	include DHCPv4 vivso (125) or DHCPv6 vendor (17) option. Usage of client
	classification in such a case is required, though.
	(Gitlab #464,!238, git 5c79da9358862657a631a9a8fc2ce79ae26b762e)

1523.	[bug]		fdupont
	IfaceMgr::send method now returns proper status that matches
	its documentation. Thanks to Matthias Stoeckl from Secunet
	for reporting this issue.
	(Gitlab #417,!221, git 4be58523f38097cea81ea06161aead58e00aeb2a)

1522.	[bug]		marcin
	The "unspecified" DHCP timer values (e.g. renew-timer) are
	represented as NULL values in the database. This corrects
	a bug whereby the unspecified timers defaulted to 0 which
	prevented the DHCP server from calculating the timers to
	be sent to the client. Instead a value of 0 was sent.
	(Gitlab #451,!227, git 5ec9a55528fbcfff4e0c808f9a745b9fd3a5dfae)

1521.	[func]		marcin
	Removed subsecond precision for the timestamps in MySQL config
	backend. It caused issues on systems with MySQL version prior
	to 5.6.4 which don't support subsecond timestamp values.
	(Gitlab #444,!229, git 71200e98f5a862908240a0d2e269b5da23290af9)

1520.	[build]		fdupont
	Made perfdhcp build optional and off by default: to build it
	please use the new --enable-perfdhcp configure flag.
	(Gitlab #340,!220, git b2d9a5559c348e82d6730809ccf1429097a9872c)

1519.	[bug]		Brent Bloxam
	A bug in kea-admin that always assumed the PostgreSQL database is
	always local has been fixed. Thank you to Brent Bloxam from
	Beanfield Metroconnect for submiting a patch!
	(Gitlab #423,!216, git d14e2f34c7d544aeb5e1e219f305fac9ab18c498)

1518.	[func]		marcin
	Extended MySQL schema to include the types of the global DHCP
	parameters in the database. The Kea servers will use this
	information to cast the values fetched from the database into
	their actual types. The supported types are: string, integer,
	boolean and real.
	(Gitlab #429,!217, git edd745c507ce5a888461df1489311de0c22cd312)

1517.	[func]		tmark
	kea-dhcp4 will now connect to and fetch configuration data from
	configured backends. At this point, only fetched subnet data is
	merged and used.
	(Gitlab #101,!202, git c572f8aea94349ff5fb4afee13a88ba811cc6459)

1516.	[func]		marcin
	Implemented audit trail for MySQL Configuration Backend. It allows
	for tracking incremental changes in the servers' configurations.
	Both mysql_cb hooks library and the MySQL schema have been updated
	to facilitate this feature.
	(Gitlab #396,!205, git 6d40db07ef641eef29405c42e718979e7a1e8675)

1515.	[func]		fdupont
	Changes required for new host commands that retrieve all host
	reservations from a given subnet (reservation-get-all,
	reservation-get-page) added. Also added documentation.
	(Gitlab #313,!199, git 991b2fadcb9e8171a78e27f95e4bfba6393d7824)

1514.	[func]		fdupont
	Control Agent and DHCP-DDNS daemons now support config-reload
	command, that instruct a given server to load again its
	configuration from a file on disk.
	(Gitlab #375,!192, git 93648a3a4918225e2c4413ae220fccc59eaea99a)

1513.	[func]		godfryd
	Fixed perfdhcp that now it keeps requested rate during performance
	testing. Previously it was always about 20% lower than expected.
	(Gitlab #283,!135, git 329f54bb151ec35888e9a8070cc5fa368d6f1f5e)

1512.   [func]      tmark
	kea-dhcp4 will now ignore empty Host Name (option code 12) values
	received from clients.  While an empty value for this option is
	not RFC-compliant, some clients do send them.  Prior to the this
	server would drop the entire packet.  In the spirit of being liberal
	in what we accept, the server will now simply omit the option.
	(Gitlab #40,!203, git f41bd35c3e7a3bdc1f31c5602fd91d5c84c60163)

1511.	[func]		fdupont
	Obsolete experimental secure DHCPv6 options (701-704) removed.
	(Gitlab #386,!196, git 1114527652615fb730e323946cafaf1c7ca72b42)

1510.	[bug]		fdupont
	DHCPv4 and DHCPv6 no longer crash if badly broken configuration
	is received.
	(Gitlab #381,!193, git f45fe7b7e3916d36d017b4ec5b50588fbf517d86)

1509.	[func]		tmark
	kea-dhcp4 can now be configured to calculate values to
	send to clients for for T1 and T2 (options 58 and 59
	repsectively).  Prior to this it was only possibly to
	specify explicit values.
	(Gitlab #365,!194, git 67944844a40436cd69e0e5b4962f5c9cba89ef6f)

1508.	[func]		fdupont
	Implemented the management API using a control socket for the
	DHCP DDNS (D2) server. D2 now supports the following commands:
	build-report, config-get, config-set, config-test, config-write,
	list-commands, shutdown and version-get. Also, extended Control
	Agent (CA) to support one additional command: config-set.
	(Gitlab #30,!183, git ab27550cec365f42289eb5fa1bc39f33f01b19c2)

1507.	[func]		tmark
	kea-dhcp4 now ensures that the message type option (53) is
	the first option in outbound DHCPv4 packets.  This was done
	to accommodate non-compliant clients that require the option
	to be first.
	(Gitlab #363,!177, git 34f40035bf7a7849083138cacee440a9f0991d67)

Kea 1.5.0 released on Dec 14, 2018

1506.	[build]		marcin
	Bumped up libraries version numbers for Kea 1.5.0 final release.
	(Gitlab #338,!168, git 551c5d704804d0ab2ea276e95dbae66b9d0f5561)

1505.	[bug]		marcin
	Corrected an issue in the lease_cmds hooks library which caused
	errors while adding leases with high lease expiration time value
	to the database. Many thanks to Shawn Routhier from Infoblox for
	finding and reporting the issue.
	(Gitlab #337,!167, git 3fcdc28814310ac93b3903897e952b3b60cfa0bc)

1504.	[bug]		fdupont
	Created separate control buffers for reception and transmission
	over UDP sockets.
	(Gitlab #327,!166, git cbb573858d7b1a4d2ba2316db457aa55ab037fc3)

1503.	[doc]		fdupont, marcin
	Updated "JSON Configuration" section of the Kea User's Guide.
	(Gitlab #198,!160, git 94c66b3c071d7bbf4b247bf57cd75ddcc343177e)

1502.	[bug]		fdupont
	Unicode parser for JSON structures has been improved. It now
	handles escape sequences better.
	(Gitlab #45,!40, git ba9b18cf2af66f8fb80e3dbbe13da11c99764588)

1501.	[func]		fdupont
	keactrl now supports kea-netconf. The new daemon is disabled by
	default. Please edit keactrl.conf (netconf=yes) if you want to
	start using it.
	(Gitlab #186,!163, git 8f7d556456891e7c675082f7e6cc88da71a92fee)

1500	[func, doc]	tmark
	Streamlined the isc::dhcp::PacketQueue interface and
	added a section on Congestion Handling to the developer's guide.
	(Gitlab #278,!162, git 0ce615f5da993ac90f675c5315ba7cb5c2ef3e1c)

1499.	[func]		tmark
	For Kea 1.5.0, congestion handling has been disabled by
	default.
	(Gitlab #277,!164, git 8d87c46a3cc7b7be4dd5f751b48449e92ee62d84)

1498.	[bug]		marcin
	Corrected behavior of the DHCP servers with respect to the
	"reconnect-wait-time" parameter setting. This parameter is
	specified in milliseconds, but the servers used to interpret
	it as specified in seconds.
	(Gitlab #173,!154, git 377f49e84ad6ebc91cbeac4116d24a15571c522d)

1497.	[func]		fdupont
	All YANG modules now have a revision specified. When starting,
	kea-netconf daemon will now check if the required modules are
	installed and have a proper revision. This should help spotting
	issues when migrating from older YANG modules.
	(Gitlab #204,!121, git 9e772e1472e073ee85924cfc706cb57a5e70a0b1)

1496.	[doc]		marcin
	Updated Kea documentation to reference RFC 8415, which is the
	new DHCPv6 specification. It obsoletes a number of RFCs:
	RFC 3315 (previous DHCPv6 specification), RFC 3633, RFC 3736,
	RFC 4242, RFC 7083, RFC 7283 and RFC 7550. Kea documentation
	now refers to RFC 8415 where appropriate instead of obsoleted
	RFCs.
	(Gitlab #288,!158, git 974b033a8de7a8e671156c33efeb13d4ac847c96)

1495.	[bug]		marcin
	Corrected an issue in the Memfile lease backend which caused
	errors while reading leases with very long lifetimes. Many
	thanks to Shawn Routhier from Infoblox for finding and reporting
	the issue.
	(Gitlab #303,!151, git ab92ab6fcd414f1efc7c5de6a641274da7c04e92)

1494.	[bug]		marcin
	Kea servers reject commands with unsupported parameters.
	(Gitlab #253,!147, git 7fc55489887c0e8f32db5c1fe9f46fa1cc2a4407)

1493.	[bug]		marcin
	Names carried in DHCPv4 Client FQDN option, Hostname option and
	stored in the lease database are case insensitive.
	(Gitlab #86,!152, git d9e23e2a6a3114b1c87de9c881ef10cdb1e00c61)

Kea 1.5.0-beta2 released on Nov 30, 2018

1492.	[doc]		fdupont
	Added a step by step netconf operation example in the
	Kea Administrators's Guide.
	(Gitlab #195,!131, git 994a826caf3c1a9f5f84d8b703a3b202120e91b6)

1491.	[build]		tomek
	coroutine.hpp from Boost 1.68 has been added the Kea source.
	It is used only if the Boost library provided by the system
	is very old and does not include that header. This effectively
	reverts the change done in Kea 1.4.0.
	(Gitlab #293,!45, git df0f507b8b750c8dff1f537cad5b5748b7841852)

1491.	[build]		marcin
	Bumped up libraries version numbers for Kea 1.5.0 beta2 release.
	Also, generated logger message files are now installed with Kea.
	(Gitlab #62,!144, git 7dc8d73a58504fd81a49b1c54651388d53d98d53)

1490.	[bug]		marcin
	Applied fixes in Cassandra Host Manager which prevents Kea
	crash during an attempt to delete non-existing reservation.
	In particular, this crash was observed as a result of sending
	reservation-del command over RESTful API.
	(Gitlab #27,!138, git 8666ed4754ffd27f3aa46a2cf3e4b161a1d877ee)

1489.	[doc]		fdupont
	Added examples of global host reservations.
	(Gitlab #136, !143, git bee8b8620f849f6bcaf2b31c3b130bb371c6312c)

1488.	[doc]		marcin
	Added stat_cmds to the list of available hooks libraries.
	(Gitlab #85,!142, git 08615372b4f869fe61b13559efa33d0d9794d79b)

1487.	[doc]		marcin
	Corrected broken links and various typos in Kea documentation
	which had been identified during Kea 1.5.0 beta1 release
	process.
	(Gitlab #263,!137, git 79a224288efa1e1c51b0f2ec11ff646563b306e1)

1486.	[func]		tmark
	For Kea 1.5.0-beta2, congestion handling has been enabled by
	default. This was done to expose the feature to more testing.
	We will finalize the default setting prior to releasing Kea 1.5.0.
	(Gitlab #276,!132, git fda1f985997412a58d3b4eee4a1ca0588d3f3beb)

1485.	[func]		fdupont
	Simplified and updated Kea YANG models. For instance the list of
	loggers was moved from the removed logging container to global
	config parameters.
	(Gitlab #204, !97, git 1de6c2987ec9067b7c1baa577c6dcd6ddd1b30fb)

1484.	[bug]		marcin
	Resolved issues with MySQL backend failing to insert a lease
	to the MariaDB database on OpenSUSE. This fix may also
	improve stability of the MySQL backend on other systems running
	MariaDB.
	(Gitlab #53,!125, git 038eddbc7b904289e4b74b5ef2406cb57f79a646)

1483.	[func]		tmark
	Use of congestion handling is now optional via the 'enable-queue'
	flag added to 'dhcp-queue-control'.  It is disabled by default.
	When disabled Kea's DHCPv4 and DHCPv6 servers will consume packets
	directly from interface sockets in the main thread (i.e. employs
	pre Kea 1.5 technique).
	(Gitlab #260, !120, git 9e304fae48d0d0658fd39a21aba9da528b4cc6f4)

1482.	[func]		fdupont
	The configuration parameter "reservation-mode" can be specified
	at global (new), subnet and shared network levels.
	(Gitlab #268,!126, git c72d381c39868308c7d11c7d4def3bdae0a0e04e)

1481.	[func]		fdupont
	Cleaned up the keatest-module YANG test module.
	(Gitlab #204,!98, git a830adcefd9306969216d35c51306df3610278bb)

1480.	[func]		fdupont
	The unused configuration parameter "always-include-fqdn"
	was removed. Configurations using it will be rejected as
	it is no longer recognized.
	(Gitlab #182,!128, git cafeba167e7c64370dd39eca4551f61acd89d3da)

1479.	[build]		fdupont
	Support for sysrepo 0.7.6 (and libyang 0.16-r2) was added.
	Previous versions of sysrepo (and libyang) are still supported.
	(Gitlab #176, !107, git 4304a10b21708afb2a7599c77bc7508a600333cb)

1478.	[bug]		marcin
	Performance improvements in the HTTP client code used in the
	Kea High Availability.
	(Gitlab #57,!122, git 7bd97af1f3d7670cd64cadf0d0cb9ddbe4e74909)

Kea 1.5.0-beta1 released on Nov 9, 2018

1477.	[build]		marcin
	Bumped up libraries version numbers for Kea 1.5.0 beta release.
	(Gitlab #261,!119, git 54d63139048e7fe2dd0384b547ed6f8b96ff0e8f)

1476.	[func]		tmark
	Added initial implementation of congestion handling to kea-dhcp4
	and kea-dhcpt6. This adds a new top level element to the server
	configurations, "dhcp-queue-control".  Both servers will now
	read client packets from interface sockets in a separate thread
	queueing them for server level processing.  For Kea 1.5-Beta
	this feature is always on.
	(Gitlab #42, !103, git 09d5ffebc8f9bfab2ab99c384eec9c3a3c915f39)

1475.	[func]		sebschrader
	Add authoritative feature for DHCPv4 from ISC DHCP: requests from
	unknown clients are dropped (default/previous behavior) or
	answered with DHCPNAK (new behevior with new authoritative flag
	set to true for the subnet). Patch proposed by Sebastian Schrader.
	(Gitlab #66, !115, git 0fc1b767826f214475025d8631227970de368de5)

1474.	[doc]		godfryd
	Updated list of supported operating systems.
	(Gitlab #205, !109, git 73253af554cf48434798282f8440a99b1494fd04)

1473.	[doc]		tomek
	Outdated FAQ section removed from the User's Guide.
	(Gitlab #118, !113, git 7d079384bd5f49e0e36a571ee964bfd7d6ebd25d)

1472.	[bug]		marcin
	Timeout is now reported by the HTTP client when connecting to the server
	takes too long. This eliminates HTTP client hangs when firewall is
	misconfigured and causes connection to never be established. This issue
	was found during Kea High Availability testing.
	(Gitlab #26,!106, git 9724823f160af0ef5e8ccdf779087ff08a04457a)

1471.	[bug]		lmasarati
	Fixed a bug in kea-admin that ignored specified remote hostname.
	Thank you to lmasarati and Thorsten Krohn for reporting it and
	proposing a patch!
	(Gitlab #61, #138, !114, git 901cac7dc85ad8dacf631bf3a5c266eefeb3e6a1)

1470.	[func]		marcin
	Improved lease database synchronization mechanisms in High
	Availability hooks library. The new implementation uses
	lease4-get-page and lease6-get-page commands to fetch leases
	from the partner server. This prevents timeouts occurring
	during long synchronizations as well as decreases CPU and
	memory consumption on the HA enabled servers during lease
	database synchronization.
	(Gitlab #78,!85, git c54ea216463dcc6df693c96c4a5f82c0fbec2ff6)

1469.	[doc]		marcin, fdupont
	Documented new class_cmds premium library which is used
	to modify client class configuration of the DHCP servers.
	(Gitlab #64,!41, git c1c1d0b71496d81b330a8c1eb95996bbf634ada0)

1468.	[build]		wlodek
	make distcheck fix.
	(Gitlab #202, !111, git 5d8fb5f7af5fa36f4cb2b89f10631683b2e230d5)

1467.	[doc]		fdupont, tomek
	Doxygen errors fixed.
	(Gitlab #180,!93, git d12fb04d71c3b2d0e84ebb2c957334454b5705c4)

1466.	[func]		fdupont
	Added random number generation in services provided by
	the crypto library (and ultimately by the crypto backend,
	i.e. Botan or OpenSSL).
	(Gitlab #29,!9, git 609ddc69613dc828b3d93673d61a2c259c3944aa)

1465.	[build]		marcin
	Removed libkea-process dependency on MySQL, Postgres and
	Cassandra libraries.
	(Gitlab #194,!104, git bcce7d3c2226c10218d537c4688344c3b7f8c84a)

1464.	[build]		marcin
	Exclude mysql_cb hooks library from the Kea 1.5.0 release. This
	library will be added back in Kea 1.6.0 release.
	(Gitlab #93,!105, git 49572aa300ea2b25712d7e8cea0dd0df34faf7ee)

1463.	[bug]		tmark
	Added missing parsing logic for the reservation-mode value,
	"global", to kea-dhcp6.  The parsing logic was somehow omitted
	and caused kea-dhcp6 configuration parsing to fail on values
	of "global".
	(Gitlab #129,!55, git 00352d701f61274f0993b468a413af6c5623af3d)

1462.	[build,doc]	tomek,sgoldlust,vicky
	Kea REST API is now documented. Thanks to Suzanne Goldlust for
	providing descriptions for great majority of commands and to
	Vicky Risk for review and corrections. Also, docgen, a new
	tool for documentation generation has been written.
	(Gitlab #10,!3, git 5d2e4d6fcc182a19eafa895abc35b1aee599fd23)

1461.	[doc]		marcin, fdupont
	Added new sample configurations providing all parameters at
	the exception of host reservations for DHCPv4 and DHCPv6 servers
	for testing of configuration managers.
	(Gitlab #130,!89, git 4bc7e0dbe4804f63c51d100a8f724327e3d3a936)

1460.	[func]		tmark
	While kea-dhcp4 and kea-dhcp6 configuration parsing supports
	configuration backend elements "server-tag" and "config-control",
	use of these parameters has been disabled. Development of this
	feature will resume after Kea 1.5 release.
	(Gitlab #101,!87, git 4292a7ef7ab268826f846812e7320e1fe1fc46ef)

1459.	[func]		marcin
	Implemented libdhcp_mysql_cb hooks library which provides
	Configuration Backend functionality for MySQL.
	(Gitlab #93, git 98456608056b3361352b3127767138845eeb5d00)

1458.	[func]		fdupont
	Control sockets for kea-netconf has been implemented. The code is
	not functional yet, but the capability of the kea-netconf daemon
	to communicate with CA, D2, DHCPv4 and DHCPv6 daemons is there.
	(Gitlab #153,!60, git 11486e255aef704114645f8e7c5fee9c3abf9e76)

1457.	[func]		tmark
	Both kea-dhcp4 and kea-dhcp6 configuration parsing support new,
	server-level configuration elements "server-tag" and "config-control".
	While these elements will parse, they are not yet used by the servers.
	(Gitlab #32,!23, git c0727407da8d749d9fb51d873a725369800c967b)

1456.	[build]		tomek
	Extended Kea version is now stored in a separate file for
	build performance reasons.
	(Gitlab #137,!42, git 87479e979ca3d3025cb4129ace991a59e32e0f62)

1455.	[func]		fdupont
	Implemented hexstring(value, separator) operator that can be used
	in any expression, such as client classification, flex-id or
	RADIUS attribute.
	(Gitlab #67,!34, git 004d9a29db09b1c203c52e23585bd275c52095fa)

1454.	[func]		fdupont
	Unused interface-id and rapid-commit parameters removed from
	DHCPv4 parser.
	(Gitlab #116,!24, git 7e47292f10acb9179241c991d3591e9bfa47c37d)

1453.	[func]		marcin
	Updated MySQL schema to facilitate Kea Configuration Backend
	feature.
	(Gitlab #89,!22, git e28c0c7b3e7a7729167cdad993f634ed1f0ac53b)

1452.	[func]		marcin
	Implemented libkea-cb library which includes basic class
	hierarchy for the Kea Configuration Backend.
	(Gitlab #28,!20, git fb5c031ecaf4182e56f62874e9a6bd4c1d755a77)

1451.	[build]		tmark
	Resolved a namespace issue with std::distance() in libdhcp++.cc
	when building with Boost 1.68.   Thanks to Huy Vu and Khem Raj
	for reporting and suggesting a fix.
	(Gitlab #109,!21, git 1fd301f998129e9926ffa35eac27768ae150633d)

1450.	[build]		tomek
	Dependencies improved. libkea-process no longer requires libkea-dhcpsrv.
	As a result, D2 and CA are no longer linked with libkea-dhcpsrv.
	(Gitlab #25,!14, git cdb3a6f2d98a303b80433df7e0d5698c77897b7f)

1449.	[func]		tmark
	Modified Kea 1.5.0 database upgrade scripts to convert
	subnet ID values of 0, to either null (MySQL and Postgres)
	or 0xFFFFFFFF (CQL), in existing host reservations. This
	is done to accommodate support for global host reservations.
	(Gitlab #15,!11, git 25b54fd9ced4c6d3a2c8ceff9cc7c866b56da2c1)

1448.	[build]*	marcin
	Created new Kea libraries: libkea-database, libkea-mysql,
	libkea-pgsql and libkea-cql. Some database specific code was
	moved from libkea-dhcpsrv to those new libraries.
	(Gitlab #92,!13, git 5feb6b8a53675c27715e9e8fbeb312bd6eb17547)

1447.	[doc]		tmark
	Updated Kea Administrators's Guide with discussions of the
	use of subnet ID parameters in hook library commands.
	(Gitlab #14,!15	git# 4a7da8069feab1e21132689a9368f8ccb4174683)

1446.	[func]		tmark
	kea-dhcp6 now supports global host reservations and a new
	global reservations-mode .  Prior to this reservations could
	only be specified per subnet.  This is supported by by Memfile,
	MySQL, PostgreSQL, and Cassandra host data sources.
	(Gitlab #13,!6, git# a5484c4d8852662be7da1e6e8b1d4c1a19e6502f)

1445.	[func]		tomek
	Implemented initial skeleton version of the kea-netconf tool.
	Currently it can't do anything, but the build system is now
	capable of detecting sysrepo (use --with-sysrepo in configure),
	there's a very basic documentation and unit-tests.
	(gitlab !1, git 89ff2093811d65220d99dc2a6516375c4ec953dc)

1444.	[bug]		tomek
	keactrl version tests now work properly on macOS.
	(Gitlab !5, git a8c385e1507ffd101f65b445783b0355b01decce)

1443.	[func]		tmark
	kea-dhcp4 now supports global host reservations and a new
	global reservations-mode .  Prior to this reservations could
	only be specified per subnet.  This is supported by by Memfile,
	MySQL,PostgreSQL,and Cassandra host data sources.
	(Trac #5705, git f991cffd06add941f8bf2937232f51d597623e21)

1442.   [func]		MayyaSunil
	Implemented new queries for IPv6 leases by DUID.
	(Github #99, git c20b5248da1283e596e35ad057ae242f4d613965)

1441.	[func]		marcin
	Added log message indicating that the control socket has been
	opened by a server.
	(Gitlab #8, git 3dbaf4917bea112466f1ee5726870c545950e114)

1440.	[func]		tmark
	The internal representation of an "unused" subnet-id has been
	changed from zero to 0xFFFFFFFF. The largest, valid value for
	a subnet's ID is now 0xFFFFFFFE.  Three new constants have been
	added so subnet_id.h:

	isc::dhcp::SUBNET_ID_GLOBAL
	isc::dhcp::SUBNET_ID_UNUSED
	isc::dhcp::SUBNET_ID_MAX

	which should be used in code/hooks in place of hard-coded values.
	(Trac #5704, git 90fe9ca2cd6f63bcc7168bdc3786677db57b65ec)

1439.	[func]		tomek
	keactrl and kea-admin tools can now report version.
	(Gitlab #9, git 4a00ab5d4b9ac9193fc5f924149aeaca7a88e2ef)

1438.	[func]		tomek
	subnet-id parameter is now optional in lease4-add, lease6-add,
	lease4-update and lease6-update commands. If not specified or
	its value is zero, Kea will attempt to figure out the correct
	value of subnet-id. If there is no matching subnet configured,
	the lease will be rejected.
	(Trac #5683, git a8ce7a78b5b294e6bce02de887552a1e4593db4e)

1437.	[func]		tomek
	DHCPv4 and DHCPv6 servers are now able to sanity check and
	possibly correct some inconsistencies in leases when loaded from
	disk (memfile). A new parameter to govern this behavior has been
	added.
	(Trac #5682, git 609bfa0a67caa91fac6834eb39260acfd19e3be4)

1436.   [func]      tmark
	Added two new configuration parameters to kea-dhcp4 and kea-dhcp6
	DhcpDdns sections: 'hostname-char-set' and 'hostname-char-replacment'.
	These values (when not empty) are used by the server to sanitize
	host name and FQDN domain names sent by clients prior to using them
	to construct DNS names.
	(Trac #5680, git 32466ab3d4688e66c8c2f9fd24d4a98fcc871ff6)

1435.	[func]		marcin
	Implemented ha-continue command in HA hooks library and
	updated the Kea User's Guide with the information how to
	pause and resume the HA state machine.
	(Trac #5675, git 98a9bd4f6766ff2f53681d84d55c56988be4d501)

1434.   [func]      MayyaSunil
	Code added to support storage of Authentication key host reservation.
	There is no way to use the code yet.
	(Github #88, git 66602af46b1a7d9f4197b1f285c928bd9f80ba2b)

1433.	[func]		marcin
	Implemented state HA state machine pausing in the high
	availability hooks library.
	(Trac #5674, git b9f3f082c7a88fe98fa4545b9649193ceb5e3ef5)

1432.	[func]		MayyaSunil
	Code added to handle Authentication option in DHCPv6. There
	is no way to use this code yet.
	(Github #93, git 022dae4393da9e714678d52886d4f478ba308ba9)

1431.	[func]		marcin
	Implemented lease4-get-page and lease6-get-page commands
	in lease_cmds hooks library.
	(Trac #5651, git b056828212f7b206ff8bd07c097fd6f427d22d71)

1430.	[func] 		fdupont
	Lease objects and lease backends are now able to store user
        context. User context can store an arbitrary data as long
        as it is in JSON format. Database schemas updated.
	(Trac #5584, git b0b7a198b99fd417466708c80cb7cc2162ae480c)

1429.	[bug]		marcin
	Removed memory leak in the DHCPv4 and DHCPv6 servers which
	occurred when hooks libraries where loaded.
	(Trac #5664, git 2584b902d2617089bfa7238133490ddd855aa77a)

1428.	[bug]		marcin
	Corrected behavior of the standby server in the HA hot-standby
	mode, which failed to monitor delays in responses to the
	DHCP queries sent to the primary server after the primary
	server became unavailable. This resulted in transition of
	the standby server to the partner-down state immediately
	after detecting interruption in communication with the
	primary over the control channel.
	(Trac #5654, git 7a83f05fe40fb1b6812b055e2d6d633d9e00160c)

Kea 1.4.0 released on June 15, 2018

1427.	[bug]		marcin
	Resolved multiple problems causing slow synchronization of
	leases in the HA hooks library, including adjusting
	timeouts in control channel and improving performance of
	responses sent by the Command Manager to Control Agent.
	Also, introduced 'sync-timeout' configuration parameter
	into HA hooks library to control lease database
	synchronization timeout.
	(Trac #5649, git cbc29128863916a13364749bf681586aea2aa51e)

1426.	[func]		fdupont
	Added KNOWN and UNKNOWN built-in client classes: after host lookup
	if a matching host entry is found the incoming packet is added to
	the KNOWN class, if none is found to the UNKNOWN class. Then
	expressions depending directly or indirectly on these classes are
	evaluated. Note these classes may be used to select a pool but
	they may not to select a subnet.
	(Trac #5549, git 6a856ed9722b918a65dca15ff44314e28897784e)

1425.	[bug]		marcin
	Improved performance of the DHCP server running in High
	Availability configuration by optimizing the management of
	CalloutHandle objects passed to the callouts.
	(Trac #5647, git eea88d5c8f4d8efb6c5bfdfbf4e070a90069db5d)

1424.	[doc]		marcin
	List of hooks libraries provided by ISC includes an
	information which Kea servers the libraries can be attached
	to. The detailed description of each supported hooks library
	also contains this information.
	(Trac #5613, git 9d6f8de3d988c42c413a7d628e31854e9c80d8c9)

1423.	[bug]		tmark
	kea-dhcp4 and kea-dhcp6 now retain and emit global, scalar
	parameters specified in their configuration.
	(Trac #5378, git 4d05122f03d00b10a888c768fe1725cae9d6aea6)

1422.	[build]		fdupont
	Commented out BOOST_ASIO_DISABLE_THREADS in configure to reflect
	the current use of threads by boost ASIO in Kea.
	(Trac #5615, git f3fc8b1a4257a42a97aaf88a36287bbe33d1f65b)

1421.	[build]		marcin
	Moved libdhcp_ha (High Availability) hooks library from
	premium to main Kea repository and changed its license to
	MPLv2.0. Future ChangeLog entries for this library will be
	tracked in the Kea ChangeLog file.
	(Trac #5645, git 19b2553d4869bdd52b63b6f7969052d8a724f78d)

1420.	[doc]		marcin
	Updated list of loggers in the Kea Administrator's Manual.
	The updated list contains all loggers, including those
	from supported hooks libraries.
	(Trac #5622, git bd94afc0af7183452c94f3b5768c6138f79d3b60)

1419.	[doc]		marcin
	Documented "sync-leases" configuration parameter of the HA
	hooks library in the Kea Administrator's Manual.
	(Trac #5621, git 4ebac3a411aa02d1cc3d74e7eaf3212ad208159a)

1418.	[bug]		marcin
	Corrected bug in the allocation engine which caused occasional
	lease allocation failures when a loaded hooks library set the
	callout status to non default value, e.g. "skip" rather than
	"continue". In such cases, the server reported that it failed
	to allocate a lease "after 0 attempts".
	(Trac #5638, git f2e9b686ae52e1b06f660e1b522588b1440e2620)

1417.	[bug]		marcin
	Improved logging in the HTTP library both for the server and
	the client.
	(Trac #5205, git fd0bec610c89084d5a5d43ef032c9875c3e6ad46)

1416.	[bug]		fdupont
	Added support of recent Botan 2.x crypto backend.
	Note that Botan 1.[9-11] is still supported but not recommended.
	(Trac #5382, git 22651b1935a2397edfbddb9b8873c353c090f18e)

1415.	[bug]		tmark
	kea-dhcp4 and kea-dhcp6 now validate the schema version
	of lease and host back ends after establishing a connection.
	If a schema version does not match the version the server
	expects, the server will emit an error log and close
	the connection. This applies to MySQL, PostgreSQL, and Cassandra.
	(Trac #5629, git 15c34afdba45be609e35284a209ad18ed66605f8)

1414.	[bug]		tmark
	kea-dhcp4 parsing now treats renew-timer and rebind-timer
	as optional with no defaults. The logic for sending them
	to the client was changed to: send rebind-timer only
	when it is less than the lease lifetime; and send renew-timer
	only when it less than either the rebind-timer if specified,
	or lease lifetime in the absence of rebind-timer.
	(Trac #5596, git 38426e16ec04a786e35a65d27cbcb7dbabfe79b5)

1413.	[func]		fdupont
	Removed getAll, get4 and get6 methods using both hardware address
	and DUID from host backend (aka host data source) APIs.
	This is an *incompatible* change.
	(Trac #5563, git db4c34b069f114f93d9f29cdeb02b536a0fbc982)

1412.	[func]*		marcin
	The client classes used by the High Availability hook library
	use upper case "HA_" prefix and they are now built-in classes.
	This means that those classes do not need to be	declared in the
	server configuration.
	(Trac #5632, git 2d590bfd7d1b0eca377eb99eef83a3083a1d7399)

1411.	[bug]		fdupont
	Fixed warnings about lambda's not using captured variables.
	(Trac #5591, git f88a505823d39faec7dc5f647f40e6454e5dfc74)

1410.	[bug]		marcin
	Fixed multiple hanging Control Agent unittests.
	(Trac #5576, git 310af68101cba74220652ec2b403520fc5666dc0)

1409.	[doc]		marcin
	Documented in the User's Guide how Kea HA service behaves
	when the clock skew between active servers becomes too
	high.
	(Trac #5603, git ffaff4d2a03600bb4f81d335b49a840e31d03c8c)

1408.	[func]		tomek
	perfdhcp now supports -o option that adds DHCP options.
	This may be used to simulate various clients.
	(Github #77, git b81dedb7f0a2516130e7bd799d9084c63f0e844c)

1407.	[bug]		tmark
	Corrected an issue where the destruction of loggers
	prior to the destruction of the TimerMgr singleton
	caused unit tests to segfault.
	(Trac #5626, git 9f4e3f9cd8acf8e7d1d3e714d8f904754377c00f)

1406.	[func]		fdupont
	Added pkg-config alternative to configure --with-cql path so
	now you can use either pkg-config or cql_config.
	(Trac #5488, git 55498ca3455517132533a39002ebfc05d26c7e38)

1405.	[bug]		tmark
	Corrected missing "override" warning in cql_lease_mgr.h
	(Trac #5625, git df3068ba0e520df4d96dd38e2de679beb99f2e23)

Kea 1.4.0-beta released on May 18, 2018

1404.	[doc]		tomek
	Hooks package installation intruction added to Kea
	User's Guide.
	(Trac #5427, git 7bc5e4297e8b2ccb87d5d5d79ae066fe32964841)

1403.	[build]		tomek
	Support for hook packages has been updated. The --with-tierX
	flags have been removed. Each hook library is now detected
	independently.
	(Trac #5619, git aa1f95d699dc664a5660db120ef71edee910a9b3)

1402.	[bug]		tomek
	Fixed a crash that was caused by hook library registering
	new hook points. This fixes unit-tests with forensic
	logging, but the problem was generic and could cause
	other libraries to segfault during unloading or reconfiguration.
	(Trac #5577, git 2f9d1aa95c16e12fabc50d581b966f20b6d8a950)

1401.	[bug]		tmark
	Corrected an issue which caused kea-dhcp4 and kea-dhcp6 servers
	to unload their hooks libraries upon receipt of the first client
	message following a dynamic reconfigure.
	(Trac #5564, git 5111f569bd251c2a98a2e6d958e8f6b640a1802d)

1400.   [func]		tmark
	A new hooks library, Stat Cmds, has been added to the open source
	distribution.  This library provides commands for fetching lease
	allocation statistics using lease backend as the source for
	lease counts per state.  This resolves an issue in deployments,
	where multiple Kea servers share a common lease backend, which made
	it difficult to obtain accurate lease statistics.
	(Trac #5589, git 36f20f1c8b28f629fe2896b817ac0f3c6026fe0e)

1399.	[func]		tmark
	Support for fetching lease allocation statistics by subnet-id
	or subnet-id range has been added to the Cassandra back end. This
	allows it to be used in conjunction with the Stat Cmds hooks
	library commands for fetching shared lease statistics.
	(Trac #5588, git 3fcfefdea5ac838936c2109ecbbbc32eabc8fdba)

1398.	[bug]		fdupont
	Fixed bug in configurations where "outbound-interface" parameter
	was set to "use-routing", which in some cases would reset outbound
	interface index to a negative value and cause the server to fail
	to respond to the clients.
	(Trac #5515, git 9d8d00f1f127ee606f09f7ff6006f0d142aac976)

1397.	[bug]		marcin
	A bug in http client library was fixed. The IPv6 address specified
	in brackets is now supported properly.
	(Trac #5620, git fe38c4368853e47bc993d6c3844cdddba5effde5)

1396.	[bug]		tmark
	The PostgreSQL schema was expanded to include two new tables:
	lease4-stat and lease6-stat and triggers to update them as leases
	are modified. This resolves an issue in deployments, where multiple
	Kea servers share a common PostgreSQL lease database, which made
	it difficult to obtain accurate lease statistics. Since these statistics
	are now tracked by the database, they do not have to be recalculated at
	startup or following reconfiguration. This may result in less
	processing overhead during these events. The new statistics will be
	accessible via a new Hooks library, being developed for Kea 1.4
	under #5589.
	(Trac #5587, git 36a0160de0df7789eea224954717be05c08638b7)

1395.	[bug]		tmark
	The MySQL schema was expanded to include two new tables:
	lease4-stat and lease6-stat and triggers to update them as leases
	are modified. This resolves an issue in deployments, where multiple
	Kea servers share a common MySQL lease database, which made it difficult
	to obtain accurate lease statistics. Since these statistics are now
	tracked by the database, they do not have to be recalculated at startup
	or following reconfiguration. This may result in less processing overhead
	during these events. The new statistics will be accessible via a new Hooks
	library, being developed for Kea 1.4 under #5589.
	(Trac #5586, git a070c327668c10de3b28f5e249f91d6d16a97ff5)

1394.	[doc]		marcin
	Documented High Availability hook library in the Kea
	Administrator Reference Manual.
	(Trac #5478, git 3db34400d0331e3d4fc208529eeb18f6abfb6562)

1393.	[build]		marcin
	Install new header files introduced since Kea 1.3 release.
	Also, bumped up libraries version numbers for Kea 1.4 beta
	release.
	(Trac #5590, git 64351229a30832735c5a81ac17ca1521aa2483b2)

1392.	[func]		fdupont, marcin
	Implemented new hook point "leases6_committed" in the DHCPv6
	server. It supports new next step status NEXT_STEP_PARK
	which causes the server	to "park" the client's DHCP packet.
	(Trac #5458, git 04d6fb0a0ac5b9dff2a02764cc9265f9a2a05ae8)

1391.	[func]		tmark
	For both kea-dhcp4 and kea-dhcp6, the "ip-address" parameter
	in the "relay" element for both subnets and shared networks,
	has been replaced with a list form, "ip-addresses".  Configuration
	parsing will continue to honor the singular form, but it should
	be considered deprecated.  In addition, an omission in 1.3 that
	caused shared network parsing to ignore the "relay' element has
	been corrected.
	(Trac #5535, git f4601abdb657122a8ba5d7784eded773ec01d171)

1390.	[doc]		tomek
	User's Guide documentation for RADIUS and Host Cache written.
	(Trac #5538, git c73337a8ec691874b8ac0b2efcd8708f1a79acbb)

1389.	[func]		fdupont
	dhcp6_srv_configured hook point added.
	(Trac #5530, git 3bb521f6ec8b4e2a1e57ec84b17ee12b0ccf0f83)

1388.	[build]		tmark
	Modified configure script to support --with-dhcp-mysql and
	--with-dhcp-pgsql but emit a deprecation warning message
	encouraging their replacement with --with-mysql and --with-pgsql.
	(Trac #5567, git 53761069761ddde44636baa30185322debfe4186)

1387.	[func]		tmark
	perfdhcp no longer requires -r (rate) be specified in order to use
	-D<max-drop>, -n<num-request>, -p<test-period> and -t<report> options.
	(Trac #5115, git c3ba89c56882cac1080899ad201f0c02056eef38)

1386.	[func]		fdupont
	Extended comment / user-context support to DHCP-DDNS and
	Control Agent configuration syntax.
	(Trac #5495, git fe79959e3bc3c46ccb89661cb27696671a8508b8)

1385.	[func]		tomek
	lease4-wipe and lease6-wipe are now able to wipe all leases
	from all configured subnets if subnet-id specified is 0
	or the subnet-id parameter is omitted.
	(Trac #5543, git ecaf777dff4b8d1100c2a97c4fb1cf8f8e63566d)

1384.	[func]		fdupont
	Significant improvements to client classification introduced.
	The order of classes evaluation has changed from alphabetical
	to the order of appearance. New 'member' expression allows
	combination of classes. The new 'only-if-required' and
	'require-client-class' parameters controlling the scope of
	a class have been introduced.
	(Trac #5474, git 3f2d93f0731fc1858b20e831a7d1f090ea8841fe)

1383.	[func]		tmark
	kea-dhcp4 and kea-dhcp6 can now be configured to attempt to
	reconnect to MySQL backends if connectivity is lost.
	(Trac #5556, git b31da6f9a3545a2cac228eb17c59d72b6b4823f2)

1382.	[func]		fdupont
	Added support for generalized UDP Source Port for DHCP Relay
	(RFC 8357) for DHCPv4, DHCPv6 and DHCPv4-over-DHCPv6. Note
	this required changes to the inter-server protocol used by
	our 4o6 implementation, and is therefore not backward
	compatible.
	(Trac #5404, git 2a6049947ad4caaaa697dba8cb7669a09264f0bc)

1381.	[bug]		marcin
	Corrected a bug in the libkea-asiolink library which caused
	the DHCP servers to crash while processing commands over
	the unix domain socket on some systems.
	(Trac #5580, git cb5276a24436a9e9ce4d1ab4630e7193a4c2d803)

1380.	[func]		fdupont
	Implemented lease6-get-all command in lease_cmds hooks library.
	(Trac #5469, git a0bb7188df47a0f8020ff57739c5a6ab5f7e9828)

1379.	[func, bug]	marcin
	The network_state argument is provided to the callouts in
	the dhcp4_srv_configured hook point. Also, fixed a couple
	of minor bugs in the HTTP client classes.
	(Trac #5470, git 93e2b2198c3163afb81d51fdf5ec547602a12415)

1378.	[doc]		tomek
	New parameter subnets-action for network4-del and network6-del
	commands is now documented.
	(Trac #5441, git 8b2ffabb3d1ba709f319df2b34d0804ee824446b)

1377.	[doc]		tomek
	New parameters for Cassandra are now documented.
	(Trac #5484, git 56e7026ea2bfab99dbfa1a047dc920ec2f743540)

1376.	[func]		razvan
	Cassandra backend improvements: get all IPv4 leases, delete
	hosts, ability to store fixed DHCPv4 fields (next-server,
	server-hostname, boot-file-name) and user contexts in host
	reservations. Also, the ability to store MAC address details
        in DHCPv6 leases on PostgreSQL has been improved.
	(Github #70, git 8cd0c1ae416be88baf69c2243e83a429d6d5c965)
	(Trac #5506, git 8cd0c1ae416be88baf69c2243e83a429d6d5c965)
	(Trac #5507, git 8cd0c1ae416be88baf69c2243e83a429d6d5c965)
	(Trac #5508, git 8cd0c1ae416be88baf69c2243e83a429d6d5c965)
	(Trac #4530, git 8cd0c1ae416be88baf69c2243e83a429d6d5c965)

1375.	[func]		tmark
	When encountering errors unpacking vendor specific options,
	both kea-dhcp4 and kea-dhcp6 will now log the error, skip
	unpacking any remaining options, and then attempt to process
	the packet as is.  Prior to this the servers would log the issue
	and then drop the packet.
	(Trac #5551, git 59ef33ee17672c55cee4ec86ff59737b361a3c21)

1374.	[func]		tmark
	kea-dhp4 and kea-dhcp6 can now be configured to attempt to
	reconnect to Postgresql backends if connectivity is lost.
	(Trac #5477, git 8e62a058382b2245d418cfbf829776934c638e5e)

1373.	[func]		marcin
	Implemented leases parsing from JSON in libkea-dhcpsrv.
	(Trac #5466, git 84c2a2084b0fb7c086fc6b9502f7ff58b708174e)

1372.	[func]		marcin
	Implemented new hook points "dhcp4_srv_configured" and
	"leases4_committed" in the DHCPv4 server. The latter supports
	new next step status NEXT_STEP_PARK which causes the server
	to "park" the client's DHCP packet.
	(Trac #5457, git af43f07b0e227ccabcdf07a046a64cebb11bdccf)

1371.	[bug]		fdupont
	Fixed a bug in JSONfeed tool which did not correctly handle
	strings and interpret their content.
	(Trac #5513, git 231e923a85db7fb8305c7baa4d15f766fdf60942)

1370.	[bug]		tmark
	Fixed a bug which prevented inserting multiple host reservations
	where IPv4 address was unspecified or when selected subnet identifier
	was not specified (5416).  Corrected inconsistent data types for
	subnet id columns in both Postgres and MySQL schemas.  Now both
	schemas support up to MAX UINT32 in all subnet id columns. Exiting
	databases may be updated without data migration.
	(Trac #5416, #5522, git d1dd0f2e27ffa49515c17cf68d54f162359b6384)

1369.	[bug]		marcin
	Multiple critical performance optimizations in the allocation
	engine for shared networks.
	(Trac #5437, git 9d8bcd39802795d48c737a05ef3de3634a28ca4e)

1368.	[func]		tmark
	kea-dhcp4 now explicitly logs packets dropped due to a lack
	message type as a log type DHCP4_PACKET_DROP_0009.  Prior
	to this such packets were logged has having an unsupported
	message type of 0.
	(Trac #5553, git ff97e5ffb5f3478be71aae8130b6eff3208bd69a)

1367.	[func]		fdupont
	Added initial skeleton implementation for Radius hook library.
	(Trac #5524, git 832aa23b89eab71875bcbdb1e955eb92fdc0e01a)

1366.	[func]		fdupont
	Implemented FNV hashing function. Cassandra backend no longer
	explicitly depends on OpenSSL.
	(Trac #5502, git 71de75c3bb099f21fdef0d41806da281d6271287)

1365.	[func]		fdupont
	Both DHCPv4 and DHCPv6 servers can now listen on loopback
	interfaces. This capability requires setting socket type to UDP in
	DHCPv4. Note the feature has not been thoroughly tested.
	(Trac #5390, git f38cbd73581a7a0f8634a63cb17f9b60407e3acc)

1364.	[func]		fdupont
	Extended forensic (aka legal) logging with database capability.
	(Trac #5420, git 94bd3cc313e9f2a982ef8f8adf0cf44024c76499)

1363.	[func]		tmark
	Added support for automatically recalculating lease statistics
	to the CQL backend.
	(Trac #5487, git c807388d581ee1c3e479324f3c399f27feba1c96)

1362.	[func]		razvan, andrei
	A new parameter exit-wait-time has been added to perfdhcp. It is
	now possible to tell perfdhcp to wait certain amount of time after
	exit conditions are met before actually terminating.
	(Github #55, git 0cd1178ae092fa0c2f122d0e16fb673b4074a6e6)

1361.	[func]		razvan, andrei, tomek
	Support for Google Benchmark has been added. To compile
	benchmarking support, please use --with-benchmark option.
	(Github #36, git d6819971410b460d7742c762844e2e75ba580944)

1360.	[build,bug]	fdupont
	Cassandra build fixes for macOS.
	(Trac #5494, git cb0d735628aefd6bca2acc11b73d1f66b45d1c40)

1359.	[bug]		rcgoodfellow
	Fixed bug in kea-admin causing error on lease-dump.
	(Github #61, git 2c9454ec56edc8f3cff8a23329f53ced0d172280)

1358.	[func]		andreipavelQ,tomek
	The logging configuration is now applied early, which helps
	seeing errors in case the new configuration is faulty.
	(Github #41, git d77fbec5a003a69cab207aa741133015f2657878)

1357.	[build]		andreipavelQ
	--with-dhcp-mysql renamed to --with-mysql and
	--with-dhcp-pgsql renamed to --with-pgsql. These names were
	leftovers from old BIND10 times when Kea was part of bigger
	solution that also provided DNS services. Kea is now a stand-alone
	software, thus the -dhcp- doesn't make sense in those options any
	more.
	(Github #40, git 318c9e3d3db9bb938ced27932d8401172529a2ff)

1356.	[doc]		andreipavelQ
	Documentation has been upgraded to DocBook 5.0.
	(Github #39, git 9b6705bd6c534128ec18820ff0cbdd72b7fce9e9)

1355.	[func]		tomek
	Lightweight 4over6 options reinstantiated. Definitions for DHCPv6
	options 89 through 96 were added back. DHCPv4 v4 Parameters Option
        159 has its definition tweaked slightly.
	(Trac #5514, git 6a4aac2b3bfffe41460db6d1cd3c55b1430aa50c)

1354.	[build]		andrei
	Support for coverage tests has been improved.
	(Github #43, git 1949bb3abf71fb3997044d239eb683095166c39f)

1353.	[build,bug]	andrei, razvan
	Various small changes and bugfixes. Thank you to Andrei Pavel
	and Razvan Becheriu for submitting their patch.
	(Github #54, git 2efa7494228a1797dff8d9d74107a452c61e2386)

1352.	[func]		fdupont
	It is now possible to specify client classification restrictions
	on per pool basis. This capability will be useful for grouping
	certain types of devices into specific address and/or prefix
	pools.
	(Trac #5425, git 5f3a89d6e32e90cd9cbb2347c7b2208c3e1561e0)

1351.	[build]		andreipavelQ
	Compilation parameters unified (every file now includes config.h,
	several makefile tweaks).
	(Github #38, git 7206aa79c57be7466c4ab3dd558663c6c4f858b7)

1350.	[func]		fdupont
	Several hook points now support next step status DROP. This allows
	more flexibility with dropping packets from within hooks.
	(Trac #5443, git ff22a906915a34df327174f550f69a396a05bb2c)

1349.	[func]		marcin
	Implemented HTTP client classes in libkea-http.
	(Trac #5451, git 94267e252b372650e4235389251b49d6f5501322)

1348.	[build]		fdupont
	Modified configure.ac to include premium module m4 macros, if the
	module is present. Prior to this it relied on premium having it's
	own configure.ac script.
	(Trac #5400, git 38c4f2fb8fc8c8874a0e4671cc295a049acf675f)

1347.	[build]		fdupont
	Added support of boost 1.66.0 ASIO.
	(Github #60/Trac #5496, git bc2947de4296bd99b74e50e65f272c7ad5312429)

1346.	[func]		marcin
	Implemented lease4-get-all command in lease_cmds hooks library.
	(Trac #5468, git a378ec28489e98df64830d1f26c3bebd20e256b2)

1345.	[func]		marcin
	Implemented "force-create" parameter for lease4-update and
	lease6-update commands.
	(Trac #5472, git 369245e4c5308a701fd483123f2cb2fd7d3d0966)

1344.	[func]		andrei, razvan
	Support for host reservations stored in Cassandra added. The core
	functionality was added. There are some limitations (delete,
	client classes, fixed DHCPv4 fields, statistics recount, etc.)
	These will be addressed in upcoming tickets.
	(Github #37, git e37606fd2d0c02234a55f7445c52a12b2e7a82ec)

1343.	[func]		fdupont
	User-context and comments are now supported in many new scopes:
	global, shared-network, subnet, pool, host reservation, option,
	option definition, client-class, control-socket, dhcp-ddns,
	interfaces, loggers, and for DHCPv6 pd-pool and server-id.
	(Trac #5351, git 3405a8fa5d391d96cd15874fd3de3ac63ceb33b6)

1342.	[bug]		fdupont
	Fixed subnets and host reservations returned by config-get and
	config-write.
	(Trac #5452, git c24d057bed2692eaf3cdb6af889122eb582ffede)

1341.	[func]		razvan, andrei
	Significant update of Cassandra support. A lot of code for
	Cassandra Lease Manager has been updated and partially rewritten.
	(Github #35, git 41795494720cd9886c1e98d21eaeefd94d674e37)

1340.	[func]		marcin
	Added support for "dhcp-enable" and "dhcp-disable" commands in
	the DHCPv4 and DHCPv6 server.
	(Trac #5442, git 36dc68ff7aa8b3cfd265c4f982d10248590039bd)

1339.	[doc]		marcin
	Updated User's Guide describing how to selectively disable
	legal logging for a subnet.
	(Trac #5407, git 469080abd711f8e88a5133f76f4ab31a5549a858)

1338.	[func]		marcin
	Persistent HTTP/1.1 connections and HTTP/1.0 keep-alive
	are supported by RESTful API.
	(Trac #5448, git 05018f7cc0662d6956b9b7648646e0c17da948ba)

1337.	[doc]		marcin
	Added placeholder section for the libdhcp_ha hooks library.
	(Trac #5447, git d939b5b8bc4befb24daf863f2408d97493e4bfbf)

1336.	[bug]		marcin
	DHCPv6 server always sends prefixes with the lifetime of 0 for
	the prefix leases that should no longer be used, even if those
	prefixes are not included in the Renew/Rebind.
	(Trac #5403, git 91bb0855ff7ef86ff72b5a946ae716798d7bebc1)

1335.	[bug]		marcin
	Fixed a bug which prevented inserting multiple host reservations
	where IPv4 address was unspecified or when selected subnet
	identifier was not specified. This change affects both Postgres
	and MySQL backend.
	(Trac #5416, git 03fab8f7d5c2e8a5ea735b11ff75652aa31d791d)

Kea 1.3.0 released on October 27, 2017

1334.	[bug]		marcin
	Fixed a bug in the DHCPv6 server whereby a lease with zero
	lifetimes could be mistakenly included in the server's
	response.
	(Trac #5387, git 140e7239096c0d5b9fc82b2c9c461476bf9d5729)

1333.	[doc]		tmark
	Added a discussion of conflict resolution to the DHCP-DDNS chapter
	of the Kea admin guide.
	(Trac #5275, git ce3fe30524cdc21a9cabeafbdcb2fc3cd2e86cff)

1332.	[doc]		tomek
	Clarified list of supported options, added examples for using
	hex notation to specify option values.
	(Trac #5068, git c942586172a68a7fac09e366383d996ade7f3840)

1331.	[func]		marcin
	Default "lfc-interval" value is now set to 3600.
	(Trac #5341, git dd1af78a49bfb68b88e8215dde65e40a470af81c)

1330.	[bug]		fdupont
	The option length checks were relaxed for the V-I Vendor Class
	option.
	(Trac #5391, Github #57,
	 git 8c1ea6684a808e8d3af9ea7eccecd93adc801e8a)

1329.	[func]		marcin
	Added support for "client-id" identifier when querying for
	leases in the lease_cmds hooks library. Documentation
	updated accordingly.
	(Trac #5395, git aceafa67f4fbde55ed6724a7b7551ed251e4ee91)

1328.	[doc]		vicky
	Acknowledgements section updated.
	(Trac #5385, git fe0658896f3784cd8f59bd5158244d6975cfe4c1)

1327.	[build]		marcin
	Updated Kea libraries' version numbers and hooks version for
	the 1.3.0 release.
	(Trac #5375, git 70c0fc164c89716419b6ee42da3ca0d4be938a30)

1326.	[func]		fdupont
	server-hostname and boot-file-name are now allowed in global,
	subnet4 and shared network scopes in DHCPv4.
	(Trac #5277, git 5a2454ec063530867dca2c46a71e342ccd98a5bb)

1325.	[bug]		marcin
	Fixed a bug whereby a reserved address could be allocated to
	a different client when this client explicitly requested
	this address.
	(Trac #5393, git 0964c66d44516a04ec62c8e70be92f216fe3df5a)

1324.   [doc]           wlodek
	Added examples of configuration for iPXE boot with DHCPv6 Kea server
	(Trac #5356, git c68b9b381930d1e44fd5daa1b9d033035e32cff2)

1323.	[doc]		marcin
	Added new section to Kea Hooks Developer's Guide describing how
	to implement new control commands within hooks libraries.
	(Trac #5331, git b23f36ca4a410ba7bca7fd4a9f40c008c77e3c7c)

1322.	[build]		marcin
	Copy all header files from Kea libraries during "make install".
	(Trac #5372, git cb38d39a942351ec04a655a396dd7396ea20548b)

1321.	[doc]		marcin
	Better explained subnet selection within shared networks when
	client classification is in use.
	(Trac #5367, git 26b4d240c5a1ba73e5b61f45d5a832e52f6472dd)

1320.	[doc]		marcin
	Improved documentation of shared networks within Kea Administrator
	Reference Manual.
	(Trac #5381, git c4be6a71ed3705c182d7ba4417a06ed8fa59f2b5)

1319.	[func]		marcin
	Added support for DHCPv4 option 54 (dhcp-server-identifier).
	(Trac #5376, git aae2d91f101b8c61c0abfb3482de04a8dd074121)

1318.	[doc]		marcin
	Updated Kea Administrator's Manual with the information about
	new capability of flex-id hook library to use value derived from
	flexible identifier as a client identifier or DUID.
	(Trac #5384, git cce58fee4aa0476712209a7ed92fab587258b49b)

1317.	[bug]		fdupont
	The kea-admin script now behaves properly when -4 or -6 is missing
	while using lease-dump command.
	(Trac #5379, git 53870c07d1864faf2a25bdc4ed6c5cf2b0223f8d)

1316.	[bug]		marcin
	Corrected a bug which caused a returning DHCPv4 client performing
	4-way exchange to be assigned a different address from a shared
	network than previously allocated.
	(Trac #5388, git 601a387ba43d990947ee2e1a05e78851d8133a3c)

1315.	[bug]		marcin
	Created unit test for the case when there are several IPv6 subnets
	within a shared network and each subnet specifies the same
	DHCP option with a different value. This test verifies the fix
	applied with ticket #5364 which address the problem of assigning
	options from invalid subnet.
	(Trac #5366, git 112addd4619509c464dc051f4885e00dc1f69d26)

1314.	[bug]		marcin, tomek
	Improved unit tests for shared networks and corrected a bug
	in the allocation engine which caused wrong subnet id to be
	stored in the lease database and wrong subnet be used by the
	DHCPv6 server for options assignment.
	(Trac #5364, git 07ce52ee4ce65eeeea1890201812ac83a286658f)

1313.	[bug]		fdupont
	Empty output_options structure is no longer returned by config-get
	or config-write commands.
	(Trac #5267, git f2290503ed899f00c7f2f2b905b90bc360617340)

1312.	[func]		marcin, tomek
	Added new configuration parameter "outbound-interface", which
	controls how the outbound interface and source address is
	determined for the responses sent by DHCPv4 servers to relayed
	clients. The default setting is to use the same interface as
	the one over which the query has been received. The alternative
	is to use system routing to determine the right interface and
	source address.
	(Trac #5377, git d08088923ec1ea0d1cb8a947bd520174d874d25e)

1311.	[build]		fdupont
	Improvements in --enable-shell and other parameters passed while
	building dist tarball.
	(Trac #5210, #5339, #5352,
	git e531cda4e10114a8f14bcbf3d7e25b6584230875)

1310.	[bug]		marcin
	Documented "ia_pd" parameter for lease6_renew and lease6_rebind
	hook points.
	(Trac #5368, git 6842036714f84bf12529e1a43e12ac5a07e2e5c0)

1309.	[func]		fdupont
	Kea-shell script now has an optional --path parameter that allows
	using not empty URL path.
	(Trac #5361, git 9a31c417d52f1481185b0880a10a4b5f16d8462a)

1308.	[func]		fdupont
	Support for conditional token ifelse(condition, iftrue, iffalse)
	was added. It can be used in flex-id, client classification and
	possibly other expressions that may appear in the future.
	(Trac #5363, git 34c364abd23a1a745da79c10c69b94b8defad08b)

1307.	[func]		fdupont
	When an option is defined with a record type and the array
	flag is true the last record field is an array. All standard
	options supported by ISC DHCP and using this are now supported
	by Kea (so now there is no standard option supported only by
	ISC DHCP).
	(Trac #5226, git f66951dbda8f62122187ac3a99f0fdcc65b383d8)

1306.	[bug]*		marcin
	Respective Kea daemons now use their own default configuration
	files: kea-dhcp4.conf, kea-dhcp6.conf, kea-dhcp-ddns.conf and
	kea-ctrl-agent.conf. This change is aimed at eliminating the
	issue whereby 'config-write' command overrides configuration
	of all servers rather than just a configuration of the deamon
	to which this command has been sent.
	(Trac #5338, git 252e5e8a75fa42271b0cdb6edad3c152bbf3c515)

1305.	[bug]	tmark
	Corrected logic that was causing kea-dhcp4 to remove DNS entries
	when renewing leases with generated FQDN names.  Prior to this
	the server was incorrectly scheduling DNS removal when configured
	to generate the client's FQDN.
	(Trac #5369, git 18f57f502f1b9fb5bf7ef5ab995ddda60006fd39)

Kea 1.3.0-beta released on September 29, 2017

1304.	[bug,func]	fdupont
	The DHCPv4 Vendor Specific Information (code 43) option and
	private options (codes 224-254) can be redefined at the global
	scope or inside a client-class. This allows to support different
	definitions following the DHCPv4 Vendor Class Identifier (code 60)
	option or when defined as a binary option to accept with problems
	option 43 carrying a raw value.
	(Trac #5073, git b290b3cbaa926d4e9613f6607c5fcbae2301b266)

1303.	[func]		tmark
	The command handlers in the lease_cmds hook library are now
	implemented has hook callouts and registered with the Hooks
	manager. Prior to this they were registered as command handlers
	with the Command Mgr.
	(Trac #5332, git c902bda9f026720f6efbf2e5ad407302aeb5e466)

1302.	[func]		marcin, tomek
	DHCPv6 server supports shared networks. It allows for grouping
	multiple subnets and use them interchangeably to allocate
	IP addresses and other resources to a client located on the
	particular link. This mechanism is useful to extend an
	address space for the client belonging to a particular
	subnet and/or to segregate clients being on the same link but
	belonging to different classes, e.g. cable modem vs router.
	(Trac #5307, git 110d0c9e403af28e6810141f978d9bf55c381f14)

1301.	[func]		fdupont
	Added some standard option definitions which are supported
	by ISC DHCP but not (yet) by Kea.
	(Trac #5227, git 4bef838245f08fca5f2cf037cd3a75278b77f8f9)

1300.	[doc]		tomek
	Documentation for shared networks added.
	(Trac #5310, git 41fd3bb7ed2f4cd15db6cbd14713f4474f659c92)

1299.	[doc]		fdupont, tmark
	Added an example stunnel configuration file to demonstrate
	using kea-shell through https.
	(Trac #5282, git efe044fa90d53398e215d2bf31e00e83353e8774)

1298.	[func]		marcin, tomek
	DHCPv4 server supports shared networks. It allows for grouping
	multiple subnets and use them interchangeably to allocate
	IP addresses and other resources to a client located on the
	particular link. This mechanism is useful to extend an
	address space for the client belonging to a particular
	subnet and/or to segregate clients being on the same link but
	belonging to different classes, e.g. cable modem vs router.
	(Trac #5306, git 4f2fca69be32997c718ab2c7f37ac80ed4e41d15)

1297.	[func]		tmark
	Added a hook point, "command-processed", to kea-dhcp4
	and kea-dhcp6 servers. This hook point occurs after
	a control channel command has been received and
	processed.
	(Trac #5111, git 043d17b0688d4ab25b12469d27859983cb297d07)

1296.	[bug]		tmark
	Altered the mysql backend logic to disable auto_reconnect and
	set session value of wait_timeout to a very large values. This
	avoids a segfault in MySQL client library caused by auto-reconnects
	occurring when kea server's MySQL connection is idle for longer
	than the global MySQL wait_timeout.
	(Trac #5354, git 9881ef6d772f27de82c048e198ba0ff9e71b9351)

1295.	[bug]		tomek
	DHCPv4 and DHCPv6 servers are now able to parse shared networks.
	A basic shared networks examples added.
	(Trac #5357, git 74b824cc80f8be66084308c0bf12c1a71f311915)

1294.	[func]		marcin
	Implemented data structures holding configuration of shared
	networks. The new structures are unused until remaining tickets
	for shared networks implementation are completed.
	(Trac #5305, git 76dd46f7070c141cc89d772d69a897b67bd179a1)

1293.	[func]		tomek
	DHCP4_BUFFER_WAIT, DHCP4_BUFFER_WAIT_INTERRUPTED, DHCP6_BUFFER_WAIT,
	and DHCP6_BUFFER_WAIT_INTERRUPTED logging messages are no longer
	emitted.
	(Trac #5345, git 779040fa399fb2da271569dc315294463e28f852)

1292.	[func]		tomek
	User contexts are now supported for subnets. This adds a new
	functionality, but also makes the existing documentation example
	correct.
	(Trac #5350, git 828ecb6dbdaaedd97d2af79dfa9b7f4845d3a049)

1291.	[func]		fdupont
	The configuration parser now checks for mandatory parameters that
	are missing.
	(Trac #5124, git af0f3d50a835f64a5f8a47c47ef464b119a49643)

1290.	[bug]		marcin
	Corrected a bug causing illegal memory access while
	retrieving server hostname and boot file name fields from
	the host reservation database. Many thanks to Juan Settecase
	for his assistance in identifying this issue.
	(Trac #5340, git 2fdc7efcb862ced3c1054620bf14e75a0db6aed2)

1289.	[bug]		marcin, tmark
	Corrected handling of EAGAIN and EWOULDLBOCK errors in
	UnixDomainSocket. This was causing intermittent command
	channel write errors in kea-ctrl-agent on some Debian systems.
	(Trac #5336, git db251cb66ad77ba28ab44281323ddeb23cf29506)

1288.	[func]		marcin
	Documented subnet_cmds library in the Kea User's Guide.  Also moved
	several classes from dhcp<4/6> into lib/dhcpsrv to facilitate subnet
	command parsing.
	(Trac #5315, git d259f330a1690b20eb368f6252f5da2cdb6187de)

1287.	[bug]		tmark
	Logger configuration now correctly uses maxsize and maxver
	parameters, allowing log rotation to function properly.  Prior to
	this these values were not being propagated downward, causing log
	rotation to always be disabled.  The defaults for maxsize and
	maxver are 10Mb and 1 respectively.
	(Trac #5324, git 75f148458bdeeed27eb877cc2c3ce3069b152f38)

1286.	[func]		marcin
	Configured subnets are now indexed by subnet identifier and
	prefix for faster subnet lookups in the configuration.
	(Trac #5314, git 894aeb048b7281f947f87a5d6dc5112fac4a86fb)

1285.	[func]		tomek
	Several new commands implemented in lease_cmds library:
	lease4-del, lease6-del, lease4-update, lease6-update,
	lease4-wipe and lease6-wipe that allow deleting and updating
	leases and also wipe all leases from a specific subnet.
	(Trac #5280, #5281, 94ff2448c8cf6e3321f4d1b3666a2e2b736f6c50)

1284.	[func]		tomek
	A new library, lease_cmds, has been implemented. Its intended
	purpose is to support commands for lease management. Currently
	supported commands are: lease4-add, lease6-add, lease4-get,
	lease6-get. Additional commands and documentation are planned.
	(Trac #5272, #5279, git 785c2e521b198a03d26bde4a804638bfc19ce91b)

1283.	[func]		fdupont
	An 'always-send' parameter has been added to options
	configuration.  It allows an option to be always sent, even if
	a client didn't request it.
	(Trac #5241, git cef2b630c720a442710efc0d1615b7c7bce01e54)

1282.	[bug]		fdupont
	Now all interface service sockets are closed before interface
	re-detection. Note if the re-configuration fails they remain
	closed.
	(Trac #5333, git 8bff2ec336456de51d0d9d3ff011d28a6a61ef66)

1281.	[build]		tmark
	Configure script now correctly recognizes static boost_system
	library as well as checks for the presence of static glibc static
	libraries when --enable-satic-link is specified.
	(Trac #5337, git 42548148cbeaaa285519e121f493d52607f1e8a0)

1280.	[build]		waltsteverson
	Missing header for PD-exclude DHCPv6 option is now installed.
	(Github #51, git 36a8e1b8f687a6398af8a10f241e8d19e9de33d8)

1279.	[build]		waltsteverson
	Compilation fixes for Alpine Linux
	(Github #50, git 824afa63354e045a5e4f6437246c329d359e04dd)

1278.	[doc]		jsoref
	Many spelling corrections.
	(Github #52, git 1dcaef6f8e7901d628c8638fc2f8145ac0279586)

1277.	[func]*		marcin
	Added support to Command Manager to process commands using
	callouts implemented within hooks libraries.
	(Trac #5330, git 8041d177ed5587101ecb47a09820a7e67e42a066)

1276.	[build]		tmark
	The configure script now configures the build to require the Boost
	system library (boost_system) by default.  The library must be
	installed and you may need to specify "--with-boost-lib-dir=<path>".
	Prior to this the default was to attempt to build Boost with headers
	only.  Building with headers only may still be done, though it is
	strongly discouraged, by specifying "--enable-boost-headers-only".
	(Trac #5215, git b6f1ee0d1210e35631369fc697c76cc3cf2c4130)

1275.	[func]		marcin
	LibraryHandle object can now be used to register handlers
	for the control commands in a hook library.
	(Trac #5329, git 966cc24ae5593ebb08d6f02a11dab23463ebad7e)

1274.	[func]		marcin
	It is now possible to manage Control Agent with keactrl.
	(Trac #5108, git 53ba9f8197a25abd2c52ee3f5e95bc4e4be0241f)

1273.	[doc]		marcin
	Documented in the User's Guide that the server terminates
	when database connection is lost.
	(Trac #5320, git 5c8b277e8041b53b27a87b32d162ab41ef8b43d7)

1272.	[bug]		marcin
	Fixed inefficient leases indexing in the memfile lease
	manager causing increased CPU utilization during lease
	searches.
	(Trac #5328, git 23b490414f5575b252c8c42fbe93ad2c57d47953)

1271.	[doc]		marcin
	Documented how to setup secure connection to the Kea
	control	channel.
	(Trac #5304, git a920453bbcf9ffa7200eeddca6323faeff498f16)

1270.	[bug]		tmark
	Added a distribution rule to src/bin/d2/Makefile.am so
	d2_parser.yy will now be included in the distribution source
	tree. Also added entries for missing headers to asiolink/
	Makefile.am.
	(Trac #5325, git 199003d7aa9f8d4a7f8daa73f8259e951bc03217)

1269.	[func]		marcin
	Command manager can now handle large responses to control
	commands. Prior to this change the size of the response
	was limited to 64k. The server now also signals timeout
	after 10s if the connection lasts too long.
	(Trac #5318, git 8531a65521ea42f01f3bed444b054e92f7bd1a46)

1268.	[func]		fdupont
	Kea now re-detects network interfaces every time configuration is
	changed. 're-detect' parameter added to restore old behavior, if
	needed.
	(Trac #3389, git b2ce84790c33d1580dcfa773d7fcfb65c27addc7)

1267.	[bug]		fdupont
	Unit-tests for libdhcp now ignore ENOPROTOPT when setting
	SO_REUSEPORT to improve compatibility with older RedHat versions.
	(Trac #5243, git a7b478e1d1f7f0b38055086fe9ac053e4fab2850)

1266.	[func]		fdupont
	It is now possible to define options in DHCPv4 pools.
	(Trac #5288, git aa2839caab8d885e5bceca6f506162debd239b3f)

1265.	[func]		fdupont
	Extended classification relay6[nest] syntax to allows counting
	relays from the DHCPv6 client side by using negative number,
	e.g. relay6[-1] represents the first relay (closest to the
	client).
	(Trac #5287, git 7d0f7a8372dcf256fea8ac13330f0e3e7ed2e8ef)

1264.	[func]		marcin
	Kea's command manager has been re-implemented to use ASIO.
	Simultaneous connections over the control channel are now
	possible.
	(Trac #5317, git 4139a2f41bb3736615bdfa278746962a16384d0d)

1263.	[doc]		marcin
	Added example configurations of the nginx and Apache2 HTTPS
	servers running as reverse proxy for Kea RESTful API.
	(Trac #5302, git 48113aba218603afac4d457075458d4988e4082b)
	(Trac #5303, git b3113da16eb5c6fa323068f0a57dfa30f42893d2)

1262.	[func]*		marcin
	Renamed "dhcp4-server", "dhcp6-server" and "d2-server" parameters
	of the Control Agent configuration to "dhcp4", "dhcp6" and "d2"
	respectively.
	(Trac #5190, git fc67885022115df76425c6901959cedee63a93b9)

1261.	[bug]		marcin
	Eliminated valgrind errors in libkea-http.
	(Trac #5261, git 34addef4a654665c6022f0269d51970c72431ac2)

1260.	[bug]		fdupont
	Corrected logic in prefix delegation that was causing multiple
	entries to be written to the lease file when renewing or rebinding
	a prefix.
	(Trac #5104, git b9ab6ebe7a491c062bc8b0b42afc53f4d6cee011)

1259.	[func]		marcin
	Implemented timeout for the control commands forwarded between
	the Control Agent and Kea servers. The enhanced forwarding
	mechanism uses asynchronous calls over the unix domain sockets.
	It also detects the JSON structure boundaries when receiving it
	over the stream sockets.
	(Trac #5189, git e48d9399c215406f2dab1601d22d6c932b4af271)

1258.	[bug]		fdupont
	Fixed wrong python package path when kea-shell was configured
	without a prefix.
	(Trac #5214, git 44908c5fa56bfa7e1113078f43c458687a97388a)

Kea 1.2.0 released on April 28, 2017

1257.	[bug]		marcin
	Improved logging in the hosts manager.
	(Trac #5264, git 2fb9fd78e63f5d09810702847ad3e3b3020ea92b)

1256.	[bug]		tomek
	Control Agent now writes proper configuration when using
	config-write command.
	(Trac #5253, git a1b5da4db6ebfa9635bbe411ec363cdcc4fd1d28)

1255.	[bug]		marcin
	Fixed failing unit tests in libkea-http.
	(Trac #5260, git 43394f76efb1634155c04b205dec7361fc21f4f9)

1254.	[func]		tomek
	Various improvements needed for upcoming host commands library:
	host data source is now able to delete hosts, hosts can be exported
	to JSON format, C++11 code for configure script moved to separate
	file, several compilation warnings removed.
	(Trac #5208, git 88555d8f23745f3d615448e906796920cc7f44d0)

1253.	[func,doc]	tomek
	Default configuration file has been overhauled significantly. It
	now covers many additional options and features. Command channel
	is now enabled by default. Thanks to Dan Mahoney for his review.
	(Trac #5198, git 280de81cfe957ccab8a28074bdb0a4bc0e45104e)

1252.	[bug]		tmark
	kea-dhcp6 now correctly resets lease state and increments the
	assigned statistic when it reissues an expired-reclaimed lease
	to the lease's original client, in response to a REQUEST from
	said client.
	(Trac #5252, git 85bde7adbe6a78238bd5e17fecabfa918755f16c)

1251.	[func]		tomek
	New type of host identifier (flex-id) used in reservations has
	by added to MySQL and PostgreSQL schemas.
	(Trac #5195, git 37c26cc30b717019fbd6b7349279541edb351382)

1250.	[bug]		fdupont
	Do not unregister timers when running the config-test command.
	(Trac #5186, git e891b06940e41b4cfaa324c2ace8fdd761ee6662)

1249.	[bug]		tmark
	The assigned lease statistics were not being probably adjusted
	by either kea-dhcp4 or kea-dhcp6 when reclaimed expired leases
	were reissued.
	(Trac #5247, git 4e5193fb32b14325ccf5824614e58bcceb3e6388)

1248.	[bug]		marcin
	Improved socket connection handling code, corrected numerous
	failing and crashing tests for libkea-asiolink, libkea-http
	and kea-ctrl-agent on Debian, Fedora and Ubuntu.
	(Trac #5217, git 4bcb45f0c88aba3d0f70ca48d9fff6f1d4616bc2)

1247.	[bug]		marcin
	Resolved issues with DHCPv4 host reservations by 'client-id'
	when MySQL or PostgreSQL host database backend is in use.
	Also, the 'client-id' is used together with other host
	identifier types when 'host-reservation-identifiers' parameter
	is not specified.
	(Trac #5102, git 390d687d0f61635f5562d13860ff6362eee67853)

1246.	[func,bug]	tomek
	Restrictions in filename argument in config-write command have
	been removed. It is now possible to use absolute paths.
	DHCPv4, DHCPv6, D2 and Agent parsers did not handle flush,
	maxsize or maxver parameters in logger configuration correctly.
	This is now fixed.
	(Trac #5187, git a30ffcc67cfb7370c586d3c85147792e27aab4c7)

1245.	[func]		fdupont
	DHCPv4 domain-search option can now be defined using
	comma separated values.
	(Trac #5087, git eca0b8c6425bc922587675100f100b1aae54aee2)

1244.	[doc]		tomek
	User's Guide section about Kea shell added.
	(Trac #5171, git 3dc4908fe02e86c57ccd5ad2d2f8330655f438be)

1243.	[func]		tomek
	config-reload command implemented. It allows Kea DHCPv4 and DHCPv6
	servers to reload its original configuration file. Also,
	set-config command was renamed to config-set.
	(Trac #5213, git b209c2b577a2f9da71cc918d7a551f8efdc1c4cb)

1242.	[func]		fdupont
	Integer fields in options can now be specified in either
	decimal or hexadecimal format.
	(Trac #4540, git 4cbf341f4169cf1e1eae0721644797a726d89702)

1241.	[func]		fdupont
	Support for tuple-based options added. DHCPv6 option
	bootfile-param (code 60) can now be set in a more convenient
	manner.
	(Trac #4070, git 30102cacee95b91e6c4666f0c11f06232f19eeb9)

1240.	[bug]		marcin
	Corrected IOFetch unit test failures on Debian.
	(Trac #5216, git a7c2946678c43aedfb2e3c37b9730a10067528f3)

1239.	[func]		marcin
	Implemented additional sanity checks when adding host
	reservations into the configuration file.
	(Trac #5207, git ea42c6f479918235ae4a67a60d08720e2664720c)

Kea 1.2.0-beta released on April 7, 2017

1238.	[build]		tmark,tomek
	Library version numbers bumped for release.
	(Trac #5201	git 58c9c5b705d72031c1589c30c542384a9d43e0f3)

1237.	[bug]		marcin
	Fixed hanging Control Agent unit tests.
	(Trac #5200, git 65daafd135965f9eb0bd4c3a22085d4bd3c6ffbe)

1236.	[build]		zeitounator
	Improvements in tools/tests_in_valgrind.sh script.
	(Github #49, git 272e7babf9ebeab5f78850394d72c9431041e2e9)

1235.	[func]		MrMarvin
	kea-admin now supports -h (and --host) parameter that can specify
	MySQL or PostgreSQL database locations other than the default
	localhost.
	(Github #14, git 4038157a3499ad90956c98a2172c57b173f2b985)

1234.	[build]		fdupont
	Improved installation procedure for kea-shell.
	(Trac #5170, git 68a902fb723965ee6f5b7a8272224395917525cc)

1233.	[doc]		marcin
	Documented new component Kea Control Agent in the Administrator's
	Manual and the Developer's Guide.
	(Trac #5175, git abf7887ad65eb4b221a1fe61ea0c9773b4feaddb)

1232.	[func]		tomek
	host4_identifier and host6_identifier hook points have been added.
	Premium: Flexible Identifier (flex-id) hook point has been developed.
	It allows users to specify a custom expression that takes any
	option, field, characteristic or property of the packet to be
	used as identifier and then do reservations based on the evaluated
	expression for each incoming packet.
	(Trac #5132, git cd497526d5bff7ae55bb41c9264fb33943a0cf62)

1231.	[func]		marcin
	Control agent forwards commands to be handled by other Kea
	servers.
	(Trac #5078, git 19a50ed1ccafae19ef10d84cba73992cadf49753)

1230.	[bug]		fdupont
	kea-dhcp-ddns now correctly populates the original ID in the TSIG rdata
	when doing signed updates.  Prior to this the value was set to zero
	causing PowerDNS to reject then requests with a bad key error.
	(Trac #5071, git cafa3d5c24f0112b0b9384a9c1083fe8a3eeb2bf)

1229.	[func]		fdupont
	A new command: config-test has been implemented in DHCPv4, DHCPv6
	and control agent servers. It allows checking whether new
	configuration looks correct.
	(Trac #5150, git 5f6cf226e848baef8d9af64e16c1dbf617a0a798)

1228.	[bug]		fdupont
	Logging on syslog now uses correctly the given facility. If none
	is given the default facility is local0, and with an unrecognized
	value user (log4cplus default). The syslog openlog() ident
	parameter is the program name.
	(Trac #5053, git 532d9f0e459ab1450a83a5015a2dd54745794383)

1227.	[func]		fdupont, tomek
	Additional commands: version-get, build-report have been
	implemented for DHCPv4, DHCPv6 and Control Agent
	components. Control Agent also now supports shutdown command.
	(Trac #102, git 9d2b8326fc032876d74c1768c61c630987c25cc5)

1226.	[func]		fdupont
	Command line option -t support added to libprocess and implemented
	for kea-dhcp-ddns and kea-ctrl-agent. It allows configuration sanity
	checking. Note that some parameters, such as ip-address, port, and
	DNS server addresses for instance for kea-dhcp-ddns are not fully
	checked as sockets are not opened or connections are not attempted.
	(Trac #5152, git 2231d79ebebd3cdf432cd4a8ac32018d180e27b6)

1225.	[func]		tomek
	Two new commands: config-get (retrieves current configuration)
	and config-write (writes current configuration to disk) have been
	implemented.
	(Trac #5151, git ffb26811736a2ae6f9b5556b9823aa284b7e0aec)

1224.	[func]		fdupont
	toElement(), a crucial functionality for upcoming get-config
	and write-config command, has been implemented.
	(Trac #5114, git df38c26f957c9ac329718ac9d70ffbcf7b95c4e9)

1223.	[func]		tomek
	Kea-shell, a management client able to connect to REST interface
	provided by Control Agent, has been added. Control Agent now
	uses bison parser, which provides better sanity checks, improved
	comments and file inclusions.
	(Trac #5137, git 816dc5ccfa374bd9942a49c7bac475f6d0523caa)

1222.	[func]		fdupont
	Obsolete parameter 'allow-client-update' has been removed
	from DHCPv4 and DHCPv6 components.
	(Trac #5145, git 01fde297a978e2bd832655ac7276e5aa3a7e8400)

1221.	[func]		tomek
	Control agent is now able to parse the input configuration and
	store it in its configuration syntax structure. Upcoming tickets
	will take advantage of that information.
	(Trac #5134, git 828304f2f408888e4b096418e90e35ba524979d0)

1220.	[func]		parisioa, fdupont, tomek
	DHCPv4 and DHCPv6 parsers have updated to accept database port
	parameter. The parameter for Cassandra is now called
	"contact-points" (was "contact_points" previously).
	(Trac #5061, git d12b6f4a6d80d6bc854f2a8a086e412dc37867bc)

1219.   [func]		marcin
	Control Agent uses libkea-http to process commands over
	the RESTful interface.
        (Trac #5107, git 88ce715926a46b6b3832630116fc7782adc46c7b)

1218.	[func]		tmark, tomek
	Configuration parsing for D2 has been migrated to bison/flex
	and the SimpleParser framework.  This includes changes to
	libprocess which render the CPL agnostic to the underlying
	parsing mechanisms.
	(Trac #5110, git feb2cedc0936364a923ab78542a21114533dd0f5)

1217.	[func]		marcin
	Implemented libkea-http library.
	(Trac #5077, git cd72284b5b221e620770883db7e166c4d3ba7eb6)
	(Trac #5088, git 715d18f961801ffbd798a65b19459178c3a53857)
	(Trac #5099, git 7e8df7993f295431e2cb6a13858f746649c4e18d)

1216.	[func]		fdupont, tomek
	Command line option -t implemented for DHCPv4 and DHCPv6.  It
	allows configuration sanity checking. Note that not all parameters
	are completely checked. In particular, service and control channel
	sockets are not opened, and hook libraries are not loaded.
	(Trac #3770, git 1d12582e270935ee7b72548d9c66753f4eea4ca4)

1215.	[doc]		tomek
	Developer's Guide updated to cover flex/bison parser.
	(Trac #5112, git 44139d821c1f4e43dbff22d49101a0854e4f9f5b)

1214.	[func]		tomek
	Bison parser implemented for Control-agent. The code is able
	to syntactically parse input configuration, but the output
	is not used yet.
	(Trac #5076, git d99048aa5b90efa7812a75cdae98a0913470f5a6)

1213.	[bug]		fdupont
	Option string values containing comma can now be specified
	correctly by preceding comma with double backslashes (e.g.
	"foo\\,bar").
	(Trac #5105, git fa79ac2396aa94d7bac91bd12d3593ebaaa9386d)

1212.	[doc]		andreipavelQ
	Many spelling corrections.
	(Github #47, git a6a7ca1ced8c63c1e11ef4c572f09272340afdd7)

1211.	[func]		andreipavelQ
	Updated PostgreSQL version reporting to be in line with
	MySQL and Cassandra.
	(Github #42, git 7ef4a190facadd66775b4a44c696d1c4215616cd)

1210.	[doc]		andreipavelQ
	Doxygen version updated to 1.8.11.
	(Github #45, git ce72998382b62269823fa0dcbfa41dfa9c72b69e)

1209.	[func]		tomek
	Relay options are now printed in DHCPv6 when sufficiently detailed
	debug logging is requested.
	(Trac #5131, git 5bf58b21fcf07f2e2e97275efa1f76cde913b30a)

1208.	[func]		tomek
	Global DHCPv4 and DHCPv6 parsers have been migrated to the
	SimpleParser framework. Several parameters (renew-timer,
	rebind-timer, preferred-lifetime, valid-lifetime, match-client-id,
	next-server, decline-probation-period, dhcp4o6-port,
	echo-client-id) now have explicit default values.
	(Trac #5019, git f3538dd031e6f29abcd516f425d72c8f929abbb0)

1207.	[func]		fdupont
	Client classes parser migrated to SimpleParser. The 'name'
	parameter in 'client-classes' definitions is now mandatory.
	(Trac #5098, git e93906e48a6e2b0ff78c5e37dca642646fe47d43)

1206.	[func]		tomek
	'hooks-libraries' parser migrated to SimpleParser. The code will
	now refuse a configuration if a hook library fails to load.
	(Trac #5031, #5041, git 1bbaf4cbcf6fda59bacdf526a6c762315fdd88a1)

1205.	[func]		tomek
	Parsers for interfaces configuration converted to SimpleParser.
	Removed obsolete 'version' parameter in Dhcp6.
	(Trac #5020, #5038, git 3d8e48c640e302670c04907468d11faafbe9fe7b)

1204.   [func]         marcin
	Added 'control_command_receive' hook point to Kea Command
	Manager.
	(Trac #5100, git d0c7cb29a7df3588c540afb4ca56de55f26142e0)

1203.   [func]         marcin
	Implemented TCPAcceptor class in libkea-asiolink. This class
	provides means to listen and asynchronously accept new TCP
	connections.
	(Trac #5094, git 920ba90696ba9d8579a7db5e1efcf955d6654a96)

1202.	[func]		tomek
	Parsers for mac-sources, control-socket, and relay-info converted
	to SimpleParser. It is no longer accepted to specify empty
	mac-sources. Either specify actual values in mac-sources or
	don't specify mac-sources at all.
	(Trac #5032, git f1c9dee0936b48be28f890ffd428fbdeb87c12ea)

1201.	[func]		tmark
	kea-dhcp4 and kea-dhcp6 now support the "set-config" command.
	The command causes the server to replace its current configuration
	with the configuration supplied as the command's argument.
	(Trac #5046, git 4afbdcf89c9f83d944f774d05bd401d3f2768d10)

1200.	[func]		tmark
	kea-dhcp4 and kea-dhcp6 now support the Command Channel "libreload"
	command.  The command causes the server to unload and then load all
	currently loaded hook libraries.
	(Trac #3238, git d4d8665494e1847b34b66f8ef542851ea6f0213c)

1199.	[func]		tomek, fdupont
	Dhcp4 parser migrated to bison. This yields a number of user
	visible changes:
	- better comment handling (bash, C, C++ style comments)
	- file includes now supported
	- better syntax checking
	- added advanced.json config example
	- removed obsolete 'version' parameter
	(Trac #5017, git 1cf853c595a100c86f9b2b3353f1b5964d902147)

1198.   [func]         marcin
	Created kea-ctrl-agent. This application currently doesn't
	do anything. Future tickets will add REST API to allow for
	managing Kea services.
	(Trac #5075, git 1ec7586da5ae1474b52d5a395fb80ee37d6d568e)

1197.	[doc]		tomek
	Configuration examples now set lfc-interval to a default
	value of one hour.
	(Trac #5072, git cf4362196fa2b7892643d1e40b974bb450a3de7e)

1196.	[func]		tomek, fdupont
	Dhcp6 parser migrated to bison. This yields a number of user
	visible changes:
	- better comment handling (bash, C, C++ style comments)
	- file includes now supported
	- better syntax checking
	(Trac #5036, git 4c5902da95a5228275cdb151b357864cfa9c31f5)

1195.	[build]		fdupont
	Altered to compile in C++ 2011 standard mode. Also replace (most)
	instances of the deprecated std::auto_ptr with std::unique_ptr.
	(Trac #5066, git a060d4a983860bf3056d50d9bf7ee4355c8372f2)

1194.   [build]     	marcin
	Moved StateModel class from D2 to libkea-util.
	(Trac #3175, git 270ec379aec2894104a299cdd1080e24007e25fb)

1193.	[doc]		stephen
	Update Hook Developers documentation to make it clearer where
	the Kea include files and libraries are located.
	(Trac #5069, git 14a78caaf3af9fe9a0ffe2c8af784eab78e813e0)

1192.   [build]     marcin
	Created libkea-process library and moved the Controllable
	Process Layer (CPL) from D2 to this new library.
	(Trac #5074, git 4563925f7966e9da2132eb427e742cc3d3feee5d)

1191.	[build]		tomek
	Optional support for premium package added.
	(Trac #5027, git 5ff51f28a1f05d941bb117986922a6f410f23c6c)

1190.	[func]		tomek
	User context implemented: an arbitrary user information can
	now be defined for address and prefix pools.
	(Trac #5023, git 4f81789e19b72c933bcf86e402b417c63bd7bd3f)

1189.	[func]		fdupont
	Owing to API changes, crypto code now requires OpenSSL 1.0.1 or
	later.
	(Trac #3908, git 4c14fdfd4187a4c8f7b775432082b76782e47663)

1188.	[doc]		vlegout
	Fixed several spelling mistakes.
	(Github #32, git d51c005519c4add6fd0c37bcd68b0fbe94941b2d)

1187.	[bug]		marcin
	DHCPv4 server allows for allocating multiple leases for the
	same hardware address if a different client identifier is
	used for each lease. This facilitates the PXE boot use cases
	where a booted machine may request a lease multiple times.
	(Trac #5029, git 03defed4d8bb9a997d31dbfcf30ae3f866bd3353)

1186.	[func]		marcin
	Support for DHCPv6 options defined in RFC6603 and RFC7598. Thanks
	to Andrei Pavel and Cristian Secareanu of Qualitance for submitting
	initial implementation.
	(Trac #Github24, git 59b62eb3ddd9db62c04bd47cd8fbdc1af62fbc1b)

1185.	[build]		marcin
	Install Kea headers to be used for building external libraries.
	Before this change some required headers were not installed.
	(Trac #5055, git a46087b7b7face4a1318658bbdcbf7602c1bb729)

1184.	[bug]		eest
	Fixes in the occasionally failing LFC unit test. This
	fix was provided by Patrik Lundin.
	(Github #31, git 69a5722bf3b41bf3b2bc0c2bcac966c23c08f62d)

1183.	[bug]		tmark
	kea-dhcp4 now correctly loads declined leases from CSV
	lease files. Prior to this, declined leases were being
	incorrectly and silently discarded.  In addition, both
	kea-dhcp4 and kea-dhcp6 will now emit an error log for
	each invalid row encountered when loading leases from
	CSV files.
	(Trac #5058, git 29b088079bed3c5059fdf8a43a4e79cd7f9a4207)

1182.	[func]		marcin
	DHCP servers detect overlapping pool ranges during
	configuration.
	(Trac #2280, git c8f931e0189c9630f5fba5d2a5553bed4abf36f7)

1181.	[func]		marcin
	Extended DHCPv6 server to allow for specifying DHCP options
	on address and prefix pool levels.
	(Trac #5022, git e3b2785c79aedbb0c8af7468d61f6d61dafd2282)

Kea 1.1.0 released on September 30, 2016

1180.	[doc]		stephen
	Editing pass through the Kea guide.
	(Trac #4484, git 63456fab1b978bd515198b9b9e604f293efd8217)
	(Trac #5008, git f09cd12d5b1abc60ccef98df2abc6c41b482a404)

1179.	[doc]		tomek
	Manual pages updated.
	(Trac #3515, git 4cf0395e11e724786c4d2a1d48805f1c770f4c99)

1178.	[doc]           tomek
	user_chk hook library is now documented in the User's Guide.
	(Trac #3209, git 4a8534d968a21cff3851619fb22d0032a1202c87)

1177.	[build]	marcin
	Updated Kea libraries version numbers for 1.1-final release.
	(Trac #5012, git 6e9a224b46def357141a31386fcc912b29dfe16d)

1176.	[doc]		tomek
	Developer's Guide has been updated.
	(trac #4299, git ed38076c183394feaef60e7123d0c488c9f6447d)

1175.	[bug]		marcin
	Corrected a bug whereby a client, for which there was no
	host reservation specified, did not obtain an IPv6 lease
	from a server when PostgreSQL or MySQL host database backend
	was in use. In addition, PostgreSQL host database backend
	allows for specifying NULL values in certain columns within
	host reservation tables.
	(Trac #5009, git d3109bb27786867fdc99954ba55367f0ad129e7a)

1174.	[bug]		tmark
	Modified kea-dhcp6 to avoid requesting DNS updates when
	existing leases are renewed without changes to the FQDN.
	(Trac #5007, git 05ea3a5eb75c06cf9814c63a1a54261bf58a954b)

1173.	[bug]		xxwolfsrainxx, marcin
	MySQL database creation scripts use single quotes for
	strings to avoid issues with creation of the database
	when MySQL server operates in ANSI_QUOTES mode.
	(Github #30, git e40a54a8e24b5f6427edd4afcd5cdc15012b8866)

1172.	[bug]		andir
	Kea build fixes for gcc 6, which uses C++14 by default.
	(Github #29, git ad68c3942839618c26d7ff017fbac7df139b5d01)

1171.	[doc]		marcin
	Updated supported operating systems and the prerequisites for
	installing and building Kea in the Kea Administrator
	Reference Manual.
	(Trac #4502, git af847837590ce5b37a300ebe15652fb172585b38)

1170.	[doc]		marcin
	Updated Kea Administrator's Reference Manual sections
	regarding host reservations. Added configuration examples
	for using host reservations with MySQL and PostgreSQL
	databases.
	(Trac #3684, git 71d21eac51d20ff5d368b17c437abc45c955a04c)

1169.	[doc]		marcin
	Updated Kea Administrator Reference Manual to explain the
	implications of using "kea_verbose" parameter in the keactrl
	configuration.
	(Trac #3950, git c5f4920fd1994882e1fae398ae29b455401296bd)

1168.	[doc]		marcin
	Corrected location of the Kea repository in the Kea Administrator
	Reference Manual.
	(Trac #4258, git f081000b892287316e54848ca1f62ca3512d4263)

1167.	[func]		marcin
	DHCP servers utilize client classes defined in host reservations.
	(Trac #4765, git 242fbc47b31da404e57be458ac065f811084cca9)

1166.	[bug]		marcin
	Corrected error message produced by the host database access
	parser when the database type was not specified.
	(Trac #4261, git 028dd49f4fa4843e68e23d11c237e9f4683470ba)

1165.	[func]		marcin
	Hostname option is returned to the client when requested using
	Parameter Request List option. Previously this option was only
	returned when a client has sent Hostname option to the server.
	(Trac #5005, git 96ab8ecaa3d5b2d6cd88d0b16406f433d2cdf841)

1164.	[bug]		marcin
	Corrected an issue whereby DHCPv4 server did not correctly set a
	server identifier in response message sent to a client on BSD
	systems.
	(Trac #5003, git 110c67325072a781d55cf0634f8f5f3385611f97)

1163.	[bug]		marcin
	Corrected swapped DHCPSRV_MEMFILE_GET_EXPIRED{4,6} messages
	in the Memfile lease manager.
	(Trac #4717, git ce5919d97879c3fda0858894b24418af135ef8f3)

1162.	[func]		pallotron
	Added two enhancements to perfdhcp: optionally using MAC
	addresses from a file in new DHCP transactions, and
	generation of DHCPv6 relayed messages.
	(Github #22, git c5b4a5981cf642ebb9aecb8acc07b87abdccbd91)

1161.	[bug]		fdupont
	Fixed interface manager receive methods which raise a bug on
	Fedora 24 / gcc 6.1?
	(Trac #4551, git 8d590e434062535e850a60a7892481df845ff390)

Kea 1.1.0-beta released on August 31, 2016

1160.	[build]		marcin
	Bumped up version numbers of Kea libraries and KEA_HOOKS_VERSION
	for the Kea 1.1.0 beta release.
	(Trac #4632, git 93941523e039a1cc4bb34182a290f9d7b805df34)

1159.	[func]		marcin
	MySQL database schema updated to version 5.0.
	(Trac #4562, git 0e40b35e280f0845686bcfdb2efb577c7878ede6)

1158.	[func]		tomek
	It is now possible to specify fixed fields (next-server,
	server-hostname and boot-file-name parameters) for client classes.
	(Trac #4626, git 89cf54524d8b55cc982ab2146915c0a90fc6efe2)

1157.	[func]		marcin
	Added support for static reservations for fixed fields in
	DHCPv4 messages: siaddr, sname and file.
	(Trac #4552, git 9b79fe005dd77328ea7c596fc6886f8fb838d1cf)

1156.	[bug]		tmark
	Lease statistics are now recalculated during server startup and
	after each successful reconfiguration for Memfile, MySQL, and PostgreSQL
	back ends.  This addresses issues caused by accumulated values being lost
	across restarts and reconfigurations making rendering values incorrect.
	(Trac #4294 git 0abdcf15f85861ffcb67d50fa4ce3965d25e4a9f)

1155.	[func]		marcin
	Kea can be configured to operate using read-only host database.
	This is only supported for MySQL and PostgreSQL databases.
	(Trac #4489 git 0d8dc7affb67ad8066b44c6f81532b79a641d50b)

1154.	[bug]		stephen
	Changes to logging to avoid premature destruction of some
	objects during program exit.  On some systems this caused
	one of the unit test programs to crash when it terminated.
	(Trac #4494, git 023c2fc3688bcdbccb4b286bea873c8f9c06cd5f)

1153.	[func]		tomek
	Integers can now be used in client classification.
	(Trac #4483, git e90cf0ee4007521b86177be6d5fbb970c02c1075)

1152.	[doc]		marcin
	Use of PostgreSQL as a storage for host reservations is now
	documented in the Kea Administrator Reference Manual.
	(Trac #4282, git f2879919772c10b1ae8c45d0e761ef199cf84061)

1151.	[func]		tmark
	Support for assigning client classes to host reservations has
	been added to both the PostgreSQL and MySQL backends.
	(Trac #4277, #4213 git 6990ab9d542e984c59ce5a11ff926c3c732a75fc)

1150.	[bug]		tomek
	Extended gcc bug workaround to work on all versions of gcc
	from 5.2 up to, but not including 6.0. See ChangeLog entry
	1103 or Trac ticket #4243 for details.
	(Trac #4553, git 80243d9d246b982d86dd7e0d00597383cae01706)

1149.	[bug]		marcin
	Corrected a bug whereby clients were not assigned reserved
	addresses from an external database, as a result of unexpected
	closure of a connection to that database.
	(Trac #4544, git 7f682112dd5ab9fcd6bfa4e10505c246775f353d)

1148.	[func]		tomek
	The vendor options (124, 125 in DHCPv4 and 16, 17 in DHCPv6) are
	now accessible from client classification.
	(Trac #4270, #4271, git ef676368f9036625d73f7f34e3fe9b5eeeaee7f1)

1148.	[func]		fdupont
	Added the pkt classification token to extract incoming packet
	meta-data (receiving interface name, source and destination
	address, length).
	(Trac #4272, git 9a3bdfa43cf65ef56a8d63580dd5d7414fc41373)

1147.	[func]		stephen
	-Werror is no longer the default for compilation.  Promotion of all
	compilation warnings to errors now requires the --with-werror switch
	to be specified when running configure.
	(Trac #4533, git 874e3a3f5cb10313856284646fcee7cf86e4fcce)

1146.	[func]		sar
	Add the forensic hook library documentation to the admin guide.
	(Trac #4511, git 0bb39840a3cbdaf815819f846120c90d9ca038ff)

1145.	[func]		tmark
	The Postgresql backend now supports host reservations for both
	DHCPv4 and DHCPv6, with options and IPv6 reservations.
	(Trac #4277 git ac1eaa1026987c2d86d57b4aa0dc9a4d093787f0)

1144.	[bug]		mihu
	Response to DHCPINFORM is generally sent to port 68, rather
	than port 67. Thanks to Michal Humpula for providing a patch.
	(Github #23, git 4216a4bedf8a884df087c68d48c88ee9ffa444dc)

1143.	[doc]		fdupont
	User's Guide has been updated with DHCPv4-over-DHCPv6 support
	details.
	(Trac #4273, git fe8cb64adeabe00d84ee390b579a8328717ae521)

1142.	[doc]		sar
	Uncomment the example columns in some rows in the table
	listing the classification examples.
	(None, git dee442a64f57c8d9dd87636f9e39084ed1b11e03)

1141.	[func]		marcin
	Pkt4, Pkt6 and Pkt4o6 objects passed to hooks libraries
	return copies of DHCP options to avoid unintended modification
	of the options stored in the server configuration.
	(Trac #4497, git e50d2ebe998ec3faad8ade22b6971d6584c81044)

1140.	[func]		marcin
	DHCPv6 server supports assigning multiple reserved addresses
	and/or prefixes to a single client.
	(Trac #4321, git 0bfb2a9093174e4424051c01beeee7637ac95be0)

1139.	[doc]		tomek
	New features of host reservations have been documented: ability
	to reserve standard and vendor options in host reservations. Separate
	sections for each backend added.
	(Trac #4518, git 99a40fead28f4324dfb55f1962a8bf3e85ab70e2)

1138.	[build]		fdupont
	Compilation problem on FreeBSD caused by unused parameter in
	certain version of boost headers is now resolved. Also, INSTALL
	file has been updated and now lists dependencies.
	(Trac #4283, git 7dbd95651c308527f2e42c533fdc0a12aeec5308)

1137.	[doc]		fdupont
	Developer's Guide has been updated with DHCPv4-over-DHCPv6 support
	details.
	(Trac #4274, git b3eda594e055f03a9a601bacf0c72c3db0ef8e3c)

1136.	[doc]		tomek
	Included full text of MPL 2.0 and Apache licenses.
	(Trac #4529, git baefb4b3e2078a0a0f794b42ef52d6b7d53c9dab)

1135.	[func]		fdupont
	Integrated the DHCPv4 service part of DHCPv4-over-DHCPv6 support.
	(Trac #4110, git 7d36aebe14db10b0cbac8e6c0e82160b9d5d7ecd)

1134.	[func]		fdupont
	Integrated the DHCPv6 service part of DHCPv4-over-DHCPv6 support.
	(Trac #4109, git 8d1f330d9b0a44039a8b9e0b479f8da1743b9504)

1133.	[func]		razvan
	The initial support for CQL (Cassandra) backend added. It is able
	to store leases information.
	(Github #21, git d3a412d4b090bfd84ec5bc5d7817b1dfcc92602e)

1132.	[func]		tmark
	The Postgresql schema has been updated to support host
	reservations and its version number has been bumped to 3.0.
	This schema is content equivalent to the MySQL schema version 4.2.
	(Trac #4275, git 6f8e646bee9de22c921ed26409f3d1856ebce9e6)

1131.	[func]		fdupont
	Update the DHCPv4-over-DHCPv6 inter-process communication code.
	(Trac #4106, git 1ce1cba00af5d81822d5bbe26ddd28b718f51d54)

1130.	[func]		marcin
	DHCPv6 server assigns DHCP options specified for hosts. Host
	specific options take precedence over class specific options,
	subnet specific options and global options.
	(Trac #3573, git c29551e43010a345cfa2efda46389f4433d84650)

1129.	[bug]		marcin
	libdhcp++: Removed unnecessary copies of the container holding
	option definitions to improve performance of both DHCPv4 and
	DHCPv6 server.
	(Trac #4498, git 14716853a92e08c4cc5be75ae85c5e84d6356a1e)

1128.	[func]		tomek
	Subnet selection in DHCPv4 will now work, even if the addresses
	configured on interface are not in range of the subnet definition
	from the configuration file.
	(Trac #4308, git 7c74ecdbb64c69d341d623422216b0a54e6ff519)

1127.	[func]		marcin
	DHCPv4 server assigns DHCP options specified for hosts. Host
	specific options take precedence over class specific options,
	subnet specific options and global options.
	(Trac #3572, git 49f67aaf36dab38b4fcbf59dcad97e4309903b2f)

1126.	[func]		marcin
	Host reservations can be assigned using DHCPv4 client identifier.
	(Trac #4317, git 5f14fca1e029b04ad21a417936c2b8889acef10d)

1125.	[func]		fdupont
	Inter-process communication for exchanging packets between
	DHCPv4 and DHCPv6 components of DHCPv4-over-DHCPv6 has been
	implemented.
	(Trac #4106, git 3223bb8280bfd99c225e725de660ae764abe3c87)

1124.	[bug]		sar
	Update the classification document to match the output from
	the debug statements.
	(Trac NA, git 8b3ea8e26c3e6cd3c46073b635212fd29f031774)

1123.	[func]		marcin
	Extended MySQL host data source to retrieve DHCPv4 and DHCPv6
	options associated with hosts from a MySQL database.
	(Trac #4281, git b8a306a27d1cae03f6bc5223c30806f5cd1b64f4)

1122.	[func]		sar
	Add debug logging to the classification tokens.  This uses
	the loggers "kea-dhcp4.eval" and "kea-dhcp6.eval" to capture
	details of the classification expression evaluations.
	(Trac #4480, git cf14d0d21c69879f21733457a97a6ac0bdb1dae2)

1121.	[func]		stephen
	Make the database connection timeout a configurable parameter with
	a default value of five seconds.
	(Trac #3164, git 3332ad17523c6fcc1e735e4297169ebb2de95118)

1120.	[bug]		marcin
	Performance improvement in libdhcp++: improved efficiency of the
	DHCPv4 Message Type option creation.
	(Trac #4495, git 41c43a2a9e34931fc3ebf58c459f10ad08575d19)

1119.	[bug]		marcin
	Performance improvement in hosts reservation: removed
	inefficient conversion of the host identifier to text
	when logging.
	(Trac #4499, git 48c20790480d5ed7bfde0ef7b052dd4a9745607d)

1118.	[func]		tmark
	The "query4" argument, containing the client packet received, has been
	added to the DHCPv4 hook points: lease4_select and lease4_renew.  The
	"query6" argument, containing the client packet received, has been
	added to the DHCPv6 hook points: lease6_select and pkt6_send.
	(Trac #4481, git c0af94c47bda85eb1caa3a78a46280b63990672a)

1117.	[bug]		stephen
	Adjusted variable type in a MySQL-related file to overcome a
	type mismatch problem reported by one particular compiler.
	(Trac #4485, git 4c6fb189b5d12ffdf4ab171c9154366e70e6082c)

1116.	[func]		tomek
	DHCPv4 subnet selection can now be selected based on IPv6
	information. This is part of ongoing effort to support RFC7341:
	DHCPv4-over-DHCPv6.
	(Trac #4112, git 3352685981ec8ca9a90f7405ff56cd31af6fb0d9)

1115.   [bug]		tmark
	An explicit call to unload the hook libraries prior to server
	exit was added to both kea-dhcp6 and kea-dhcp4.  This corrects
	an issue where logging components were being destroyed prior
	to hook libraries being unloaded.
	(Trac #4492, git 2a4792b3551cce2fb9147f33f032ae7e71791d21)

1114.	[bug]		marcin
	perfdhcp: Improved algorithm for dropping timed out transactions.
	This prevents growing memory consumption due to storing timed
	out transactions when the DHCP server drops many messages.
	(Trac #4493, git 9757a93110afb82c5379643f2f48e223d497efae)

1113.	[func]		tomek
	It is now possible to specify parameters for hook libraries.
	(Trac #4297, git f45d0b5d297f6ad522eb8b7e6f6a0de1064b8569)

1112.	[func]		marcin
	"host-reservation-identifiers" configuration parameter has been
	implemented. It allows for specifying an ordered list of
	host identifiers that DHCPv4 and DHCPv6 servers use to
	retrieve static host reservations for a client.
	(Trac #4303, git 942808400e7116d95acfd53b0dc1ecad1c45c598)

1111.	[func]		tmark
	Schema scripts have been relocated from src/bin/admin/scripts to
	src/share/database/scripts and are now shared by both kea-admin
	and unit testing.
	(Trac #4239, git 131fcf52f2a65cedb53975f99114296366fb0199)

1110.	[func]		fdupont
	Added support for extracting constant length fields from a DHCPv4
	packet.
	(Trac #4268a, git 5d1397efc05802b72e86785528870b7154307ff0)

1109.	[func]		sar
	Added support for accessing DHCPv6 packet fields message type
	and transaction id in a classification expression.
	(Trac #4269, git 48be5f5ceaba6b0d0a2b31465e8a5904524e894c)

1108.	[bug]		pallotron
	perfdhcp uses the same transaction id throughout the DORA
	exchange to adhere with RFC 2131.
	(Github #19, git d260a70d6aa0baecd68131bc35f58f097aa77bcc)

1107.	[func]		tmark
	The DDNS parameter, replace-client-name, has been changed from a boolean
	to list of modes, which provides greater flexibility in when the Kea
	servers replace or supply DNS names for clients.  This is supported both
	kea-dhcp4 and kea-dhcp6.
	(Trac #4259, git 45e56d7aa0d4a6224a1a28941f6cb11575391222)

1106.	[func]		marcin
	"circuit-id" can be specified as host identifier in host
	host reservations. However, the server ignores the reservations
	by "circuit-id" at this point.
	(Trac #4301, git cf56fc2a2e0e821a17dd95de49a43755745682fb)

1105.	[func]		sar
	Added access to the peer address, link address and option
	information added by relays in a DHCPv6 message.
	(Trac #4265, git bb00d9d205ee047961ba70417d7ce02c37d80ce7)

1104.	[bug]		stephen
	Made DHCPSRV_MEMFILE_LFC_UNREGISTER_TIMER_FAILED a debug message as the
	condition leading to it (trying to unregister a timer that is not
	registered) does not have an adverse effect on the operation of Kea.
	(Trac #4293, git 06204c5d347d0df359af69974c155d0fa9725b44)

1103.	[bug]		tmark
	Wrapped asio/asio.hpp with logic to suppress optimization when building
	under GCC 5.2.0 through 5.3.1 and BOOST_ERROR_CODE_HEADER only is defined.
	This avoids an issue in the asio socket layer that was incorrectly
	reporting socket read errors causing unit tests to fail and kea-dhcp-ddns
	to loop logger calls in the error handler (aka double errors).
	(Trac #4243, git 082f846f37cb32964c876b2bff5fcac82d1eaaf0)

1102.	[func]		marcin
	Updated Host Manager API to allow for retrieving host reservations
	by any type of host identifier. Previously it was only possible
	to retrieve host reservations by hardware address or DUID.
	(Trac #4302, git 3979656c918164e3c39e0e8fb78b2862a2b5e95a)

1101.	[func]		kalmus, marcin
	Implemented IPv6 address/prefix reservations in MySQL.
	(Trac #4212, git 79481043935789fc6898d4743bede1606f82eb75)

1100.	[func]		fdupont
	Reorganized the DHCPv4 and DHCPv6 services into run() (service
	loop), run_one() (receive, call next routine and send) and
	processPacket() (internal core processing of an incoming packet).
	(Trac #4108,#4266,#4267, git ba24bd770d1a1791f8fdc3df7f2e41f9f0c851ec)

1099.	[func]		tmark
	Both kea-dhcp4 and kea-dhcp6, now log the primary lease events (e.g.
	grants, renewals, releases, declines) at the INFO log level to the
	lease4_logger and lease6_logger respectively.  Prior to this these
	events were logged at the DEBUG log level.
	(Trac #4316, git 9beca27e3d76d0ccec925125f23074227db08869)

1098.	[bug]		fdupont
	Fixed some minor Coverity-detected issues.
	(Trac #4326, git ad1f442ee4382b354dc8be84ba77785e565aa86b)

1097.	[bug]		marcin
	libdhcpsrv: Fixed issues with lease indexing in Memfile
	database backend.
	(Trac #4339, git a065144663ac716b1fa1c8c224a88aa176da9630)

1096.	[bug]		fdupont
	Fixed Coverity-detected overflows in pkt4::setFile() and setName().
	(Trac #4306, git 0b7388891eaab39fe727b076468d672551126796)

1095.	[func]		marcin
	DHCP option values can be specified within host reservations
	in the configuration file.
	(Trac #4319, git 069dd7c248afcfcb7e4d958f20faa32e946e74ce)

1094.	[bug]		fdupont
	Fixed Coverity-detected exception-handling issues.
	(Trac #4307, git 3e1050749d9684144e1bd17552af7e4abf3c0d17)

1093.	[func]		fdupont
	Added support for IP address (IPv4 and IPv6) literals in
	classification expressions.
	(Trac #4232, git b98cc019b172a4903a2121e910f3cee4eaca2d51)

1092.	[func]		fdupont
	Added relay4[X].exists method in classifications that checks
	whether a sub-option is present in theDHCPv4 RAI (Relay Agent
	Information, 82) option.
	(Trac #4313, git 87397fd75215b69ad79708aaa1d7505aca299fb5)

1091.	[bug]		fdupont
	Protected DHCP server main() routines against errors raised from
	logger calls in the error handler (aka double errors).
	(Trac #4310, git 6813e1a7520335f6920ff8de5e52ecdb24712910)

1090.	[bug]		fdupont
	Empty option specifications no longer require setting the
	csv-format parameter.
	(Trac #4291, git 398458f3ad4680fd5f3c032eb6c99d50c2981368)

1089.	[func]		marcin
	The Host class has been extended to store DHCP options to
	be assigned to a client.
	(Trac #3571, git 9d434f28cc4683eccbcca1ba0d1e45bceb5230d2)

1088.	[bug]		sar
	Always copy the DHCPv4 flags field from a client's request to the
	the server's response.
	(Trac #4292, git 8b7182abdc7ff47eb9b68451e7507b7e4b9872e0)

1087.	[bug]		fdupont
	Removed obsolete requirement of python3 by --enable-generate-docs
	configuration option.
	(Trac #4315, git 2c236316d5fbac9906cf48a6e4df1649e7545e67)

1086.	[bug]		marcin
	When lease-database configuration parameter is not
	specified the default lease database backend (memfile)
	is used.
	(Trac #3696, git 0be5e6eb32680a742ddcf427b8181f55c0c98115)

1085.	[func]		fdupont
	The following DHCPv4 options are now supported:
		nisplus-domain-name (64),
		nisplus-servers (65),
		mobile-ip-home-agent (68),
		smtp-server (69),
		pop-server (70),
		nntp-server (71),
		www-server (72),
		finger-server (73),
		irc-server (74),
		streettalk-server (75)
		streettalk-directory-assistance-server (76)
	(Trac #4286, git 5ed03ed5ea48334bbd16a9a8e1676f3b4cc730a0)

1084.	[bug]		jpopelka
	Added missing slashed in path_replacer.sh.
	(Github #10, git 8986813825623b19fb220534434d0c13785fc14c)

1083.	[func]		fdupont
	Added a concat function in classification which concatenates two
	strings.
	(Trac #4233, git eec10b436b928bd5eb3139c2f98ec9a6a818f30e)

1082.	[func]		fdupont
	Added Not, And and Or logical operators, parentheses around
	logical expressions and option[code].exist logical predicate
	(to check the presence of an empty option).
	(Trac #4231, git 8e01dbe2fe2d8c97f89c20f5bb1d03748a2432e0)

1081.	[func]		tomek
	Client classification in DHCPv4 has been enhanced. It is now
	possible to access relay sub-options using the expression
	relay[123].hex.
	(Trac #4264, git c13791e916ceae9a73ca44005581e0e39385a572)

1080.	[func]		marcin
	perfdhcp now accepts -f option for DHCPv4 server testing, which
	enables lease renewals at the specified rate.
	(Trac #4254, git 8c5630b9ce6d3fba224f0643a7c69e4f7aaefca7)

Kea 1.0.0 released on December 29, 2015

1079.	[bug]		jpopelka
	Fixed compilation issue in MySQL host data source: the
	dhcp_identifier_length is now unsigned long. This addresses
	a compilation problem on Fedora.
	(Github #17, git 8548d1b589df98cc956b4d80d2cb8819ef576717)

1078.	[bug]		fdupont
	Removed warnings emitted during generation of Doxygen documentation.
	(Trac #4234, git b67910a3893bc79eb77a48bae6c31214a317bd40)

1077.	[bug]		marcin
	Addressed regression in distcheck after merge of #4224.
	Before the changes one of the lease files produced by
	'kea-lfc' was not removed after tests running lease file
	cleanup. As a result, the distcheck failed discovering
	this file being left after distclean.
	(Trac #4249, git 04aa9b95bf8c4dd8b555dd78cc8cd57126473800)

1076.	[bug]		tmark
	This change bumps the MySQL schema version from 4.0 to 4.1 and includes
	the following changes: added explicit use of InnoDB engine to all MySQL
	table create statements,  MySQL lease dump output is now sorted by lease
	address in ascending order, and the MySQL lease_hwaddr_source table now
	contains an entry for HWADDR_SOURCE_UNKNOWN (i.e. source = 0). Our thanks
	to Sebastien Couture at Ubity Inc. for reporting the InnoDB engine issue
	and submitting a fix for it.
	(Github #16, Trac #4237,#4238, git f0fb9f35a394785215573a591c2bcc68ab481436)

1075.	[doc]		marcin
	Changed Kea license from ISC to Mozilla Public License,
	v. 2.0.
	(Trac #4236, git a0574cdab4deb31e3244fc4e237753a1ad361d96)

1074.	[bug]		marcin
	PID files created by Kea processes are used in shell based
	tests to determine if the given process is running. This
	solves the problem whereby some unrelated processes could
	be reported as running Kea processes in those tests, causing
	the tests to fail.
	(Trac #4224, git 94edccc50cb374ec4db35f653b869c9f06d356ea)

1073.	[doc]		tomek
	Developer's Guide updated with client classification text
	and several clean-ups.
	(Trac #4102, git ac33ebf7428ba5935d3302d000bed317716fabfe)

1072.	[bug]		tmark
	The lease6 hardware address source value is now being properly populated.
	Prior to this the value stored with each IPv6 lease was always zero.
	(Trac #4247, git 27886dadcf9051dc622ee6fde586c27f3d431f8b)

1071.	[func]		tmark
	Assigned unique log message IDs to log messages issued from
	MySQL hosts storage operations, eliminating reuse of
	lease database message IDs.
	(Trac #4216, git f0e37cd6d45537971a730c68187011dce41217cc)

1070.	[doc]		sar
	Correct v6 classification examples to use client-id (1) instead
	of server-id (2).
	(Trac #4222, git 69dd98d03861d9de72c2ef75c17c8154b0c5088b)

Kea 1.0.0-beta2 released on December 22, 2015

1069.	[bug]		tomek
	Improved handling of incoming packets with invalid client-id
	and DUID.
	(Trac #4206, git 2c94f80e30abe53ae5b677762fc69e888c92e03f)

1068.	[func]		marcin
	Renamed log message compiler binary from 'message' to
	'kea-msg-compiler'.
	(Trac #4228, git bbeb5c776c39b9f4132f7f614720db75590ccef9)

Kea 1.0.0-beta released on December 8, 2015

1067.	[doc]		sar
	Remove description of option[xx].text operator from classification
	until its use becomes clearer.
	(Trac #4218, git 22fe2bf889984078cd86c2a230a038632d21432c)

1066.	[func]		tomek
	Configuration parameters for setting up external hosts storage
	are now implemented. This feature is considered experimental
	for DHCPv4 and currently not really usable for DHCPv6.
	(Trac #3569, git 8896c9c3f77a7836d67e6c33943ac4892b851213)

1065.	[func]		fdupont,tomek
	The DHCPv4 server now stores Relay Agent Information option as
	the last one.
	(trac #4121, git 2f883d4afb9b27c6c59d993692370685b206b6c2)

1064.	[doc]		tmark
	Added Kea logo to documentation.
	(trac #3702, git 7cae813ffe9a7320db5c84ac4beb1c3c0ecabbf7)

1063.	[func]		marcin
	It is possible to disable writing generated DHCPv6 server
	identifier in a persistent storage. This also fixes a
	failing distcheck.
	(trac #4211, git d8f39b7aff9312237d4b6d6de39a7336a25ead4c)

1062.	[func]		marcin
	libeval: options may be referenced by their names in
	expressions used for client classification.
	(Trac #4204 git 38aebe9566e09daa30796df686cfdd6d0c43fa4d)

1061.	[func]		kalmus
	MySqlHostDataSource class implementation. It provides methods
	for adding and extracting Host objects to and from MySQL database.
	(Trac #3682, git 275b40fb941a6934c6434715184ae1c39f3fb3f2)

1060.	[func]		stephen
	Incremented KEA_HOOKS_VERSION to 3 for Kea 1.0.
	(Trac #4208, git bf6f3d495604942a395b51bbe4c37001b7541242)

1059.	[func]		nicolas
	The client packet is now passed as a new parameter "query4"
	to the pkt4_send hook point. Thanks to Nicolas Chaigneau from
	Capgemini for providing this patch.
	(Github #8, git )

1058.	[func]		tomek
	Two new hook points lease4_recover and lease6_recover have been
	implemented. They are called when a declined IPv4 or IPv6 lease
	concludes its probation period and is being recovered into
	usable state.
	(Trac #3988, 3989, git 1930797c48fee7f4006a33cecd6f08b05ae76725)

1057.	[func]		marcin
	It is now possible to specify type and value of a DUID used
	as DHCPv6 server identifier.
	(trac #3874, git faf52b069cf774d0050d76b4f47b542b2b5105f2)

1056.	[doc]		sar
	Added description of the expression based classification
	system to the Kea Admin Guide.
	(Trac #4101, git 3ec88e0669470ab406c45d50d0f853f9aeb3bf04)

1055.	[func]		fdupont
	Classify match expressions are evaluated on incoming packets and
	requested options are appended when configured by the subnet, a
	class or globally.
	(Trac #4097, git 752ad11ff4ebe97ec27d098aff706d1999900346)

1054.	[func]		tmark
	Replaced underscores, "_", with hyphens "-", in the parameter
	names used in the kea-ddns server's configuration as well as
	those in the DDNS messages (NCRs) sent to the server. For
	example, "ip_address" is now "ip-address", "change_type" is
	now "change-type".  This makes JSON element naming consistent
	throughout Kea.
	(Trac #4202, git 91bf527662060d4b1e294cd53e79b431edf0e910)

1053.	[doc]		tomek
	Support for DHCPDECLINE (v4) and DECLINE (v6) messages is
	now described in the Kea User's Guide.
	(Trac #3990, git 6b0db91610420f3cce55d9f887d7c73660ece209)

1052.	[func]		marcin
	libeval: expressions involving options can now use textual or
	hexadecimal format of the options.
	(Trac #4093, git 4cdf0fff1067b3dde6570dc6831e8b1343bc50fe)

1051.	[func]		tmark
	kea-dhcp4 and kea-dhcp6 configuration parsing now supports
	the "client-classes" element for defining client classes.
	(Trac #4096, git d21fd6925983eb20f82029e3866652398ea5e5fe)

1050.	[doc]		tmark
	Corrected the descriptions of ncr-protocol and ncr-format parameters
	in the Kea Admin Guide.
	(Trac #4117, git 034c1c95b57768d5abbc7fb40cc57d7cadad21dd)

1049.	[build]		fdupont
	Add a new --enable-generate-parser configuration parameter
	(disabled by default) which makes flex and bison to regenerate
	parser files.
	(trac #4125, git 18321bf85f93b24d720f1ab2d90b4f4da85bc471)

1048.	[func]		fdupont,tomek
	Implement expression parser for client classification.
	(Trac #4088, git ac9eb312bfd1c6bf22a868ad789a0c049f33f637)

1047.	[func]*		stephen
	Change the way that hooks libraries are defined in the configuration
	file in preparation for allowing the specification of library-specific
	parameters in a future version of Kea.
	(Trac #3259, git b2986b0b0299e691b13123922129bdbf8575afdb)

1046.	[func]		tmark
	Upon startup Kea servers will now detect memfile lease files
	that need upgrading, and will launch in instance of the LFC
	to convert them to the most current memfile schema version.
	(Trac #3601, git ce4b0e42e8a01bbf3b58fdb1f505bbd6e2fad134)

1045.	[func]		tmark
	Added classes for storing client class definitions to libdhcpsrv.
	(Trac #4095, git 1039a942450e2a45a1e1aa9924cae4fdbd1541fe)

1044.	[build]		fdupont
	With the addition of a background thread for timeouts, ensure that
	the configuration and process spawning code are thread safe.
	(Trac #4060, git 4c130bd7c8d0eb97966e9821bab491bca5321b6c)

1043.	[func]		fdupont
	Implemented support for hex strings in client classification.
	(Trac #4091, git 406153af95404adb96296df09ec6033b484586e3)

1042.	[doc]		fdupont
	User Guide: parameters having default values may be omitted in the
	option definitions.
	(Trac #3927, git c7460e849258ec77cf1215a2baf840d98f1ab77b)

1041.	[func]		tomek
	A new library, libkea-eval has been added. It is not functional
	yet, but its purpose is to provide a generic expression
	evaluations that will be used in the upcoming client classification.
	(Trac #4081, git 28d818a26a5d128e8a51d62b68c0cc817e6e2415)

1040.	[func]		tmark
	When kea servers lose connectivity with MySQL or PostgreSQL backends
	they will log an error message and exit with an exit value of 255.
	(Trac #3780, git cf94e99698e1d8a1613026bda5e4fc9bb4a68d74)

1039.	[doc]		marcin
	Configuration parameters pertaining to processing expired
	leases by the DHCPv4 and DHCPv6 server have been documented.
	(Trac #3979, git a2ee99ba313e54a9dcf8a09ed118dbfe612e3d55)

1038.	[func]*		marcin
	DHCPv4 and DHCPv6 servers reclaim expired leases before they
	are re-assigned.
	(Trac #3977, git 5880e706cb27c19b1b70296ccd8d96e38e82027b)

1037.	[func]		fdupont
	Added a new 'leases-reclaim' command which reclaims expired leases
	immediately.
	(Trac #3978, git 9d5716e5bd6b151d90591f8497bae689321875c2)

1036.	[func]		tmark
	kea-admin now supports upgrading from Postgres schema version
	1.0 to 2.0.  Schema 2.0 includes support for lease expiration
	and reclamation.
	(Trac #3969, git 8fde70c1b63b5a2646688290b1d0cf53f4c964ad)

1035.	[doc]		fdupont
	Modified documentation of DHCP options to show internal format
	of records.
	(Trac #4071, git c5cffe74ac1bd38e4870ff1c22c36febb46e8c27))

1034.	[func]		fdupont
	Add support for DHCPv4 subnet selection option.
	(Trac #4058, git b7072884e8ce74dc64cd74e101d81e5c0763f492)

1033.	[bug]		stephen
	Updated OutputBuffer class to address warnings from Coverity.
	(Trac #3443, git 4bf0a14aa7a1303ed6959127c5354687e9f222ba)

1032.	[func]		marcin
	PostgreSQL lease database backend has been extended with new
	functions to obtain expired leases and to delete expired
	reclaimed leases.
	(Trac #3968, git 0bc02588d8553ba9a4fc749115a3e370407d7287)

1031.	[build]		fdupont
	Rewrote the system_messages tool from Python to C++.
	(Trac #3516, git a8195310c641027d1822344cafad64e6f695d614)

1030.	[bug]		marcin
	Fixed failing 'reclaimExpiredLeasesTimeout' unit tests on
	some virtual machines.
	(Trac #4075, git c3a2487f53ecf69edc0a38f574fce17c4332162c)

1029.	[func]		tomek
	A new hook point lease6_decline has been added. It is called when
	the DHCPv6 server is about to decline a lease as a result of
	processing incoming DECLINE message.
	(Trac #3986, git b6e3f1bbe3595aeba769d627d571e2eeee38a397)

1028.	[func]		marcin
	Expired leases are processed periodically according to the
	server configuration.
	(Trac #3975, git 3bd8891c0b9cb7dc504fa69251610996775cefbf)

1027.	[func]		tomek
	Expired declined IPv6 leases can now be reclaimed (returned to the
	available pool) after probation	period elapses.
	(Trac #3985, git 9aadfa902d898ce1f52b773152a5b34519a9a9fe)

1026.	[doc]		stephen
	Added documentation for the kea-dhcp4.commands and
	kea-dhcp6.commands loggers.
	(Trac #3952, git 3eb5d3185683e05494c1d84ed7195627fce4b6c1)

1025.	[func]		tomek
	A new hook point lease4_decline has been added. It is called when
	the DHCPv4 server is about to decline a lease as a result of
	processing incoming DHCPDECLINE message.
	(Trac #3986, git 39bde93fe25e4aff52623d4df7fd55c64e0a9c21)

1024.	[func]*		tomek
	Boolean Skip flag in Hooks API has been replaced by enum status.
	This is backward incompatible change if you developed hook
	library that takes advantage of the skip flag. See Hooks
	Developer Guide for easy steps necessary for migration.
	(Trac #3499, git 99ca398d4d042a098b5c491368733220db8cdd08)

1023.	[func]		tmark
	kea-admin now supports upgrading from MySQL schema version 3.0
	to 4.0.  In addition, the lease6 data dump now contains the
	text label for lease_hwaddr_source column rather than its
	numeric value.
	(Trac #3967, git 2e13ac3b0b278faabe338b00ffee8259c13f5342)

1022.	[func]		fdupont
	Added support for the V4 link selection sub-option (RFC 3527).  If
	present in an incoming packet, the server will allocate an address
	in the subnet identified in the option. If this is impossible, no
	address will be allocated and the request refused.
	(Trac #4057, git 8c02cec5ec8e311a9d23fd582d8e9e8647667abb)

1021.	[bug]		stephen
	Added missing address parameter to ALLOC_ENGINE_V4_REQUEST_OUT_OF_POOL
	message.
	(Trac #3996, git 680233550747209a1707e8f920179479b980aa2a)

1020.	[func]		kalmus
	A general purpose base class for MySQL connection has been
	implemented.
	(Trac #3681, git 884d8bb4a55d3d7b1b8f3f01efb312bd8dec399b)

1019.	[func]		marcin
	Added new configuration parameters controlling processing of the
	expired leases in the DHCPv4 and DHCPv6 server.
	(Trac #3974, git c998d36c40cc46ffe9f888e615bbcfa0a311d40d)

1018.   [func]		sar
	Added support for several options for use by PXE.
	From RFC4578 (for DHCPv4) these are: 93 - client-system,
	94 - client-ndi, 97 - uuid-guid.
	From RFC5970 (for DHCPv6) these are: 59 - bootfile-url,
	60 - bootfile-param, 61 - client-arch-type, 62 - nii.
	(Trac #3576, git fdcc73afe7e26bd427817fd771567b1c44713b06)

1017.	[func]		tmark
	Lease dump SQL logic, used by kea-admin, is now supplied via stored
	procedures rather than external text files.  Files of the form
	lease_dump_<version>.sh will no longer be installed under
	<prefix>/share/kea/scripts.
	(Trac #3916, git 09cdd86a5e284250d7657a93a36df2e2705947d2)

1016.	[bug]		fdupont
	Fixed problems when --enable-static-link is specified as a
	"configure" option. With this switch present, all Kea
	executables (servers, tools, unit tests, etc) are linked
	to the static (vs. shared) version of Kea libraries.
	However, note that they can still be linked to dynamic
	system libraries.
	(Trac #4004, git 760a343efbd241f5ed333cfff088124378f69115)

1015.	[func]		tomek
	Expired declined leases can now be reclaimed (returned to the
	available pool) after probation	period elapses.
	(Trac #3984, #3976, git 32a8ec68e0e5ea93991915812158d7628d2b4709)

1014.	[func]		marcin
	Implemented lease4_expire and lease6_expire hooks in libdhcpsrv.
	(Trac #3972, git 8a8547aec1caf2a8d1c7ca206f68534f3c03f1d9)

1013.	[func]		marcin
	New mechanism for scheduling lease file cleanup is used in the
	DHCPv4 and DHCPv6 servers.
	(Trac #3971, git 431d515fc3d64aa82369c8eaf48d03339f12dc69)

1012.	[bug]		stephen
	Replace #include of message_dictionary.h in message_initializer.h
	with a declaration of the MessageDictionary class, avoiding the need
	to include message_dictionary.h in the set of header files installed.
	(Trac #4046, git 9f1801b4326f62632a7c9f0aa939d58f120c10e8)

1011.	[func]		fdupont
	Added definitions and tests for the options from secure DHCPv6.
	This protocol is still experimental. The option and other protocol
	codes are for testing, they will be updated when IANA assigns
	official values.
	(Trac #4015, git 95f8c0d0af45807c1f303b9bbbb08f82b3bfc343)

1010.	[bug]		tmark
	Fixed test failures occurring for some tests after
	IfaceMgr::closeSockets was called.
	(Trac #4067, git 9161867dc6a354659ae8b5115ee437ec76c1771e)

1009.	[bug]		fdupont
	Now libutil blocks all signals when creating a new thread
	(so signals are delivered only to the main thread).
	(Trac #4065, git a4a8e422e613e4378f0a0641e4c480b73d67ebeb)

1008.	[build]		fdupont
	Removed the included header-only ASIO code.  Kea is now built
	against the installed copy of Boost.  The build by default
	attempts to use the header-only error code (ASIO dependency), but
	may also use the version in the boost system library.  The
	location of this library can be specified.
	(Trac #4009, git 8c293bc0d1804a512964621f114e64fcba0abcb9)

1007.	[func]		tomek
	DECLINE message in DHCPv6 is now supported. The server is able
	to receive it, check its correctness and move the lease to
	DECLINED state. Currently there is no way to recover the lease
	before 'decline-probation-period' time.
	(Trac #3982, git 11e2c4366d8624601172c01e95cff6a8b95833b3)

1006.	[bug]		marcin
	Fixed issues with threads concurrency in the TimerMgr.
	(Trac #4047, git 48297af6e0443808a482536b61436a42bc6a5b38)

1005.	[func]		tomek
	DHCPDECLINE message in DHCPv4 is now supported. The server is able
	to receive it, check its correctness and move the lease to
	DECLINED state. Currently there is no way to recover the lease
	before 'decline-probation-period' time.
	(Trac #3981, git c14a63c0d3a56ea3e880e874f854adc0077de75e)

1004.	[bug]		fdupont
	Incoming Confirm, Rebind and Information-Request messages are
	now more thoroughly checked against presence of client-id
	and server-id options.
	(Trac #3773, git fd2889b9de45e2822b6713663bee06b75259c6dc)

1003.	[build]		fdupont
	Updated Makefiles to ensure that all required dynamic libraries
	are included in the link command line as some systems are unable
	handle implied library dependencies.
	(Trac #3911, git 4d13f5234da33df03c0989829a0e1c1056e53a4e)

1002.	[func]		marcin
	MySQL lease database backend has been extended with new
	functions to obtain expired leases and to delete expired
	reclaimed leases.
	(Trac #3966, git 419832a6279c70b5db04b1cab10737e31f2c99f9)

1001.	[build]		fdupont
	Fixed critical C++ issues in the Kea code. This does not cover
	auto_ptr warnings (just ignore them) or the gtest 1.7.0 bug with
	EXPECT_TRUE() and ASSERT_TRUE() macros (we recommend to download
	last subversion sources at http://googletest.googlecode.com/svn/trunk
	and use the --with-gtest-source configuration argument when
	you'd like to build unit tests).
	(Trac #4024, git 55afd98fead0c16bb81107dfc1a5f49a5e295aa6)

1000.	[func]		marcin
	Implemented Timer Manager which holds the pool of interval
	timers used by the DHCP servers.
	(Trac #3970, git bc8503055338da36d07a2b67c64087f645c9a9e3)

999.	[func]*		tmark
	The DHCPv4 server will now honor DHCPRELEASEs for leased addresses
	which cannot be matched to subnet.  This allows leases to be
	released after configuration changes have eliminated their subnet.
	Prior to this the server would reject the release and emit a
	DHCP4_RELEASE_FAIL_NO_SUBNET log message.
	(Trac #2615, git eeebf9f68cf5be6a0f7eefc78832d664361c4990)

998.	[func]		tomek
	'decline-probation-period' parameter has been added to DHCPv4
	and DHCPv6 configuration. It can be configured, but is not yet
	used, as the DECLINE message support is still pending implementation.
	(Trac #3983, git 6b10d119c89685476335f268181c9982f6fa6161)

997.	[build]		jreed
	Removed obsolete Python coverage build options.
	(Trac #3483, git a08cbbecbd3b11d0b73f68a40986a353b22ed3be)

996.	[func]		marcin
	Memfile lease database backend has been extended with new
	functions to obtain expired leases and to delete expired
	reclaimed leases.
	(Trac #3965, git dd5b95453528416f22e961e6ebb3051bc2ae788c)

995.	[build]		fdupont
	Removed additional files left over from BIND 10 (headers,
	src/lib/{asiodns,testutils,asiolink}).
	(Trac #40{28,29,31}, git 78ff0fb0a97731a8b3c055b1cbb4faebcd115f7c)

994.	[func]*		marcin
	DHCPv6 server fully supports RFC 7550.
	(Trac #3947, git c06ab97a4e068c4b4b11f4685c56dd402b2385dc)

993.	[bug]		fdupont
	The logging spec file was searched in the build tree when it
	was in the source tree so distcheck (where they differ) failed.
	(Trac #4026, git 5eb213647d7ac0a707530d57af2c6dbd725ac1b3)

992.	[func]		fdupont
	A 'flush' parameter has been added to logging configuration. It is
	now possible to disable automatic immediate flushing to achieve
	better logging performance.
	(Trac #3752, git 16c4c2b6d95c45864ec3e2b27e0d320e386b2c0b)

991.	[build]		fdupont
	Removed partial function template ordering macros to allow Kea to
	build with Boost 1.59 and later.  Also removed some
	compiler-dependent code.
	(Trac #4006, git e06934f211436eea37439128ff6f388709f01101)

990.	[bug]		tomek
	Improved child process signal handling. Improved number of
	exception handling routines in DHCPv4 and DHCPv6.
	(Trac #4000, git bf5e48f2cf80b5263cc89f445795bc8c5b8f011d)

Kea 0.9.2 released on July 28, 2015

989.	[bug]		tmark
	Fixed a bug in both DHCPv4 and DHCPv6 servers that could cause
	them to crash during sever shutdown when DNS updates are enabled.
	(Trac #3997, git ce91bdd78f420f64324c573a952ec804bc25e0d8)

988.	[bug]		fdupont
	keactrl no longer returns an error when the "status" command is
	issued and the Kea configuration file doesn't exist.
	(Trac #3785, git a27d72ef3cb7640a41dca26c8728a9cbd9ad1ca9)

987.	[bug]		marcin
	Fixed textual representation of the options containing an array
	of 1 byte long unsigned numbers.
	(Trac #3959, git 9045fd9d6d282184cce10a622c0108abab029d5b)

986.	[bug]		marcin
	Fixed the failing lease allocation from the large address and
	prefix pools.
	(Trac #3958, git c86b6a68725e2f57679598ff4890fc82f4482c20)

985.	[bug]		marcin
	Eliminated extraneous debug-level DHCP6_RESPONSE_DATA entry from the
	DHCPv6 server log output.  Prior to this the server was logging
	each response twice.
	(Trac #3949, git 023973cbce44e5fb92a2bc45e69f2786d5152091)

984.	[bug]		tmark
	Replaced used of "kill -0" with "ps -p" in keactrl when
	checking of servers are alive.  This makes it possible for
	non-root users to use keactrl to monitor server status.
	(Trac #3954, git f7f22b244343a3dc2d06645a47c2c65a5134326e)

983.	[bug]		fdupont
	Enforce numeric month values in Posix date printing.
	(Trac #3944, git fdbe74b0235055057a37c6ce2b0aaf88f0cc7891)

982.	[bug]		marcin
	Fixed the typo in the name of the D2 logger.
	(Trac #3951, git 92305b2a1774df1cf1bdfeb93d787fea0ab27f74)

981.	[bug]		tmark
	keactrl now uses PID files to identify and control server instances.
	Prior to this it relied on the system command, "ps", which could lead
	to it misinterpreting which processes are or are not running.
	(Trac #3939, git 93a720ed7ffdffe66bd835cd64f78e4ad601637a)

980.	[doc]		marcin
	Updated Developer's Guide.
	(Trac #3484, git 220c337c31a592311363eca981c7f1578abbe15d)

979.	[bug]		fdupont
	Fixed two cases of public variables in a base class being
	hidden by variables in a derived class.
	(Trac #3920, git bd42a66fb67aab3fe397523c6fdbf14a939587c8)

978.	[func]		tmark
	DHCPv4, DHCPv6, and DHCP_DDNS now all create PID files upon
	startup.  The PID file pathname is formed from:
		<localstatedir>/<conf name>.<binary-name>.pid
	If a server's PID file exists and contains the PID of a
	live process, it will emit a log message and exit.
	(Trac #3769, git cdce632add025aaadbcdc89078f5bd3e19cfb5ca)

977.	[doc]		tomek
	Frequently Asked Questions section added to the Kea User's Guide.
	(Trac #3873, #3847, git 95683c9d3c3dd7024269df1904b6cbe5817741a2)

976.	[build]		tomek
	Included missing Doxygen documentation images in the tarball.
	(Trac #3928, git 2fb63a18897b93b12a5fc4635d4ac29e0bf82841)

975.	[doc]		marcin
	Updated the list of standard DHCPv4 options in the User's Guide
	with the information of whether they are returned by the server
	even when they are not requested.
	(Trac #3578, git b361b28ce53729a5f2d59f79670a36cf1a4a0352)

974.	[bug]*		marcin
	Corrected invalid format of the DHCPv4 option 5 (name-servers).
	The corrected format comprises a list of IPv4 addresses,
	rather than a single IPv4 address.
	(Trac #3887, git 54d1dbe6138e74c5efacfbaf85b77c87aea9ddf1)

973.	[doc]		marcin
	Added new section to the User's Guide to describe the issues
	with unicast responses to the DHCPINFORM messages when ARP
	traffic is blocked.
	(Trac #3740, git 22bcb060ceca544dfa1779815321155668bf19dc)

972.	[doc]		marcin
	Updated sections of User's Guide concerning creation of
	the option definitions and Vendor Specific Information
	options for both DHCPv4 and DHCPv6.
	(Trac #3846, git 6aebe0867ca9cf6fb09a289d80051125db7fa34b)

971.	[func]          fdupont
	Changed all occurrences of unlink() to the more portable remove()
	to avoid problems on operating systems where the former is not
	available.
	(Trac #3841, git 3752529ed3d72137f6899ef8225a0b231db5b1f0)

970.	[bug]		fdupont
	Refactored some code to suppress cppcheck warnings.
	(Trac #3919, git 26be6ac4cefde012ca8ef12607b6beaadca13eed)

Kea 0.9.2-beta released on June 30, 2015

969.	[func]		tomek
	KEA_SOCKET_TEST_DIR environment variable can be used to specify
	the directory for opening Unix sockets during tests. That may
	be used to avoid path length limitations when running unit-tests
	in deeply nested directories.
	(Trac #3918, git 9cfd502e8d4605eaf34f8744f90272dc3e8a3e34)

968.	[bug]           marcin
	DHCPv6 server extends the lifetime of the client's lease
	in the database when the client sends the Request message.
	This prevents premature lease expiration before the client
	renews the lease, according to the timers and lifetimes
	returned by the server.
	(Trac #3913, git 1d64829a3f1a8288dc833ed388d9ffc9fe4cf491)

967.	[doc]		tomek
	Management API section added in the DHCPv6 chapter of the Kea
	User's Guide
	(Trac #3917, git 21305d2da26090e3fad1ff9fb242a2bbb6b7e56b)

966.	[func]		fdupont
	Include database software details in extended version information.
	(Trac #3882, git b0e166c4d8b0383ebd6e2f51d55eed68a2bcafa8)

965.	[func]		sar
	Per IPv6 subnet statistics (subnet[id].assigned-nas,
	subnet[id].total-nas, subnet[id].assigned-pds, and
	subnet[id].total-pds) has been implemented.
	(Trac #3799, git 4aa4808268bbc54290578f60ba60ed33cf344712)

964.	[doc]		tomek
	User's Guide and Developer's Guide updated with statistics and
	control channel description.
	(Trac #3800, git 7ce8ca560370ec5f9bd4d5199a177b441f08a47e)

963.    [func]		tmark
	DHCPv6 server now supports a control channel, implemented over
	a UNIX socket. Currently supported commands are: statistic-get,
	statistic-reset, statistic-remove, statistic-get-all,
	statistic-reset-all, statistic-remove-all, and shutdown.
	(Trac #3797, git f49828612d9030c9f3441acaf4b3a9f60b492a3e)

962.	[func]		fdupont
	Make the parsing of options and vendor options more consistent
	between v4 and v6. In addition make the parsing more robust
	against malformed packets.
	(Trac #3618, git f4066793c5e034386c689fd72d2a91a70ffb6d5f)

961.	[func]		fdupont
	Improved error messages when handling invalid or malformed
	configuration file. File and line number are printed, when
	available.
	(Trac #3697, git 70fc36e164e988c251bdaaee7e27c5f6407e0f4c)

960.	[build]		fdupont
	Get rid of the last bundy pieces of code.
	(Trac #3732, git 6b7da42f902fabb6855e54a19ea472c18ba82a93)

959.	[build]		fdupont
	Removed no longer used logging in cc and config libraries.
	(Trac #3732, git 8d0324f4786900db953489ebaa9e018b1238543f)

958.	[func]		tomek
	DHCPv4 server now supports control channel, implemented over UNIX
	socket. Currently supported commands are: statistic-get,
	statistic-reset, statistic-remove, statistic-get-all,
	statistic-reset-all, statistic-remove-all, shutdown.
	(Trac #3880, git 688658395518f0b97d5384af81ceab5206691ad5)

957.	[func]		tomek
	Per IPv4 subnet statistics (subnet[id].assigned-addresses and
	subnet[id].total-addresses) has been implemented.
	(Trac #3798, git bab2030f56bbf390959f9f9238a8acc62d583c70)

956.	[func]		marcin
	Improved log messages emitted by the allocation engine,
	which now uses a dedicated logger.
	(Trac #3852, git 923928774f4f59c887d768cf155b5978e838a6f2)

955.	[func]		tmark
	Added unit tests to kea-admin for testing the lease-dump command
	with a PostgreSQL backend. Updated PostgreSQL database installation
	instructions in Kea Administrator's guide to include use of kea-admin
	tool.
	(Trac #3884, git 0772b7df2a89e1019141be1d0ddec30d53c4b919)

954.	[func]		fdupont
	Enhance the versioning information printed by the executables and
	make it more consistent across all of the executables. "-v" is for
	basic Kea version information, "-V" provides more detailed
	versioning and versions for external dynamic libraries, finally
	"-W" provides the configure report from the configuration step
	during the build of Kea.
	(Trac #3513, git 584cf666e101c6cb5c9af76175ddd867ece85764)
	(Trac #3859, git 384e6c6225de18fc97d606e4a1972baeef598ba4)

953.	[bug]		fdupont
	Corrected the setting of string characters to values above 127
	in HMAC tests.
	(Trac #3829, git 54f4ec64e513fea1547631122dc1af8579fae3db)

952.	[bug]		fdupont
	Made some loop indexes an unsigned type to avoid compiler warnings
	where the termination condition is comparison with an unsigned
	value.
	(Trac #3833, git 3db9f1d78f59856b982a1ff84c3b5a1ba7ea39df)

951.	[build]		fdupont
	Removed BUNDY configuration backend.
	(Trac #3732, git 96364cbbb15318c8f55d5b287cda0990d3eaae32)

950.	[doc]		marcin
	Updated section about logging in the User Guide. Also,
	updated Hooks Developer's Guide with the recommendations for
	the developers about use of logging in hooks libraries.
	(Trac #3805, git b403de1f335a2fb5098c9abc0858b8137892f868)

949.	[func]		tmark
	kea-admin now supports dumping MySQL and PostgreSQL lease tables
	to CSV file, via a new command "lease-dump".  This is primarily
	intended for use as a diagnostic tool.
	(Trac #3802, git 6ec774e8523e7f8415d6cd18c34062489e127847)

948.	[bug]		fdupont
	libdhcpsrv: check if new host reservation tries to use an already
	reserved address.
	(Trac #3652, git 4f10b78341b197bd321fbf2ec71db7420e40718d)

947.	[func]		marcin
	DHCPv6 server now supports Rapid Commit option.
	(Trac #3070, git a6b6156aaa95ab74c69a537e90483f82e9fbe4a2)

946.	[doc]		tmark
	Added documentation for kea-admin "lease-dump" command to the
	Kea Admininstrator's Guide and kea-admin man page.
	(Trac #3803, git 54b59b7ef02f6428405794066ea779e9bd4c0b6e)

945.	[func]		marcin
	Improved log messages emitted by the DHCPv6 server. Also,
	the server is now using multiple distinct loggers for logging
	messages pertaining to different functional parts of the
	code, e.g. packet transmission, lease allocation, DDNS etc.
	(Trac #3807, git c95ebdaf39c3d8d78d83d53db15824c60078f566)

944.    [func]      tmark
	kea-admin commands lease-init, lease-version, and lease-upgrade
	now support PostgreSQL. Note that at this time the PostgreSQL
	backend only supports Kea schema version 1.0, so there are no
	upgrades available.
	(Trac #3883, git 990a0d72fa247e4a12e2608994204c48274e4cd6)

943.	[func]		sar
	Split the DHCP-DDNS logging messages amongst several loggers to
	allow the administrator finer control over debugging messages.
	Messages pertaining to the name change requests processing include
	an ID, currently the DHCID, to identify the transactions.
	(Trac #3808, git 4fbe08234049de6ef67bb5cdb244d180a7a4c3a9)

942.	[func]		tomek
	18 new statistics added in DHCPv4 server: generic packet counters,
	per packet type counters, parsing failure and packet drops.
	(Trac #3794, git a61f40c44910a09699a9a566a5ec35ab758564ba)

941.	[bug]		marcin
	Configuration parser for host reservations returns an error
	when an unsupported parameter is specified.
	(Trac 3810, git 54ee0f6328a303c366dd8239e768dfc4a23a5d9b)

940.	[bug]		fdupont
	DHCPv4 server drops DHCPRELEASE messages sent from a bad
	location (i.e., no subnet can be selected)
	(Trac 3504, git f0f13ac74779f76ed7af91bd5dab3d11ba00be79)

939.	[bug]		fdupont
	Small fix in HooksDhcpv4SrvTest.subnet4SelectSimple unit-test.
	(Trac 3881, git a21afdffec41fceb61e6760d4108d670b2eabe75)

938.	[build]		fdupont
	Removed Python from the log library (code, message compiler and
	documentation)
	(Trac #3734, git d24b7c9716c6eb7a3e9dd2cb3fd2d1bfe4e1201f)

937.	[bug]		fdupont
	The log ID LOG_UNRECOGNISED_DIRECTIVE was changed to
	LOG_UNRECOGNIZED_DIRECTIVE to follow US English spelling.
	(Trac #3762, git 235e3304746352e9341008225f9f2392586a9f66)

936.	[bug]		fdupont
	Added an ASSERT to avoid a crash in HooksDhcpv4SrvTest
	subnet4SelectSimple unit test. Fixed out of bounds vector accesses
	in perfdhcp (which should not be able to handle links
	with long (i.e., more than 6 bytes) link-layer addresses).
	(Trac #3868, git c20f47e19d6060605c0611754db7b66b08553caa)

935.	[bug]		fdupont
	Fixed 3 out of bounds accesses on vectors in DHCP++ code.
	(Trac #3854, git de263ad0008f3494a85592f78db1ec662b68e689)

934.	[bug]		fdupont
	Renamed the DHCP-DDNS constant INVALID_SOCKET to SOCKET_NOT_VALID
	to avoid conflicting with a constant of that name defined on some
	operating systems.
	(Trac #3861, git 28205225ceed03ff3126e43cd06cedbaa7d8d657)

933.	[func]*		marcin
	DHCPv4 server by default identifies a client using the
	client-identifier, if present. The new configuration
	parameter 'match-client-id' allows for disabling this
	behavior, i.e. 'chaddr' field is used to identify the
	client instead.
	(Trac #3747, git b9dc6ffd0f3396e9da8e0c83fd82164b8b8af011)

932.	[func]		kalmus
	MySQL schema has been extended with tables that can store
	host reservation. This ticket updates database schema only,
	the tables are not in use yet.
	(Trac #3567, git d2cd5d53b3f31422a342c9bb8946dad9ed1ea032)

931.	[func]		marcin
	Improved log messages emitted by the DHCPv4 server. Also,
	the server is now using multiple distinct loggers for logging
	messages pertaining to different functional parts of the
	code, e.g. packet transmission, lease allocation, DDNS etc.
	For complete list of logger names see User Guide.
	(Trac #3806, git 7b148c2dd5e2696a541883223ce1efd2de81f143)

930.	[func]		tomek
	Statistics Manager is now implemented. There is a new library
	libkea-stats that governs statistics collection. Its usage will
	be added in the upcoming tickets.
	(Trac #3793, git 68e9554ecabfc2a79731eeec1c706522e4d39332)

929.	[build]		fdupont
	Corrected problem in build system whereby specifying an
	installation directory on the "configure" command line that
	included a "+" in the name caused the build to fail.
	(Trac #3713, git 741ff09b743307bad28ae13db440e5e0f402d319)

928.	[build]		fdupont
	A CONFIG_H_WAS_INCLUDED define has been added to provide
	a way in source files to check whether config.h has been included.
	(Trac #3812, git cbb135d5f217b0692dcdbc9cfcc04f6a0dbc3922)

927.	[bug]		tmark
	DHCPv4 no longer attempts to update the lease database with the
	generated FQDN when processing DHCPDISCOVERs.
	(Trac #3779, git 0b413ee8aba1afa1643b216a1e8c35103c6c975b)

926.	[bug]		marcin
	Fixed the crash during the logging deinitialization.
	(Trac #3823, git 435b958860ec7b921645bd5923fff96ea4341f19)

925.	[func]		marcin
	libkea-hooks logs when the callouts execution begins or ends
	for the particular hook. It also logs the execution time of
	individual callouts and the total time for all callouts.
	(Trac #3804 git dd1432d7807e7d3b54c87dd4b3155d3110619fbd)

924.	[bug]		marcin
	Removed shell warning about the "missing format character"
	in the keactrl usage.
	(Trac #3784, git aa683395a4cd75af5340eb8603fe46b7b0dd8f4e)

923.	[func]		tmark
	The DHCPv4 server now logs packets it has either dropped as invalid
	or to which it has replied with a NAK to a separate logger,
	"kea_dhcp4.bad_packet".
	(Trac #3743, git cb91ca851099423e1b6c39cca3f3e2ba29795a51)

922.	[build]		fdupont
	The config.h file should never be included by another include file.
	Copy missing header files to the install directory.
	(Trac #3782, git ea6e9d166faa54b1f9781bc56d7d8fee6c87b1f9)

921.	[func]		marcin
	libdhcpsrv: Added log traces to the host manager.
	(Trac #3699, git 75b75c89db88eb1a81e76f5550f2a5b3155ce42d)

920.	[bug]		marcin
	Corrected issues with logging initialization in hooks
	libraries. The dynamically loaded hooks libraries may now
	define their own loggers which are configurable using Kea
	configuration file.
	(Trac #3198, git 8216a6b1a2ed6e2b38919280809ee21fc4107fd6)

Kea 0.9.1 released on March 31, 2015

919.	[doc]		stephen
	Corrected some configuration examples in the documentation.
	(Trac #3772, git e9f084525bc1eec1cca635c00f33228bf7fac6a4)

918.	[func]		tomek,tmark
	DHCPv6 server now supports static reservations of hostnames
	for clients.  Note this resolves #3708 by reducing the number
	of calls to selectSubnet to once per client request.
	(Trac #3689, git c13c824d9948f7e3f71a65ed43798f3b5c14042c)

917.	[bug]		marcin
	DHCPv4 server may allocate lease for the client which is
	using a non-unique identifier (HW address or client id),
	if the other identifier is unique.
	(Trac #3768, git 0f7a029e2a2a7652d49a0bcd9f49e879fac9136f)

916.	[func]		sar
	Add a log message that indicates when the v4, v6 or
	DHCP-DDNS server has completed processing its
	configuration and is about to enter the loop to process
	messages.
	(Trac #3755, git c71c7836804842bae51fe79fd599c57f5b3d007d)

915.	[func]		tomek, marcin
	The DHCPv6 server now supports the Relay-Supplied Options
	option,	as defined in RFC 6422. The relay can insert options
	in the relay forward message that the server will send back
	to the client if certain criteria are met.
	(Trac #3705, git 4772ee589712f5359ecbd79ebf71fbc7bb68741b)

914.	[bug]		marcin
	DHCPv4 server: corrected the logging message issued when
	the server could not allocate or offer the lease for the
	client. The corrected message contains the client-id,
	hardware address, ciaddr and requested-ip-address.
	(Trac #3737, git 4c56e1348c5d50eaa5b3083a0a8c346966e1b603)

913.	[bug]		sar
	Handle recovery properly should the LFC crash while
	manipulating files after completing processing.
	(Trac #3759, git bb3b4d14119392261a1766da2b406fa46d4c0f21)

912.	[doc]		sar
	Added sections on LFC to the administrators and developers
	guides.
	(Trac #3720, git 828b801e6a4616de331588076ab9c4c35677595)

911.	[func]*		marcin
	libdhcp++: the C++ objects representing network interfaces
	(Iface objects) are now non-copyable. As a result, the API
	of the Interface Manager functions returning the pointers
	to the Iface objects has changed.
	(Trac #3715, git 7415c74e38e13385a75e7200cb23b7d6ca86df7f)

910.	[func]		marcin
	DHCPv4 server supports static reservations of the hostnames
	for the clients.
	(Trac #3688, git b5c50e2aff64da05b439da8d5fa4913fc8a704ca)

909.	[bug]		marcin
	Removed many cppcheck errors in the code. Also removed the
	dhcp-ubench test tool.
	(Trac #3736, git 552aea126e968b78292ae80c1c6a03c9ef4dcdcd)

908.	[bug]		marcin
	Handle overflows during time conversions in the MySQL and
	PostgreSQL lease database backends.
	(Trac #3673, git 27b4e4590fdee507f0e877d7b771dc6c6457a4b5)

907.	[doc]		tmark
	Corrected depictions of kea-admin command line options for
	database-name in Kea Administrator Reference. Prior to this
	the document showed "-d" as the database name option, when
	in fact it is "-n".
	(Trac #3742, git ec427e4c9d008abc800f87eda3c0024b35e4c2e2)

906.	[doc]		tmark
	Added description of a restriction on extracting a MAC
	address from an IPv6 link-local address to the Kea
	Administrator Reference, section 8.8, item "ipv6-link-local".
	(Trac #3691, git ca9f5541cb36f815ac614c5c21088d545eafcac6)

905.	[func]		marcin
	DHCPv4 server assigns an address from the dynamic address
	pool if the reserved address is in use by another client.
	(Trac #3694, git 95b09ff53b941691cba172c933de0682b05a0d85)

904.	[bug]		marcin
	FreeBSD-only change: Disabled unit test expecting the death
	of the process when conditional variable was destroyed when
	the thread was still waiting for the variable. This is due
	invalid behavior of the pthread_cond_destroy on FreeBSD
	which should return EBUSY in such case, whereas it returns
	success error code.
	(Trac #3710, git bdb442402ef023055715baf597c401c9974a7fb2)

903.	[bug]		stephen
	Corrected arithmetical error in the rate control module of
	perfdhcp which led to the incorrect calculation of the rate
	at which packets should be sent.
	(Trac #3729, git bb5bca3d9b68abc4b83abdd204bfb075dda630ac)

902.	[bug]		marcin
	Fixed the bug in the DHCPv4 server whereby the server
	reconfiguration (using the SIGHUP signal) failed because
	of sockets remaining open since the previous configuration.
	(Trac #3730, git 3ceb0cd97cf5e44e8fc151d0a38db553530dd3ed)

Kea 0.9.1beta released on February 18, 2015

901.	[bug]		tomek
	Previously, the DHCPv4 and DHCPv6 servers gave up after
	100 failed lease selection attempts. Now both DHCPv4 and
	DHCPv6 servers calculate the number of attempts required
	to find a lease using the pool capacity.
	(Trac #3711, git cb5533a1bf1023faf61c1b8ade6ac8fa425f46c2)

900.	[doc]		marcin
	Documented configuration of the Lease File Cleanup (LFC) in
	the Kea Administrator Reference.
	(Trac #3672, git da3c676f009785204f9d84ca008890959bffcc18)

899.	[func]		tomek
	reservation-mode parameter has been added to DHCPv6 server.
	It controls what host reservation types are allowed and may
	improve performance in certain situations. It is also
	accepted in the DHCPv4 configuration, but currently not
	used.
	(Trac #3565, git cfbe13ad05aac23e09357fc78507cf9a82c908e6)

898.	[func]		marcin
	The DHCPv4 server configuration allows for opening multiple
	sockets on a single interface with multiple IPv4 addresses
	assigned. This facilitates the use case when different relay
	agents send messages to different addresses on the interface.
	(Trac #3695, git 3116243706a2dbcae3f9b5b3af9d2241a07b9ab2)

897.	[bug]		fdupont
	Removed a double free of the read_buffer_ field of Iface
	objects after (spurious) copy (partial as copies are not
	yet fixed).
	(Trac #3712, git 0b38ff6a6e77eb4182bfd7c0c681bef22ad5f634)

896.	[bug]		fdupont
	Removed exit() in D2 for version command line processing.
	This interfered with how the unit-tests were run.
	(Trac #3616, git 758a61e277675e89d857a22c3f8e844de307dca6)

895.	[doc]		tomek
	Host reservation for DHCPv4 and DHCPv6 is now documented.
	(Trac #3575, git a981e42eb0f39d27795364a6862b3a5e574e540a)

894.	[bug]		fdupont
	Accept empty options or sub options in DHCPv4 messages unpacking
	routines.
	(Trac #3661, git 42a4854208ec16834c590a9316b9a5306c60a3bb)

893.	[func,bug]	fdupont
	Changed the qualifying-suffix parameter in the dhcp-ddns
	configuration element to be mandatory with no default value when
	updates are enabled (i.e., the enable-updates mandatory parameter
	is true).
	(Trac #3632, git 12808651448837c611e4f6a262f7a1eb3deaf8da)

892.	[func]		sar
	A class, LeaseFileStats, has been added to provide simple
	statistics for use with lease files.  Also added logging
	to the kea-lfc process per the design.
	See http://kea.isc.org/wiki/LFCDesign for the design.
	(Trac #3667, git 7f36e034fe79d85f317d7d07e2fe636d6cdf1f6e)

891.	[func]		tomek
	libdhcpsrv: Allocation Engine now uses statically assigned
	addresses when processing DHCPv6 renewals.
	(Trac #3677, git 9ce50790c91624937ff2b622e4afff36d5d3cc2d)

890.	[func]		marcin
	It is now possible to specify whether the DHCPv4 server
	should use raw sockets or IP/UDP datagram sockets to
	receive and send DHCP messages. The configuration format
	has been changed for the selection of interfaces on which
	the DHCPv4 and DHCPv6 servers should listen. The
	configuration files using an old format are incompatible
	with the latest version of Kea.
	(Trac #3604, git c726bbc4eae0f576f6791c7490bfba8c30a401d9)

889.	[bug]		marcin
	Resolved a bug in the DHCPv4 allocation engine whereby the
	client could request and obtain an address reserved for
	another client.
	(Trac #3690, git 1afa4e24b0fcdd6d3a2e596663ce1102ffe2340d)

888.	[func]		marcin
	DHCPv4 and DHCPv6 servers launch the kea-lfc program, according
	to the value of lfc-interval configuration parameter for the
	Memfile lease database backend.
	(Trac #3669, git c92665ce05d71e9e5cad9a0679018e9e3f7e3be5)

887.	[func]		sar
	A new process, kea-lfc, has been added. It is meant to
	be periodically executed by the DHCPv4 and DHCPv6 servers
	to remove redundant information from the lease files.
	See http://kea.isc.org/wiki/LFCDesign for the design.
	(Trac #3664, git cc85938b35e2d4bd00ccb74f1b83d3017ab0e41b)
	(Trac #3665, git b1707981f48b13895b50bf27176dede866576292)
	(Trac #3687, git 1e92382aaa2fbff08bbf1d6bbf0add195a7b6fae)

886.	[func]		tomek
	libdhcpsrv: Allocation Engine now uses statically assigned
	addresses when it allocates leases for the DHCPv6 clients.
	(Trac #3563, git b86b24fd011c0617515d62b7091d56fdfd1a7360)

885.	[func]		tomek
	Information-Request (stateless mode) in DHCPv6 is now supported.
	(Trac #2949, git 3185d229c39ed4660e9bc98a7f4a9d0dfbe64a04)

884.	[func]		marcin
	The DHCPv6 server configuration now allows for defining a pool
	for prefix delegation in which prefixes do not match a
	subnet prefix.
	(Trac #3647, git 5455d96cbf773e678bd6b1c3e31bfdeb617e6c13)

883.	[bug]		marcin
	libdhcpsrv: Prevent infinite loops in the allocation engine,
	when the address pool becomes exhausted.
	(Trac #3692, git f1e464558c89a6dc88ab28a25dd14a65fee62578)

882.	[func]		sar
	A utility class has been added which handles writing and
	deleting pid files as well as checking if the process with
	the given pid is running.
	(Trac #3687, git 1e92382aaa2fbff08bbf1d6bbf0add195a7b6fae)

881.	[func]		kalmus
	Extracting hardware/MAC address from the DHCPv6 remote-id
	option is now implemented.
	(Trac #3552, git 6db5fc158133b3f308c43f1fe2fa54a6f89baae1)

880.	[doc]		tomek
	kea-admin is now described in Kea User's Guide.
	(Trac #3644, git fa83c48826e41663d93e56ec7fd6983e9b0b2cd1)

879.	[bug]		fdupont
	Drop DHCPREQUEST message from an unknown client in the
	INIT-REBOOT state.
	(Trac #3656, git 8e205adc35d8e72d1802d5ee9056e6c4ac78274a)

878.	[func]		marcin
	DHCPv4 and DHCPv6 server now support the lfc-interval
	parameter which configures the interval in which the
	Memfile lease database backend executes the Lease File
	Cleanup (LFC). Note: the LFC is currently no-op and will
	be implemented shortly.
	(Trac #3668, git 2ce54eeb607d2caa0901125b5d86a373e9e3f165)

877.	[func]           marcin
	DHCPv4 server drops unicast packets sent to the IPv4 address
	on which the server is not configured to listen.
	(Trac #3547, git 803f1f0f145b0f252ffc3637f758a47e0061de85)

876.	[func]          tomek
	Two new MAC acquisition methods implemented for DHCPv6:
	docsis-modem (which extracts MAC address from an option inserted
	by a cable modem) and docsis-ctms (which extracts MAC address from
	an option inserted by CMTS which acts as a DHCPv6 relay agent).
	(Trac #3553, git ad0a3772774bc5f9831a5ba16725a5a22887b8cb)

875.    [bug]           afidalgo, marcin
	The DHCPv4 server no longer appends the trailing dot to the
	hostnames sent to the clients in the Hostname option (12).
	Appending trailing dot confused some DHCPv4 clients.
	Credits to Alexis Fidalgo for submitting a patch.
	(Trac #3636, git 450867e6987f4c786ad6c2cc95cabcff601c1b48)

874.    [func]           marcin
	Changes to the Memfile lease database backend to load
	leases from multiple files during startup or server
	reconfiguration. This change is required by the Lease File
	Cleanup feature, which leads to the creation of additional
	files holding cleaned up lease information.
	(Trac #3671, git 667de2ef9044e97c76b15cacc7285132cdffdfcf)

873.    [bug]           wlodek
	Removed references to non-existing pgsql_test.sh script
	from Makefile.
	(Trac #3662, git ab69f38dd82cf3c3736588e03c1dc568de3ae6d6)

872.    [func]          wlodek
	Check for required header file errcode.h for PostgreSQL
	backend added to configure process.
	(Trac #3663, git d666dd9263ba1aaf88bec5b8e5ae3f0cb8e5c1db)

871.	[func]		kalmus, tomek
	DHCPv6 is now able to extract MAC from DUID-LLT and DUID-LL.
	(Trac #3548, git f6d9630e2762a0f256a2b7825d74d2bce8fe4c60)

870.	[func]		fdupont
	Cleanup the cryptolink API (e.g., removing spurious 'magic'
	zero length parameters).
	(Trac #3606, git 55d2df9d78321b3844217055e376ae44ac962d8f)

869.	[func]		tomek
	'mac-sources' configuration parameter added. The DHCPv6 server
	can now be configured to use various MAC/Hardware address
	sources.
	(Trac #3554, git 2e7c32e7c19372f0c97968ef7c8256509d80fdfc)

868.    [func]          marcin
	DHCPv4 server configuration allows for selection of the
	address on the interface that server should listen on.
	This is specifically useful in the environments with
	multiple IPv4 addresses assigned to one interface.
	(Trac #3539, git ff71887c605eedc3914bacfd2e551da7bddcc0d6)

867.	[func]		marcin
	libdhcpsrv: Allocation Engine uses statically assigned
	addresses when it allocates or renews leases for the
	DHCPv4 clients.
	(Trac #3564, git 7b192fe314c12e38622742b3b338e997934f862f)

866.	[doc]		stephen
	Corrected documentation concerning the way to configure hooks
	libraries.
	(Trac #3635, git 42d1c98a2e66ab7fc3e372365edad1f5709df885)

865.	[func]		marcin
	Host reservations can be specified in the DHCPv4 and DHCPv6
	servers configuration. The reservations are loaded, but they
	are currently unused.
	(Trac #3562, git 1ba5ec3b7831ef8126be17b9542d9b89a419e7dd)
	(Trac #3628, git 00b49298ec5e5e5c722e5938547c86c954fc76e1)

864.	[func]		tomek
	MySQL backend is now able to store information about hardware
	addresses and associated information in DHCPv6.
	(Trac #3556, git 08a29d8d2374bc3c6b3799d5dd97f586ee869392)

863.	[func]		tomek
	A new tool called kea-admin added. It allows database maintenance.
	Initialization of a new database, version check and upgrade between
	version is now supported. Currently the only backend supported is
	mysql, but support for memfile and pgsql is planned.
	(Trac #3599, git cf22f8d212f2435957f89b51722f8e26e14635f2)

862.	[func]		dgutier, tomek
	Support for client link-layer address option (RFC6939) has
	been added.
	(Trac #3551, git dabdf965d92085f86d5e96c8dadce0f0a8f7c8e3)

861.	[func]		marcin
	The configuration parameters for a DHCPv4 and DHCPv6 options are now
	optional.
	(Trac #3467, git 7bf8cef161e6dd00a7f2b2fe8ec04e1958d6db3f)

860.	[bug]		marcin
	Fixed calculation of the Client FQDN option length for the ASCII
	domain name encoding.
	(Trac #3624, git 5a120d9bf85e27ea5b2674d35af0f2774e4cd2a7)

859.	[func]		marcin
	Implemented Host Manager, which can retrieve host reservations
	specified in the server's configuration. Future tickets will
	extend Host Manager to retrieve reservations from other sources,
	e.g. SQL databases.
	(Trac #3561, git faac5e9746dbf82eb04ffef95658e4b4c7d64a4a)

858.	[bug]		marcin
	Added missing "lease-database" entry to the default DHCPv6
	server configuration, in kea.conf.
	(Trac #3630, git 0f7ff732ea2add45a24e040eae8a0dda27532a31)

857.	[func]		fdupont
	Improve the cryptolink code, for instance use a constant
	time comparison.
	(Trac #3602, git 0c1f433da650330b40fe1a67bae4716c9184f636)

856.	[build]		marcinw
	callout_manager.h and server_hooks.h headers are now exported,
	so statically linked libraries can be tested.
	(Github #4, git 00b5f3fa0369c13021bf4fb78c6450e524e4e411)

855.	[build]		fdupont
	Use convenience archives for objects used in a makefile and
	its parent makefile: before sources were compiled twice using
	the broken subdir-objects option of automake, now objects
	are put into a convenience static library (so an archive).
	(Trac #3631, git d7954b4234114d8fa41aa51f671d4faa1724b748)

854.	[bug]		marcin
	Corrected a regression on "make distcheck" which appeared after
	implementation of #3162 (partial fix).
	(Trac #3629, git 9bb6b76a24e4356b30e59631e76e32c3096fb515)

853.	[func]		tomek
	Lease6 now is able to store MAC/hardware address information. Memfile
	memfile backend has been updated to store/retrieve that additional
	piece of information. Server now tries to use available methods to
	obtain MAC/hardware address from incoming packet.
	(Trac #3555, git ab76a9e7a9d39cb3cf533729473b63a2d2401ac7)

852.	[func]		tomek
	Pkt6 class is now able to generate client's MAC from source IPv6
	link-local address if EUI-64 identifier was used.
	(Trac #3549, git d92e76860e6931477b3e60e5be8978302973f88f)

851.	[bug]		tmark
	Corrected a segmentation fault that was occurring under OS-X
	during D2 module shutdown.
	(Trac #3470, git f7822568abd04c12faa3cde34fadaac238a373d3)

850.	[build]		fdupont
	Moved optional gtest sources to ext/gtest.
	(Trac #3162, git 055512758f5c79f29eb375126d496483c9a6d0a1)

849.	[bug]		tomek
	DHCPv6 component now processes incoming vendor-class options
	properly (packets are classified as VENDOR_CLASS_[content of the
	vendor-class option]).
	(Trac #3486, git 62409cd9531b081943b8f3567f7b0dca36b18802)

848.	[func]		fdupont
	Added truncated HMAC support to TSIG, as per RFC 4635.
	(Trac #3593, git ae3a9cd1a0d2dc07b7092368149381d69bc2c61a)

847.	[build]		fdupont
	Removed no longer used configuration option --with-shared-memory
	and associated files and variables.
	(Trac #3614, git adee8c93f7c7c1303390dd63dbeae74a48a34845)

846.	[bug]		fdupont
	Fixed subdir-objects warnings from recent versions of autotools,
	e.g., on Apple OSX.
	(Trac #3162, git e25c7477f3c35cdaa0f038732f697224bfd44847)

845.	[func]		marcin
	Implemented Host class for storing information about IPv4 and IPv6
	reservations for the host.
	(Trac #3560, git fb5e1883b01ce6388d1b7a92c61061b493c36713)

844.	[bug]		tmark, marcin
	Fixed multiple issues in the DHCP-DDNS unit tests.
	(Trac #3615, git fec824d36121b12e98dd407a0bdf1bc71c8de18d)

843.	[bug]		marcin
	DHCPv4 server sets ciaddr to 0 in DHCPOFFER and DHCPNAK messages to
	adhere to section 4.3.1 of RFC2131.
	(Trac #3367, git 9f05a29caa960df2b09b7a8c23100da8b40e73d0)

842.	[func]		marcin
	DHCPv4 server logs when the packet sent by the client contains
	invalid combination of giaddr/hops before discarding the packet.
	(Trac #3537, git 760c652b54dcdfdfbd1a0014da43d3c31e848f02)

841.	[func]		tomek
	Pkt4 and Pkt6 class have a common base now. A lot code duplication
	removed. Added getMAC() method that will be used to extract MAC
	in DHCPv6.
	(Trac #3546, git 6e68af7dfe15e4d461bf068f545d2bdaaa8fcfb0)

840.	[func]		nicolas
	PktFilterInet::send method now sets source IPv4 address
	explicitly.  This enabled perfdhcp to control its source address
	on systems that have more than one address assigned to a given
	interface. Thanks to Nicolas Chaigneau from Capgemini for
	providing this fix.
	(Github #2, git 6ac36ed7a1d97bcf52ffb2aec7cbf116e58e5803)

839.	[doc]		adam
	DHCPv4 examples corrected in Kea ARM. Thanks to Adam Osuchowski
	from Silesian University of Technology for providing this fix.
	(Github #1, git 15785c0e28190659b037cfcca19f0267ccd9049f)

838.	[bug]		tomek
	Kea components now use the KEA_LOCKFILE_DIR environment variable
	to specify the directory of the logging lockfile. Locking can be
	disabled completely by setting the variable to 'none'.
	(Trac #3591, git d4556e1d21766b94f2f0cda59df15e47e6f2676e)

837.	[bug,doc]	tomek
	Logging configuration examples in kea.conf fixed. Also updated
	Kea documentation for logging.
	(Trac #3536, git 2cf3f6b9cb3d2ae6fc7b0940b55490f109ddd2f9)

836.	[bug]		fdupont
	Moved duplicated getXXXHashAlgorithm() function to new
	xxx_common.h include files in the cryptolink library.
	(Trac #3471, git 8cf2ee46b3d7398f4f716435be3d9b19bf3599f5)

835.	[build]		fdupont
	The configure script checks if OpenSSL supports SHA-2, in order
	to avoid very old (and likely subject to unfixed security bugs)
	OpenSSL versions.
	(Trac #3482, git c779a0ef23d2092cf896276dab1fbcb190380374)

834.	[bug]		marcin
	Corrected the definition of the example DHCPv4 and DHCPv6 address
	pools in the default kea.conf file.
	(Trac #3538, git 8712cc0df77368940d8d3d11811a9ac9504bce12)

833.	[func]		marcin
	Configuration Manager supports two stage configuration. In the
	first stage a temporary configuration is created and in the
	second stage this configuration is committed. If configuration
	fails at the first stage, the temporary configuration is rolled
	back and the server continues to use the old configuration.
	(Trac #3534, git 4ecee3c0c97fe417b050317356f9093ba3771a15)

Kea 0.9 released on August 29, 2014

832.	[bug]		jiri
	Compilation fix for PostgreSQL on i686. Thanks to Jiri Popelka
	from RedHat for providing a patch!
	(Trac #3532, git 96a06654f2177444dcea3a0e9f6fa06947855497)

831.	[func]		marcin
	DHCP servers check if the interfaces specified in the configuration,
	to be used to receive DHCP messages, are present in the system.
	If the interface doesn't exist, an error is reported. In addition,
	the SO_REUSEPORT flag is set for IPv6 sockets as multiple multicast
	sockets can be bound to the DHCPv6 server port.
	(Trac #3512, git 5cbbab2d01c6e1bf6d563ba64d80bc6bc857f73d)

830.	[build]		jreed
	The configure script no longer requires pkg-config.
	(Trac #3511, git 99a5a2db8c011b358873d485ac48f7c78ac6374c)

829.	[build]		wlodek
	Lettuce DNS tests removed with all related python code,
	most of them will be used in Forge project which can be found
	http://kea.isc.org/wiki/IscForge
	(Trac #3420, git e51bcbeedbc169050751c1b896726965243667be)

828.	[bug]		marcin
	Corrected the IfaceMgrTest.detectIface unit test that failed on
	Linux systems with virtual interfaces present.
	(Trac #3527, git 7aa01a6965b6e9fc39ff005803cada7f58f2e628)

827.	[build]		jiri, tomek
	Deprecated AC_PROG_LIBTOOL macro replaced by LT_INIT. Thanks to
	Jiri Popelka from RedHat for providing a patch!
	(Trac #3525, git 6c0aacf29fae1d0501ca69ff6324df8d4fc8c7ee)

826.	[bug]		jiri, tomek
	Compilation fix for Red Hat running on armv7. Thanks to Jiri
	Popelka from RedHat for providing a patch!
	(Trac #3526, git eac5a80472dcb78b538c2ed34cc0534f801e5145)

825.	[bug]		jiri, tomek
	Example JSON configuration files permission fix. Thanks to Jiri
	Popelka	from RedHat for providing a patch!
	(Trac #3524, git 822a39ba33870f70787a1f666aed772e06d04d79)

824.	[bug]		marcin
	Kea daemons report configuration summary when the configuration is
	applied successfully.
	(Trac #3477, git f39d208024f720f72c931016cfa50a54e80f8c61)

823.	[build]		tomek
	query_cmp tool removed from the source code.
	(Trac #3509, git f61c800059bd5e5c74e435d7dd97ae561d29151a)

822.	[build]		tomek
	'host' program was removed from examples.
	(Trac #3421, git aeea893fb1c52d20258929a62a59ae2e7bd12e3d)

821.	[bug]		marcin
	DHCP servers no longer log an error when Interface Manager fails to
	receive a packet as a result of signal being received.
	(Trac #3478, git d80c83aef8e103dd483234429d35aeb66149e0b9)

820.	[bug]		marcin
	Corrected the IfaceMgrTest.detectIfaces unit test which reported
	false positives for specific network configurations.
	(Trac #3517, git 9affa1b2210f5cc9d7a99724e5d5c8979409cefd)

Kea 0.9beta1 released on August 13, 2014

819.	[build]		marcin
	Renamed variables in the configure.ac so as their names do not
	refer to BIND10 project. As a result of renaming the B10_CXXFLAGS
	to KEA_CXXFLAGS in configure.ac all dependent Makefiles had to
	be updated in the tree. The AX_BOOST_FOR_BIND10 macro has been
	renamed to AX_BOOST_FOR_KEA.
	(Trac #3507, git 6616b1c0ad0a78e11bca9395fafb8efdba8d8b9c)

818.	[func]		tomek
	DHCPv4, DHCPv6 and DDNS components now report their versions.
	(Trac #3508, git 3f46c74ffa0ea1197e1fa62cb2f6580931be35f3)

817.	[bug]		marcin
	DHCPv4 and DHCPv6 servers will log an error during an attempt to
	open socket on the interface which is down or not configured.
	(Trac #3487, git fadc776914aa858ce637aab1513ab3d87631f612)

816.	[doc]		tomek
	AUTHORS file rewritten.
	(Trac #3469, git 6ef55abaa1ef79e09ad332c0da28dee7bfed70fe)

815.	[func]		tomek
	Pool definitions in DHCPv4 and DHCPv6 are now lists of
	structures. This makes adding new per-pool parameters easier in
	the future.
	(Trac #3464, git 4bd0c0eda9d86608f8802d28bd360239fe88e905)

814.	[func,doc]		tomek
	It is now possible to specify logging parameters in a
	configuration file for DHCPv4, DHCPv6 and DHCP-DDNS components.
	(Trac #3427, git 23285903645c36fc35c6866a74c50c74089cd255)

813.	[func]		tomek
	Functions, methods and variables referring to BIND10 were renamed
	to Kea. In particular, system variables (B10_LOGGER_ROOT,
	B10_LOCKFILE_DIR_FROM_BUILD etc.) were renamed. B10_ prefix was
	replaced with KEA_.
	(Trac #3417, git 1db8988de6af435fa388dc9c7f909c4a004a01d0)

812.	[doc]		tomek
	DHCPv6 and DDNS sections in Kea Administrator Reference Manual
	has been updated. Usage of keactl has been documented.
	(Trac #3468, git 3945fc6211bcadb9bece7147039a6b50ebcf936b)
	(Trac #3466, git fa9570d19c73cbe7effc75589b7eb855c411f6a3)

811.	[doc]		tmark
	Added documentation of message protocol between DHCP servers and the
	DHCP-DDNS process.
	(Trac #3505, git 6d9aed2f8fe181714e8260493c6cc06e13d0edd0)

810.	[func]		stephen
	perfdhcp is now installed in sbin as it requires root privilege
	to run. The perfdhcp source has been moved to the directory
	src/bin/perfdhcp.
	(Trac #3481, git d101aed6156a993476fa1164f0b0ec8395f5886c)

809.	[func]		stephen
	sockcreator is no longer built or installed.  The code is being
	retained in the repository for the moment, but may be deleted at
	some point in the future.
	(Trac #3480, git 2a55a469dde8fcc053b49e287c30d0906baa91b4)

808.	[func]		stephen
	Reduced number of startup and shutdown messages in the
	DHCP-DDNS process by making some of them debug messages.
	(Trac #3479, git bca0bae285de9ce904c0afd21af777dac2edb4e6)

807.	[func]		marcin
	DHCPv6 server responds to Confirm messages from clients.
	(Trac #3269, git 4f43c309a994e30c07f5aa27057552fb195ec284)

806.	[func]		marcin
	DHCPv4 server processes Requested IP Address option (50).
	(Trac #3320, git ad411a177a32bbe6a93f4baf813d985558c99e2f)

805.	[func]		stephen
	Changed all occurrences of "BIND 10" in message files to "Kea".
	(Trac #3416, git e88090b57a75424920d9b96efbf50e3554048828)

804.	[func]		marcin
	DHCPv4 server supports DHCPINFORM messages from the clients.
	(Trac #3390, git 77f8577b1dbb52bdc6deb8bed3eef6ce7abc33fd)

803.	[func]		marcin
	DHCPv4 server supports responding to directly connected clients on
	FreeBSD, NetBSD and OpenBSD using Berkeley Packet Filtering. This
	also resolves the problem reported in #3438 that the server doesn't
	pick the correct interface to respond to the client and the client
	never gets the response from the server.
	(Trac #2893, git 9fba39d93b9ece950c4294230984d6315dfa11f6)

802.	[doc]		tomek, marcin
	Developer's Guide updated to Change BIND 10 references to Kea.
	Documentation for Keactrl added.
	(Trac #3396, git 271450edbc63e9022f877c9aa3d1dc290708f151)
	(Trac #3466, git fa9570d19c73cbe7effc75589b7eb855c411f6a3)

801.	[build]		fdupont
	Detect all OS X versions more recent than 10.9 (where
	pthread_cond_destroy() doesn't work as documented,
	which makes some of unit tests to fail).
	(Trac #3473, git d620ef6659598bcc1f4c30241e845348770e264e)

800.	[bug]		marcin
	DHCPv6 server is now usable on FreeBSD, NetBSD and OpenBSD systems.
	It can receive messages sent to ff02::1:2 multicast address. Also,
	fixed the bug whereby the DHCPv6 server failed to bind the socket
	to global unicast address on BSD systems due to invalid scope id
	setting.
	(Trac #3437, git f4c2fe2fc37a37f1510e138e1f6c4ccd757e1f06)

799.	[func]		tmark
	Configuration parsing for all Kea servers has been enhanced to include
	the location of the error within the configuration file presented as
	file name, line number, and column within the configuration file.
	(Trac #3436, git b927deb2b4579f93ba74d4be8f5a3a4eaa3c6422)
	(Trac #3409, git 777dbdb29a641f7d8661f9cc2c22f1cb9fe7eb14)

798.	[build]		tomek
	JSON configuration backend is now the default. BUNDY backend
	is now deprecated after #3413 removed the BIND10/Bundy framework.
	(Trac #3476, git 727b65f2c62bbd7dc599b2e7956167e2b3c34098)

797.	[build]		tomek
	Removed a lot of remaining BIND10 framework: bind10, bindctl,
	cfgmgr, cmdctl, msgq, stats, sysinfo, tests, usermgr from src/bin
	directory, also src/lib/python directory. Python3 is not
	required anymore, unless documentation generation is enabled.
	(Trac #3413, git d7b297ac475193f687d07b0489ac74585d4f3814)

796.	[doc]		tomek
	User's Guide renamed to Kea Administrator Reference Manual,
	removed sections specific to BIND10/Bundy framework, rewritten
	general and DHCPv4 specific examples.
	(Trac #3418, git 73e6019d83760f0500890240e2e187dcd5e1e14c)

795.	[func]		marcin
	Added support to keactrl to start, stop, reconfigure and gather
	status of the DHCP-DDNS server.
	(Trac #3465, git 6bc61470c9ccee001fe282d0f879bcddac0b8721)

794.	[func]		fdupont
	cryptolink: add OpenSSL crypto backend as an alternative to Botan
	by specifying --with-openssl[=PATH] on the "configure" command
	line. Add hash support to the cryptolink API and use it in DHCP
	DDNS, removing the Botan dependency.
	(Trac #2406, git 4b4110dd68706b4171fc6d8a6f4f2a9cd820edac)

793.	[func]		tmark
	DHCP-DDNS: Implemented dynamic reconfiguration of the server,
	triggered when the SIGHUP signal is received by the server's
	process. Also, server performs a graceful shut down when SIGINT
	or SIGTERM signal is received.
	(Trac #3407, git f1a224df1e46098748ba60205be09ada4600515f)

792.	[func]		marcin
	Implemented keactrl script used to start, stop, reconfigure Kea
	servers and get their status and configuration data. This script
	is installed only if the JSON configuration backend is in use.
	(Trac #3422, git e1d164c7a9a54a7aacea88c8c57cd2826e06012b)

791.	[func]		tmark
	DHCP-DDNS: Now supports configure.ac parameter: --with-kea-config.
	It allows selecting configuration backend and accepts one of two
	values: BUNDY, which uses Bundy (former BIND10) framework as Kea
	0.8 did, or JSON, which reads configuration from a JSON file.
	(Trac #3401, git 8e69209caafc81041229f3d9601599f3d98fc86e)

790.	[func]		marcin
	DHCPv4 server: Implemented dynamic reconfiguration of the server,
	triggered when the SIGHUP signal is received by the server's
	process. Also, server performs a graceful shut down when SIGINT
	or SIGTERM signal is received.
	(Trac #3405, git dd0270bd91cf8fc958b8b388950d343d311ee99e)

789.	[bug]		marcin
	DHCPv4 server sends Renewal Time (58) and Rebinding Time (59)
	options to the client when the appropriate timers are set
	in the configuration. Previously, the timers were ignored.
	(Trac #3336, git b3c8a079889411182ade517c85aa4fe5d6b8719a)

788.	[func]		tomek
	DHCPv4 server: New parameter added to configure.ac: --with-kea-config.
	It allows selecting configuration backend and accepts one of two
	values: BUNDY, which uses Bundy (former BIND10) framework as Kea
	0.8 did, or JSON, which reads configuration from a JSON file.
	(Trac #3399, git 6e4dd3ae58c091ba0fd64c87fa8d7c268210f99b)

787.	[func]		marcin
	DHCPv6 server: Implemented dynamic reconfiguration of the server,
	triggered when the SIGHUP signal is received by the server's
	process. Also, server performs a graceful shut down when SIGINT
	or SIGTERM signal is received.
	(Trac #3406, git 3be60fa6ac521aecae6ae92d26dc03792bc76903)

786.	[func]		tmark
	DHCP-DDNS now supports DDNS updates with TSIG.  Please refer to the
	Kea Guide for details. Prior to this TSIG keys could be defined but
	were not used.
	(Trac #3432, git 80fea12a53d1e832d4e7b710ca6ea613300f73ea)

785.	[bug]		marcin
	DHCPv6 server avoids collisions between prefixes that are allocated
	as a result of receiving hints from the clients. Previously the
	whole prefix (including bits beyond the prefix length) was used to
	search existing leases in the lease database. If not found, the
	new lease was created for the prefix sent by the client. If another
	client sent the same prefix but with different non-significant bits
	the prefix was allocated. This led to prefix collisions. Currently,
	server ignores bits beyond the prefix length when searching for
	existing leases.
	(Trac #3246, git 50de7df4195195e981ae9c8c6f1b4100047d5bb5)

784.	[func]		tmark
	DHCP_DDNS's configuration was changed. The unused parameter,
	"interface" was deleted.  Three new parameters, "ncr_protocol",
	"ncr_format", and "dns_server_timeout" were added.  Please refer to
	Kea Guide for details.
	(Trac #3268,    git bd60252e679f19b062f61926647f661ab169f21c)

783.	[func]*		tomek
	DHCPv6 server: New parameter added to configure: --with-kea-config.
	It allows selecting configuration backend and accepts one of two
	values: BUNDY, which uses Bundy (former BIND10 framework as Kea
	0.8 did, or JSON, which reads configuration from a JSON file.
	(Trac #3400, git 7e9fdfa644b81f72bfa5300b7ddcdb9754400769)

782.	[func]		tmark
	Added sender-ip, sender-port, and max-queue-size parameters to
	the dhcp-ddns configuration section of both b10-dhcp4 and b10-dhcp6.
	(Trac #3328,    git 8d8d0b5eedaab20bf1008dfb3a6913eb006a6e73)

781.	[func]		marcin
	libkea-dhcpsrv: the Memfile lease storage backend returns leases
	of a specified type. Previously, it ignored the lease type parameter
	and returned all leases for a particular client. Thanks to David
	Carlier for helping to implement this ticket.
	(Trac #3148, git d2f0edf473716cd747a21d6917e89ba55c148d8e)

780.	[func]		marcin
	libkea-cc: JSON parser stores information about the position
	of the data element values in the JSON string. The position
	comprises the line number and the offset within this line where
	the specific value resides. This functionality is intended to
	be used for error logging during configuration parsing.
	(Trac #3408, git 115a52a6713340fc589f6f95d73d242931239405)

779.	[doc]		tmark
	Added a section to the developer's guide for Kea's DHCP-DDNS
	component, D2.
	(Trac #3158,    git  7be263c7372b1401a8b4288742854f96b5bec0d6)

bind10-1.2.0 (kea 0.8) released on April 17, 2014

bind10-1.2.0rc1 released on April 8, 2014

778.	[func]*		marcin
	libdhcpsrv: the Memfile lease storage backend now writes
	leases into a CSV file. Configuration parsers for b10-dhcp4
	and b10-dhcp6 use the new configuration parameters to
	control the location of the lease file. It is possible to
	disable lease writes to disk using configuration for testing
	purposes.
	(Trac #3360, git 09e6e71abf8bc693e389ebd262fd149b43c1f1d4)

777.	[func]		tmark
	If b10-dhcp-ddns is configured to listen on an address other than
	loopback, it will issue a log message warning the user that this is
	insecure and is supported for testing purposes only.
	(Trac #3383,    git  652aa4de2fa82fdf3de569d01d9f4aa618fc1972)

776.	[func]		tomek
	b10-dhcp4 and b10-dhcp6 now support using PostgreSQL as the backend
	for storing lease data.  This backend is enabled by specifying
	--with-dhcp-pgsql on the "configure" command line. Without this
	switch the PostgreSQL backend is not compiled leaving BIND 10 able to
	be built on systems without PostgreSQL installed.  Thanks to David
	Carlier who contributed the initial patches for this work.
	(Trac #3080,    git  1aae8b1fab3008e62c4f085948b1abadad512447)

775.	[func]		marcin
	b10-dhcp4, b10-dhcp6: added a new parameter to subnet configuration.
	This parameter allows subnet ids to be set to arbitrary values or
	automatically generated values. Generated subnet ids are renumbered
	each time one or more subnets are removed.  Setting the ids to
	specific values prevents this renumbering.
	(Trac #3281, git d90e9a0642fbb16a4e664160b4812f61fb81f1aa)

774.	[doc]		marcin
	Updated information in the BIND 10 Guide about the standards supported
	by Kea and its current limitations.
	(Trac #3258, git ff52b86206e3a256a02ca6d5cde55040550ba86a)

773.	[doc]		tmark
	Added sections to the BIND 10 guide on configuring and using the
	DHCP-DDNS feature of Kea.  Chapter 19, describes the new DHCP-DDNS
	server and its configuration. Additions to chapters 17 and 18
	describe configuring the DHCP servers to work with the new server.
	(Trac #3283, git 806eea955c61eba2d7268958a740a8e8ea63bdaf)

772.	[bug]		tmark
	b10-dhcp4 and b10-dhcp6 now both correctly support DDNS updates
	when honoring client requested delegation. When DDNS is enabled,
	and the client's FQDN indicates they will do the forward updates,
	the servers will now post a DDNS update request to b10-dhcp-ddns
	for the reverse updates. Prior to this the servers were posting no
	DDNS update requests when honoring client delegation.
	(Trac #3352, git b1a0f405463723d539b2e6ed2dcdd692d7796b88)

771.	[bug]		tmark
	Ticket #3339 (entry 760) was reverted to fix regression
	where components added through bindctl, could not be removed.
	(Trac #3374, git c641e2d0569df3ca3e5a93beaf0ecf39db07e402)

770.	[bug]		tmark
	Configuration parsing in b10-dhcp6 and b10-dhcp4 for the "dhcp-ddns"
	section of their configurations now supplies hard-coded default values
	rather than those from their spec files.  This is a temporary solution
	to circumvent an issue in the configuration libraries which causes
	map-items to behave incorrectly.
	(Trac #3358, git 983d8acec3a7ccb1ffef662eac7518aed5f99381)

769.	[func]		marcin
	b10-dhcp6: Implemented support for Rebind message.
	(Trac #3232, git 3649413932857470558a6f19e0b0e181b3fc0fda)

768.	[bug]		tmark
	b10-dhcp-ddns now treats a DNS server response code of
	NXRRSET as a successful outcome when processing a request
	to remove DNS data.  This corrects a defect in which
	b10-dhcp-ddns would incorrectly fail a request to remove
	DNS data when the DNS server's response was NXRRSET.
	(Trac #3362, git da3b0d4f364d069ffdb47723545798ac589fae42)

767.	[func]		tomek
	Unit-tests for all DHCP database backends are now shared.
	This improves test coverage for memfile and any future
	backends that may appear.
	(Trac #3359, git 3d6c11630ada9d0681a813cf026f6bb16aabb9fa)

bind10-1.2.0beta1 released on March 6, 2014

766.	[func]		muks
	--disable-dns and --disable-dhcp configure arguments have been
	added to conditionally disable the DNS or DHCP components
	respectively. This facility can be used to do a DNS or DHCP-only
	build of BIND 10. DNS and DHCP components are both enabled by
	default.
	(Trac #2367, git 81a689b61b1c4abf8a1a4fcbe41cfc96fd11792a)

765.	[bug]		tomek
	b10-dhcp4: Fixed a minor bug in eRouter1.0 class processing. The
	server no longer sets giaddr field.
	(Trac #3353, git 23c22e9b1141c699f361d45c309e737dfecf6f3f)

764.	[bug]		tomek
	b10-dhcp4: Fixed a bug caused client classification to not work
	properly.
	(Trac #3343, git 1801400ac874380e7a565d373b4bae96a49e21f7)

763.	[func]		tmark
	b10-dhcp-ddns may now be configured to disable DNS updates in
	in a given direction by simply not defining any domains for that
	direction in its configuration.  This allows it to be configured to
	support either forward DNS or reverse DNS only.  Prior to this if
	a request was received that could not be matched to servers in a
	given direction it was failed immediately.
	(Trac #3341, git 01f26bce1d9faaddb8be59802f73891ea065b200)

762.	[func]		tmark
	If configured to do so, b10-dhcp6 will now create DHCP-DDNS update
	requests and send them to b10-dhcp-ddns for processing.
	(Trac# 3329, git 239956696465a13196a2b6bc0f3a61aed21a5de8)

761.	[doc]		stephen, jreed
	Added "man" page for perfdhcp.
	(Trac #2307, git ff2f538912c205fbdb1408ee613c09b90de53514)

760.	[bug]		tmark
	When merging a map of configuration elements into another, elements
	that are themselves maps will be merged. In particular, this
	corrects a defect which caused a configuration commit error to
	occur when using bindctl to modify a single a parameter in
	dhcp-ddns portion of b10-dhcp4 configuration.
	(Trac# 3339, git 3ae0d93d89f3277a566eeb045191a43b2dd9d9b1)

759.	[func]		tomek
	b10-dhcp4, b10-dhcp6: IP address of the relay agent can now be
	specified for both IPv4 and IPv6 subnets. That information allows
	the server to properly handle a case where relay agent address
	does not match subnet.  This is mostly useful in shared subnets
	and cable networks.
	(Trac #3322, git 5de565baea42c9096dff78ed5fbd05982a174469)

758.	[bug]		tmark
	b10-dhcp4 now correctly handles DHO_HOST_OPTION.  This corrects
	a bug where the server would fail to recognize the option in the
	DHCP request and then skip generating the appropriate DHCP-DDNS
	update request.
	(Trac #2426, git 985d66cba7665a71e17ef70c5d22c767abaad1b6)

757.	[func]		tmark
	b10-dhcp6 now parses parameters which support DHCP-DDNS updates
	via the DHCP-DDNS module, b10-dhcp-ddns.  These parameters are
	part of new configuration element, dhcp-ddns, defined in
	dhcp4.spec. These parameters influence when and how DDNS updates
	requests are created but communicating them to b10-dhcp-ddns is
	not yet supported.  That will be provided under separate ticket,
	Trac #3222.
	(Trac# 3034, git 22c667a66536ff3e3741bc67025d824644ed4e7d)

756.	[bug]		marcin
	b10-dhcp6: server parses DHCPv6 Vendor Class option. Previously
	the server failed to parse Vendor Class option having empty opaque
	data field because of the invalid definition in libdhcp++. The
	DHCPv6 Vendor Class option and DHCPv4 V-I Vendor Class option is
	now represented by the new OptionVendorClass. The b10-dhcp4 is
	affected by this change such that it uses new class to parse the
	DHCPv4 V-I Vendor Class option.
	(Trac #3316, git 1e61d7db5b8dc76682aa568cd62bfae0eeff46e3)

755.	[func]		muks
	Add support for the CAA RR type (RFC 6844).
	(Trac #2512, git 39162608985e5c904448f308951c73bb9c32da8f)

754.	[func]		muks
	Add support for the TLSA RR type (RFC 6698).
	(Trac #2185, git a168170430f6927f28597b2a6debebe31cf39b13)

753.	[func]		muks
	libdns++: the unknown/generic (RFC 3597) RDATA class now uses the
	generic lexer in constructors from text.
	(Trac #2426, git 0770d2df84e5608371db3a47e0456eb2a340b5f4)

752.	[func]		tmark
	If configured to do so, b10-dhcp4 will now create DHCP-DDNS update
	requests and send them to b10-dhcp-ddns for processing.
	(Trac# 3329, git 4546dd186782eec5cfcb4ddb61b0a3aa5c700751)

751.	[func]		muks
	The BIND 10 zone loader now supports the $GENERATE directive (a
	BIND 9 extension).
	(Trac #2430, git b05064f681231fe7f8571253c5786f4ff0f2ca03)

750.	[func]		tomek
	b10-dhcp4, b10-dhcp6: Simple client classification has been
	implemented. Incoming packets can be assigned to zero or more
	client classes. It is possible to restrict subnet usage to a given
	client class. User's Guide and Developer's Guide has been updated.
	(Trac #3274, git 1791d19899b92a6ee411199f664bdfc690ec08b2)

749.	[bug]		tmark
	b10-dhcp-ddns now sets the TTL value in RRs that add A, AAAA, or
	PTR DNS entries to the lease length provided in instigating
	NameChangeRequest.  This corrected a bug in which the TTL was
	always set to 0.
	(Trac# 3299, git dbacf27ece77f3d857da793341c6bd31ef1ea239)

748.	[bug]		marcin
	b10-dhcp4 server picks a subnet, to assign address for a directly
	connected client, using IP address of the interface on which the
	client's message has been received. If the message is received on
	the interface for which there is no suitable subnet, the message
	is discarded. Also, the subnet for renewing client which unicasts
	its request, is selected using ciaddr.
	(Trac #3242, git 9e571cc217d6b1a2fd6fdae1565fcc6fde6d08b1)

747.	[bug]		marcin
	libdhcpsrv: server configuration mechanism allows creating definitions
	for standard options for which Kea doesn't provide a definition yet.
	Without this, the server administrator couldn't configure options for
	which a definition didn't exist.
	(Trac# 3309, git 16a6ed6e48a6a950670c4874a2e81b1faf287d99)

746.	[func]		tomek
	IOAddress no longer exposes underlying asio objects. The getAddress()
	method has been removed and replaced with several convenience methods.
	(Trac #1485, git ecdb62db16b3f3d447db4a9d2a4079d5260431f0)

745.	[bug]*		muks
	b10-auth now returns rcode=REFUSED for all questions with
	qtype=RRSIG (i.e., where RRSIGs are queried directly). This is
	because RRSIGs are meaningless without being bundled alongside the
	RRs they cover.
	(Trac #2226, git 68d24e65c9c3dfee38adfbe1c93367b0083f9a58)

744.	[func]		marcin
	b10-dhcp6: Refactored the code which is processing Client FQDN
	option.  The major user-visible change is that server generates
	DDNS NameChangeRequest for the first IPv6 address (instead of all)
	acquired by a client. Also, the server generates fully qualified
	domain name from acquired IPv6 address, if the client sends an
	empty name in Client FQDN option.
	(Trac# 3295, git aa1c94a54114e848c64771fde308fc9ac0c00fd0)

743.	[func]		tmark
	b10-dhcp4 now responds with changes in DDNS behavior based upon
	configuration parameters specified through its dhcp-ddns configuration
	element. The parameters now supported are override-no-update,
	override-client-update, replace-client-name, generated-prefix, and
	qualifying-suffix.
	(Trac# 3282, git 42b1f1e4c4f5aa48b7588233402876f5012c043c)

742.	[func]		muks
	The authoritative server now includes the datasource configuration
	when logging some errors with the
	AUTH_DATASRC_CLIENTS_BUILDER_RECONFIGURE_ERROR message ID.
	(Trac #2756, git 31872754f36c840b4ec0b412a86afe9f38be86e0)

741.	[bug]		shane
	Remove hard-coded (and unnecessary) TSIG key from error message.
	This also prevents a crash if the TSIG name is missing.
	(Trac #3099, git 0ba8bbabe09756a4627e80aacdbb5050407faaac)

740.	[func]		muks
	When displaying messages about mismatched configuration data types
	in entered values (between the supplied value type and expected
	schema type), bindctl now includes both the supplied and expected
	configuration data types in the returned error. The user has more
	information on what caused the error now.
	(Trac #3239, git 84d5eda2a6ae0d737aef68d56023fc33fef623e6)

739.	[bug]		muks
	Various minor updates were made to the SSHFP RDATA parser. Mainly,
	the SSHFP constructor no longer throws an isc::BadValue exception.
	generic::SSHFP::getFingerprintLen() was also renamed to
	getFingerprintLength().
	(Trac #3287, git 2f26d781704618c6007ba896ad3d9e0c107d04b0)

738.	[bug]		muks
	b10-auth now correctly processes NXDOMAIN results in the root zone
	when using a SQLite3 data source.
	(Trac #2951, git 13685cc4580660eaf5b041b683a2d2f31fd24de3)

737.	[func]		muks
	b10-auth now additionally logs the source address and port when
	DNS messages with unsupported opcodes are received.
	(Trac #1516, git 71611831f6d1aaaea09143d4837eddbd1d67fbf4)

736.	[bug]		wlodek
	b10-dhcp6 is now capable to determine if a received
	message is addressed to it, using server identifier option.
	The messages with non-matching server identifier are dropped.
	(Trac #2892, git 3bd69e9b4ab9be231f7c966fd62b95a4e1595901)

735.	[doc]		stephen
	Expanded Developer's Guide to include chapter on logging.
	(Trac #2566, git a08d702839d9df6cddefeccab1e7e657377145de)

734.	[bug]		marcin
	libdhcp++: fixed a bug which caused an error when setting boolean
	values for an option. Also, bind10-guide has been updated with the
	examples how to set the boolean values for an option.
	(Trac# 3292, git 7c4c0514ede3cffc52d8c2874cdbdb74ced5f4ac)

733.	[bug]		marcin
	libdhcp++: a function which opens IPv6/UDPv6 sockets for the
	DHCPv6 server, gracefully handles errors to bind socket to
	a multicast address.
	(Trac #3288, git 76ace0c46a5fe0e53a29dad093b817ad6c891f1b)

732.	[func]		tomek
	b10-dhcp4, b10-dhcp6: Support for simplified client classification
	added. Incoming packets are now assigned to a client class based
	on the content of the packet's user class option (DHCPv4) or vendor
	class option (DHCPv6). Two classes (docsis3.0 and eRouter1.0) have
	class specific behavior in b10-dhcp4. See DHCPv4 Client
	Classification and DHCPv6 Client Classification in BIND10
	Developer's Guide for details.  This is a first ticket in a series
	of planned at least three tickets.
	(Trac #3203, git afea612c23143f81a4201e39ba793bc837c5c9f1)

731.	[func]		tmark
	b10-dhcp4 now parses parameters which support DHCP-DDNS updates
	via the DHCP-DDNS module, b10-dhcp-ddns.  These parameters are
	part of new configuration element, dhcp-ddns, defined in
	dhcp4.spec.  The parameters parse, store and retrieve but do not
	yet govern behavior.  That will be provided under separate ticket.
	(Trac# 3033, git 0ba859834503f2b9b908cd7bc572e0286ca9201f)

730.	[bug]		tomek
	b10-dhcp4, b10-dhcp6: Both servers used to unnecessarily increase
	subnet-id values after reconfiguration. The subnet-ids are now reset
	to 1 every time a server is reconfigured.
	(Trac #3234, git 31e416087685a6dadc3047fdbb0927bbf60095aa)

729.	[bug]		marcin
	b10-dhcp4 discards DHCPv4 messages carrying server identifiers
	which don't match server identifiers used by the server.
	(Trac #3279, git 805d2b269c6bf3e7be68c13f1da1709d8150a666)

728.	[func]		marcin
	b10-dhcp6: If server fails to open a socket on one interface it
	will log a warning and continue to open sockets on other interfaces.
	The warning message is communicated from the libdhcp++ via the
	error handler function supplied by the DHCPv6 server.
	(Trac #3252, git af5eada1bba906697ee92df3fcc25cc0e3979221)

727.	[func]		muks
	RRset::setName() has now been removed.
	(Trac #2335, git c918027a387da8514acf7e125fd52c8378113662)

726.	[bug]*		muks
	Don't print trailing newlines in Question::toText() output by
	default.  This fixes some logging that were split with a line
	feed.  It is possible to get the old behavior by passing
	toText(true).  Message::toText() output is unchanged.
	(Trac #571, git 7286499d5206c6d2aa8a59a5247c3841a772a43e)

725.	[func]		tmark
	b10-dhcp-ddns D2UpdateMgr now uses the newly implemented
	NameAddTransaction and NameRemoveTransaction classes.  This allows
	it to conduct actual DNS update exchanges based upon queued
	NameChangeRequests.
	(Trac# 3089, git 9ff948a169e1c1f3ad9e1bad1568375590a3ef42)

724.	[bug]		marcin
	b10-dhcp4: Different server identifiers are used for the packets
	being sent through different interfaces. The server uses IPv4 address
	assigned to the particular interface as a server identifier. This
	guarantees that the unicast packet sent by a relay or a client, to
	the address being a server identifier, will reach the server.
	(Trac #3231, git c7a229f15089670d2bfde6e9f0530c30ce6f8cf8)

723.	[bug]		marcin
	libdhcp++: Implemented unit tests for the IfaceMgr's routine
	which opens IPv6 sockets on detected interfaces. The IfaceMgr
	logic performing low level operations on sockets has been
	moved to a separate class. By providing a custom implementation
	of this class, the unit tests may use fake interfaces with
	custom configuration and thus cover wide range of test
	scenarios for the function.
	(Trac #3251, git 21d2f7ec425f8461b545687104cd76a42da61b2e)

722.	[bug]		muks
	b10-cmdctl now prints a more operator-friendly message when the
	address+port that b10-cmdctl listens on is already in use.
	(Trac #3227, git 5ec35e37dbb46f66ff0f6a9d9a6a87a393b37934)

721.	[func]		tmark
	Updates the user_chk example hooks shared library with callouts
	for packet receive and packet send.  Decision outcome now includes
	the lease or prefix assigned.  The user registry now supports a
	default user entry.
	(Trac #3207, git 34fddf2e75b80d9e517a8f9c3321aa4878cda795)

720.	[func]		tmark
	Added the initial implementation of the class, NameAddTransaction,
	to b10-dhcp-ddns.  This class provides a state machine which
	implements the logic required to remove forward and reverse DNS
	entries as described in RFC 4703, section 5.5. This includes the
	ability to construct the necessary DNS requests.
	(Trac# 3088, git ca58ac00fce4cb5f46e534d7ffadb2db4e4ffaf3)

719.	[func]		tomek
	b10-dhcp4: Support for sending back client-id (RFC6842) has been
	added now. Also a configuration parameter (echo-client-id) has
	been added, so it is possible to enable backward compatibility
	("echo-client-id false").
	(Trac #3210, git 88a4858db206dfcd53a227562198f308f7779a72)

718.	[func]		dclink, tomek
	libdhcp++: Interface detection implemented for FreeBSD, NetBSD,
	OpenBSD, Mac OS X and Solaris 11. Thanks to David Carlier for
	contributing a patch.
	(Trac #2246, git d8045b5e1580a1d0b89a232fd61c10d25a95e769)

717.	[bug]		marcin
	Fixed the bug which incorrectly treated DHCPv4 option codes 224-254 as
	standard options, barring them from being used as custom options.
	(Trac #2772, git c6158690c389d75686545459618ae0bf16f2cdb8)

716.	[func]		marcin
	perfdhcp: added support for sending DHCPv6 Release messages
	at the specified rate and measure performance. The orphan
	messages counters are not displayed for individual exchanges
	anymore. The following ticket: #3261 has been submitted to
	implement global orphan counting for all exchange types.
	(Trac #3181, git 684524bc130080e4fa31b65edfd14d58eec37e50)

715.	[bug]		marcin
	libdhcp++: Used the CMSG_SPACE instead of CMSG_LEN macro to calculate
	msg_controllen field of the DHCPv6 message. Use of CMSG_LEN causes
	sendmsg failures on OpenBSD due to the bug kernel/6080 on OpenBSD.
	(Trac #1824, git 39c9499d001a98c8d2f5792563c28a5eb2cc5fcb)

714.	[doc]		tomek
	BIND10 Contributor's Guide added.
	(Trac #3109, git 016bfae00460b4f88adbfd07ed26759eb294ef10)

713.	[func]		tmark
	Added DNS update request construction to d2::NameAddTransaction
	in b10-dhcp-ddns.  The class now generates all DNS update
	request variations needed to fulfill its state machine in
	compliance with RFC 4703, sections 5.3 and 5.4.
	(Trac# 3241, git dceca9554cb9410dd8d12371b68198b797cb6cfb)

712.	[func]		marcin, dclink
	b10-dhcp4: If server fails to open a socket on one interface it
	will log a warning and continue to open sockets on other interfaces.
	The warning message is communicated from the libdhcp++ via the
	error handler function supplied by the DHCPv4 server. Thanks to
	David Carlier for providing a patch.
	(Trac #2765, git f49c4b8942cdbafb85414a1925ff6ca1d381f498)

711.	[func]		tmark
	Added the initial implementation of the class, NameAddTransaction,
	to b10-dhcp-ddns.  This class provides the state model logic
	described in the DHCP_DDNS design to add or replace forward and
	reverse DNS entries for a given FQDN.  It does not yet construct
	the actual DNS update requests, this will be added under Trac#
	3241.
	(Trac# 3087, git 8f99da735a9f39d514c40d0a295f751dc8edfbcd)

710.	[build]		jinmei
	Fixed various build time issues for MacOS X 10.9.  Those include
	some general fixes and improvements:
	- (libdns++) masterLoad() functions now use the generic MasterLoader
	  class as backend, eliminating the restrictions of the previous
	  versions.
	- (libcc) fixed a minor portability bug in the JSON parser.  Although
	  the only known affected system is OS X 10.9 at the moment, that
	  could potentially cause disruption on other existing and future
	  systems.
	Other notes:
	- if built with googletest, gtest 1.7 (and possibly higher) is
	  required.
	- many older versions of Boost don't work.  A known workable version
	  is 1.54.
	(Trac #3213, git d4e570f097fe0eb9009b177a4af285cde0c636cc)

709.	[bug]		marcin
	b10-dhcp6: Server crashed when the client sent FQDN option and did
	not request FQDN option to be returned.
	(Trac #3220, git 0f1ed4205a46eb42ef728ba6b0955c9af384e0be)

708.	[bug]		dclink, marcin
	libdhcpsrv: Fixed a bug in Memfile lease database backend which
	caused DHCPv4 server crashes when leases with NULL client id
	were present. Thanks to David Carlier for submitting the patch.
	(Trac #2940, git a232f3d7d92ebcfb7793dc6b67914299c45c715b)

707.	[bug]		muks
	Using very large numbers (out of bounds) in config values caused
	BIND 10 to throw an exception. This has been fixed in a patch
	contributed by David Carlier.
	(Trac #3114, git 9bd776e36b7f53a6ee2e4d5a2ea79722ba5fe13b)

706.	[func]		marcin
	b10-dhcp4: Server processes the DHCPv4 Client FQDN and Host Name
	options sent by a client and generates the response. As a result
	of processing, the server generates NameChangeRequests which
	represent changes to DNS mappings for a particular lease (addition
	or removal of DNS mappings).
	Currently all generated NameChangeRequests are dropped. Sending
	them to b10-dhcp-ddns will be implemented with the future tickets.
	(Trac #3035, git f617e6af8cdf068320d14626ecbe14a73a6da22)

705.	[bug]*		kean
	When commands are piped into bindctl, no longer attempt to query the
	user name and password if no default user name and password file is
	present, or it contains no valid entries.
	(Trac #264, git 4921d7de6b5623c7e85d2baf8bc978686877345b)

704.	[func]		naokikambe
	New statistics items related to IP sockets added into b10-xfrin:
	open, openfail, close, connfail, conn, senderr, and recverr.
	Their values can be obtained by invoking "Stats show Xfrin" via
	bindctl while b10-xfrin is running.
	(Trac #2300, git 4655c110afa0ec6f5669bf53245bffe6b30ece4b)

703.	[bug]		kean
	A bug in b10-msgq was fixed where it would remove the socket file if
	there was an existing copy of b10-msgq running. It now correctly
	detects and reports this without removing the socket file.
	(Trac #433, git c18a49b0435c656669e6f87ef65d44dc98e0e726)

702.	[func]		marcin
	perfdhcp: support for sending DHCPv6 Renew messages at the specified
	rate and measure performance.
	(Trac #3183, git 66f2939830926f4337623b159210103b5a8e2434)

701.	[bug]		tomek
	libdhcp++: Incoming DHCPv6 IAPREFIX option is now parsed properly.
	(Trac #3211, git ed43618a2c7b2387d76f99a5a4b1a3e05ac70f5e)

700.	[func]		tomek, marcin
	b10-dhcp4, b10-dhcp6: Support for vendor options has been added. It
	is now possible to configure vendor options. Server is able to
	parse some CableLabs vendor options and send configured	vendor
	options	in response. The support is not complete.
	(Trac #3194, git 243ded15bbed0d35e230d00f4e3ee42c3609616c)

699.	[bug]		marcin
	libdhcp++: Options with defined suboptions are now handled properly.
	In particular, Relay Agent Info options is now echoed back properly.
	(Trac #3102, git 6f6251bbd761809634aa470f36480d046b4d2a20)

698.	[bug]		muks
	A bug was fixed in the interaction between b10-init and b10-msgq
	that caused BIND 10 failures after repeated start/stop of
	components.
	(Trac #3094, git ed672a898d28d6249ff0c96df12384b0aee403c8

697.	[func]		tmark
	Implements "user_check" hooks shared library which supports subnet
	selection based upon the contents of a list of known DHCP lease users
	(i.e. clients).  Adds the following subdirectories to the bind10 src
	directory for maintaining hooks shared libraries:
	bind10/src/hooks - base directory for hooks shared libraries;
	bind10/src/hooks/dhcp - base directory for all hooks libs
	pertaining to DHCP (Kea);
	bind10/src/hooks/dhcp/user_check - directory containing the
	user_check hooks library.
	(Trac #3186, git f36aab92c85498f8511fbbe19fad5e3f787aef68)

696.	[func]		tomek
	b10-dhcp4: It is now possible to specify value of siaddr field
	in DHCPv4 responses. It is used to point out to the next
	server in the boot process (that typically is TFTP server).
	(Trac #3191, git 541922b5300904a5de2eaeddc3666fc4b654ffba)

695.	[func]		tomek
	b10-dhcp6 is now able to listen on global IPv6 unicast addresses.
	(Trac #3195, git 72e601f2a57ab70b25d50877c8e49242739d1c9f)

694.	[bug]		tomek
	b10-dhcp6 now handles exceptions better when processing initial
	configuration. In particular, errors with socket binding do not
	prevent b10-dhcp6 from establishing configuration session anymore.
	(Trac #3195, git 72e601f2a57ab70b25d50877c8e49242739d1c9f)

693.	[bug]		tomek
	b10-dhcp6 now handles IPv6 interface enabling correctly.
	(Trac #3195, git 72e601f2a57ab70b25d50877c8e49242739d1c9f)

692.	[bug]		marcin
	b10-dhcp4: Fix a bug whereby the Parameter Request List was not parsed
	by the server and requested DHCPv4 options were not returned to the
	client. Options are not sent back to the client if server failed to
	assign a lease.
	(Trac #3200, git 50d91e4c069c6de13680bfaaee3c56b68d6e4ab1)

691.	[bug]		marcin
	libdhcp++: Created definitions for standard DHCPv4 options:
	tftp-server-name (66) and boot-file-name (67). Also, fixed definition
	of DHCPv4 option time-offset (2).
	(Trac #3199, git 6e171110c4dd9ae3b1be828b9516efc65c33460b)

690.	[bug]		tomek
	b10-dhcp4: Relay Agent Info option is now echoed back in
	DHCPv4 responses.
	(Trac #3184, git 287389c049518bff66bdf6a5a49bb8768be02d8e)

689.	[func]*		marcin
	b10-dhcp4 and b10-dhcp6 install callback functions which parse options
	in the received DHCP packets.
	(Trac #3180, git f73fba3cde9421acbeb9486c615900b0af58fa25)

688.	[func]		tomek
	b10-dhcp6: Prefix Delegation support is now extended to
	Renew and Release messages.
	(Trac #3153, #3154, git 3207932815f58045acea84ae092e0a5aa7c4bfd7)

687.	[func]		tomek
	b10-dhcp6: Prefix Delegation (IA_PD and IAPREFIX options) is now
	supported in Solicit and Request messages.
	(Trac #3152, git a0e73dd74658f2deb22fad2c7a1f56d122aa9021)

686.	[bug]		tomek
	b10-dhcp6 now sends back relayed traffic to proper port.
	(Trac #3177, git 6b33de4bea92eecb64b6c673bf1b8ae51f8edcf1)

685.	[func]		tomek
	libdhcpsrv: Allocation Engine is now able to handle IPv6 prefixes.
	This will be used in Prefix Delegation.
	(Trac #3171, git 7d1431b4c887f0c7ee1b26b9b82d3d3b8464b34f)

684.	[func]		muks, vorner
	API support to delete zone data has been added. With this,
	DomainTree and RdataSet which form the central zone data
	structures of b10-auth allow deletion of names and RR data
	respectively.
	(Trac #2750, git d3dbe8e1643358d4f88cdbb7a16a32fd384b85b1)
	(Trac #2751, git 7430591b4ae4c7052cab86ed17d0221db3b524a8)

683.	[bug]		stephen
	Modifications to fix problems running unit tests if they
	are statically linked.  This includes provision of an
	initialization function that must be called by user-written
	hooks libraries if they are loaded by a statically-linked
	image.
	(Trac #3113, git 3d19eee4dbfabc7cf7ae528351ee9e3a334cae92)

682.	[func]		naokikambe
	New statistics items added into b10-xfrin : ixfr_running,
	axfr_running, and soa_in_progress.  Their values can be
	obtained by invoking "Stats show Xfrin" via bindctl when
	b10-xfrin is running.
	(Trac #2274, git ca691626a2be16f08754177bb27983a9f4984702)

681.	[func]		tmark
	Added support for prefix delegation configuration to b10-dhcp6
	subnets.
	(Trac# 3151, git 79a22be33825bafa1a0cdfa24d5cb751ab1ae2d3)

680.	[func]		marcin
	perfdhcp: Added support for requesting IPv6 prefixes using IA_PD
	option being sent to the server.
	(Trac #3173, git 4cc844f7cc82c8bd749296a2709ef67af8d9ba87)

679.	[func]		tmark
	b10-dhcp-ddns: Finite state machine logic was refactored
	into its own class, StateModel.
	(Trac# 3156, git 6e9227b1b15448e834d1f60dd655e5633ff9745c)

678.	[func]		tmark
	MySQL backend used by b10-dhcp6 now uses lease type as a
	filtering parameter in all IPv6 lease queries.
	(Trac# 3147, git 65b6372b783cb1361fd56efe2b3247bfdbdc47ea)

677.	[func]		tomek
	libdhcpsrv: CfgMgr is now able to store IA, TA and PD pools in
	Subnet6 structures.
	(Trac #3150, git e6f0e89162bac0adae3ce3141437a282d5183162)

676.	[bug]		muks
	We now also allow the short name ("hmac-md5"), along with the long
	name ("hmac-md5.sig-alg.reg.int") that was allowed before for
	HMAC-MD5, so that it is more convenient to configure TSIG keys
	using it.
	(Trac #2762, git c543008573eba65567e9c189824322954c6dd43b)

675.	[func]		vorner
	If there's an exception not handled in a Python BIND10 component,
	it is now stored in a temporary file and properly logged, instead
	of dumping to stderr.
	(Trac #3095, git 18cf54ed89dee1dd1847053c5210f0ca220590c2)

674.	[func]		tomek
	Preparatory work for prefix delegation in LeaseMgr. getLease6()
	renamed to getLeases6(). It now can return more than one lease.
	(Trac #3146, git 05a05d810be754e7a4d8ca181550867febf6dcc6)

673.	[func]		tomek
	libdhcp: Added support for IA_PD and IAPREFIX options. New class
	for IAPREFIX (Option6_IAPrefix) has been added.
	(Trac #3145, git 3a844e85ecc3067ccd1c01841f4a61366cb278f4)

672.	[func]		tmark
	Added b10-dhcp-ddns transaction base class, NameChangeTransaction.
	This class provides the common structure and methods to implement
	the state models described in the DHCP_DDNS design, plus
	integration with DNSClient and its callback mechanism for
	asynchronous IO with the DNS servers.
	(Trac #3086, git 079b862c9eb21056fdf957e560b8fe7b218441b6)

671.	[func]		dclink, tomek
	The memfile backend now supports getLease4(hwaddr) and
	getLease4(client-id) methods. Thanks to David Carlier for
	contributing a patch.
	(Trac #2592, git a11683be53db2f9f8f9b71c1d1c163511e0319b3)

670.	[func]		marcin
	libdhcpsrv: Added support to MySQL lease database backend to
	store FQDN data for the lease.
	(Trac #3084, git 79b7d8ee017b57a81cec5099bc028e1494d7e2e9)

669.	[func]		tmark
	Added main process event loop to D2Process which is the primary
	application object in b10-dhcp-ddns. This allows DHCP-DDNS
	to queue requests received from clients for processing while
	listening for command control events.
	(Trac #3075 git e2f9d2e4c1b36f01eb5bfa2c4f8d55cf139c7e02)

668.	[func]		marcin
	libdhcpsrv: Implemented changes to lease allocation engine to
	propagate information about client's FQDN.
	(Trac #3083, git 37af28303d1cd61f675faea969cd1159df65bf9d)

667.	[func]		tomek
	Additional hooks (buffer4_receive, lease4_renew,
	lease4_release, buffer4_send) added to the DHCPv4 server.
	(Trac #2983, git fd47f18f898695b98623a63a0a1c68d2e4b37568)

666.	[func]		vorner
	The CmdCtl's command "print_settings" was removed. It served no real
	purpose and was just experimental leftover from early development.
	(Trac #3028, git 0d22246092ad4822d48f5a52af5f644f5ae2f5e2)

665.	[doc]		stephen
	Added the "Hook's Maintenance Guide" to the BIND 10 developer
	documentation.
	(Trac #3063, git 5d1ee7b7470fc644b798ac47db1811c829f5ac24)

664.	[bug]		tmark
	Corrects a bug in Hooks processing that was improperly
	creating a new callout handle on every call, rather
	than maintaining it throughout the context of the
	packet being processed.
	(Trac #3062, git 28684bcfe5e54ad0421d75d4445a04b75358ce77)

663.	[func]		marcin
	b10-dhcp6: Server processes the DHCPv6 Client FQDN Option
	sent by a client and generates the response. The DHCPv6 Client
	FQDN Option is represented by the new class in the libdhcp++.
	As a result of FQDN Option processing, the server generates
	NameChangeRequests which represent changes to DNS mappings for
	a particular lease (addition or removal of DNS mappings).
	Currently all generated NameChangeRequests are dropped. Sending
	them to b10-dhcp-ddns will be implemented with the future tickets.
	(Trac #3036, git 209f3964b9f12afbf36f3fa6b62964e03049ec6e)

662.	[func]		marcin
	libdhcp++: Implemented an Option4ClientFqdn class which represents
	DHCPv4 Client FQDN Option (code 81) defined in RFC4702. This class
	supports the domain name encoding in canonical FQDN format as well
	as in deprecated ASCII format.
	(Trac# 3082, git 1b434debfbf4a43070eb480fa0975a6eff6429d4)

661.	[func]		stephen
	Copy additional header files to the BIND 10 installation directory
	to allow the building of DHCP hooks libraries against an installed
	version of BIND 10.
	(Trac #3092, git e9beef0b435ba108af9e5979476bd2928808b342)

660.	[func]		fujiwara
	src/lib/cc: Integer size of C++ CC library is changed to int64_t.
	b10-auth: The size of statistics counters is changed to uint64_t.
	b10-auth sends lower 63 bit of counter values to b10-stats.
	(Trac #3015,  git e5b3471d579937f19e446f8a380464e0fc059567
	 and Trac #3016, git ffbcf9833ebd2f1952664cc0498608b988628d53)

659.	[func]		stephen
	Added capability to configure the hooks libraries for the
	b10-dhcp4 and b10-dhcp6 servers through the BIND 10
	configuration mechanism.
	(Trac #2981, git aff6b06b2490fe4fa6568e7575a9a9105cfd7fae)

658.	[func]*		vorner
	The resolver, being experimental, is no longer installed by default.
	If you really want to use it, even when it is known to be buggy, use
	the ./configure --enable-experimental-resolver option.
	(Trac #3064, git f5f07c976d2d42bdf80fea4433202ecf1f260648)

657.	[bug]		vorner
	Due to various problems with older versions of boost and
	shared memory, the server rejects to compile with combination
	of boost < 1.48 and shared memory enabled. Most users don't
	need shared memory, admins of large servers are asked to
	upgrade boost.
	(Trac #3025, git 598e458c7af7d5bb81131112396e4c5845060ecd)

656.	[func]		tomek
	Additional hooks (buffer6_receive, lease6_renew,
	lease6_release, buffer6_send) added to the DHCPv6 server.
	(Trac #2984, git 540dd0449121094a56f294c500c2ed811f6016b6)

655.	[func]		tmark
	Added D2UpdateMgr class to b10-dhcp-ddns. This class is
	the b10-dhcp-ddns task master, instantiating and supervising
	transactions that carry out the DNS updates needed to
	fulfill the requests (NameChangeRequests) received from
	b10-dhcp-ddns clients (e.g. DHCP servers).
	(Trac #3059 git d72675617d6b60e3eb6160305738771f015849ba)

654.	[bug]		stephen
	Always clear "skip" flag before calling any callouts on a hook.
	(Trac# 3050, git ff0b9b45869b1d9a4b99e785fbce421e184c2e93)

653.	[func]		tmark
	Added initial implementation of D2QueueMgr to
	b10-dhcp-ddns.  This class manages the receipt and
	queuing of requests received by b10-dhcp-ddns from
	its clients (e.g. DHCP servers)
	(Trac# 3052, git a970f6c5255e000c053a2dc47926cea7cec2761c)

652.	[doc]		stephen
	Added the "Hook Developer's Guide" to the BIND 10 developer
	documentation.
	(Trac# 2982, git 26a805c7e49a9ec85ee825f179cda41a2358f4c6)

651.	[bug]		muks
	A race condition when creating cmdctl certificates caused corruption
	of these certificates in rare cases. This has now been fixed.
	(Trac# 2962, git 09f557d871faef090ed444ebeee7f13e142184a0)

650.	[func]		muks
	The DomainTree rebalancing code has been updated to be more
	understandable. This ChangeLog entry is made just to make a note
	of this change. The change should not cause any observable
	difference whatsoever.
	(Trac# 2811, git 7c0bad1643af13dedf9356e9fb3a51264b7481de)

649.	[func]		muks
	The default b10-xfrout also_notify port has been changed from
	0 to 53.
	(Trac# 2925, git 8acbf043daf590a9f2ad003e715cd4ffb0b3f979)

648.	[func]		tmark
	Moved classes pertaining to sending and receiving
	NameChangeRequests from src/bin/d2 into their own library,
	libdhcp_ddns, in src/lib/dhcp_ddns.  This allows the
	classes to be shared between DHDCP-DDNS and its clients,
	such as the DHCP servers.
	(Trac# 3065, git 3d39bccaf3f0565152ef73ec3e2cd03e77572c56)

647.	[func]		tmark
	Added initial implementation of classes for sending
	and receiving NameChangeRequests between DHCP-DDNS
	and its clients such as DHCP. This includes both
	abstract classes and a derivation which traffics
	requests across UDP sockets.
	(Trac #3008, git b54530b4539cec4476986442e72c047dddba7b48)

646.	[func]		stephen
	Extended the hooks framework to add a "validate libraries" function.
	This will be used to check libraries specified during BIND 10
	configuration.
	(Trac #3054, git 0f845ed94f462dee85b67f056656b2a197878b04)

645.	[func]		tomek
	Added initial set of hooks (pkt4_receive, subnet4_select,
	lease4_select, pkt4_send) to the DHCPv4 server.
	(Trac #2994, git be65cfba939a6a7abd3c93931ce35c33d3e8247b)

644.	[func]		marcin
	b10-dhcp4, b10-dhcp6: Implemented selection of the interfaces
	that server listens on, using Configuration Manager. It is
	possible to specify interface names explicitly or use asterisk
	to specify that server should listen on all available interfaces.
	Sockets are reopened according to the new configuration as
	soon as it is committed.
	(Trac #1555, git f48a3bff3fbbd15584d788a264d5966154394f04)

643.	[bug]		muks
	When running some unittests as root that depended on insufficient
	file permissions, the tests used to fail because the root user
	could still access such files. Such tests are now skipped when
	they are run as the root user.
	(Trac #3056, git 92ebabdbcf6168666b03d7f7fbb31f899be39322)

642.	[func]		tomek
	Added initial set of hooks (pkt6_receive, subnet6_select,
	lease6_select, pkt6_send) to the DHCPv6 server.
	(Trac #2995, git d6de376f97313ba40fef989e4a437d184fdf70cc)

641.	[func]		stephen
	Added the hooks framework. This allows shared libraries of
	user-written functions to be loaded at run-time and the
	functions called during packet processing.
	(Trac #2980, git 82c997a72890a12af135ace5b9ee100e41c5534e)

640.	[func]		marcin
	b10-dhcp-ddns: Implemented DNSClient class which implements
	asynchronous DNS updates using UDP. The TCP and TSIG support
	will be	implemented at later time. Nevertheless, class API
	accommodates the use of TCP and TSIG.
	(Trac #2977, git 5a67a8982baa1fd6b796c063eeb13850c633702c)

639.	[bug]		muks
	Added workaround for build failure on Fedora 19 between GCC 4.8.x
	and boost versions less than 1.54. Fedora 19 currently ships
	boost-1.53.
	(Trac #3039, git 4ef6830ed357ceb859ebb3e5e821a064bd8797bb)

638.	[bug]*		naokikambe
	Per-zone statistics counters are distinguished by zone class,
	e.g. IN, CH, and HS. A class name is added onto a zone name in
	structure of per-zone statistics.
	(Trac #2884, git c0153581c3533ef045a92e68e0464aab00947cbb)

637.	[func]		tmark
	Added initial implementation of NameChangeRequest,
	which embodies DNS update requests sent to DHCP-DDNS
	by its clients.
	(trac3007 git f33bdd59c6a8c8ea883f11578b463277d01c2b70)

636.	[func]		tmark
	Added the initial implementation of configuration parsing for
	DHCP-DDNS.
	(Trac #2957, git c04fb71fa44c2a458aac57ae54eeb1711c017a49)

635.	[func]		marcin
	b10-dhcp-ddns: Implemented DNS Update message construction.
	(Trac #2796, git eac5e751473e238dee1ebf16491634a1fbea25e2)

634.	[bug]		muks
	When processing DDNS updates, we now check the zone more
	thoroughly with the received zone data updates to check if it is
	valid.  If the zone fails validation, we reply with SERVFAIL
	rcode. So, while previously we may have allowed more zone data
	cases without checking which resulted in invalid zones, such
	update requests are now rejected.
	(Trac #2759, git d8991bf8ed720a316f7506c1dd9db7de5c57ad4d)

633.	[func]		jinmei
	b10-memmgr: a new BIND 10 module that manages shared memory
	segments for DNS zone data.  At this point it's runnable but does
	nothing really meaningful for end users; it was added to the
	master branch for further development.
	(Trac #2854, git d05d7aa36d0f8f87b94dba114134b50ca37eabff)

632.	[bug]		marcin
	perfdhcp: Fixed a bug in whereby the application was sporadically
	crashing when timed out packets were garbage collected.
	(Trac #2979, git 6d42b333f446eccc9d0204bcc04df38fed0c31db)

631.	[bug]		muks
	Applied a patch by Tomas Hozza to fix a couple of compile errors
	on Fedora 19 development release.
	(Trac #3001, git 6e42b90971b377261c72d51c38bf4a8dc336664a)

630.	[bug]		muks
	If there is a problem loading the backend module for a type of
	data source, b10-auth would not serve any zones. This behaviour
	has been changed now so that it serves zones from all other usable
	data sources that were configured.
	(Trac #2947, git 9a3ddf1e2bfa2546bfcc7df6d9b11bfbdb5cf35f)

629.	[func]		stephen
	Added first part of the hooks framework.
	(Trac #2794, git d2b107586db7c2deaecba212c891d231d7e54a07)

628.	[func]		y-aharen
	b10-auth: A new statistics item 'qryrecursion' has been introduced.
	The counter is for the number of queries (OpCode=Query) with Recursion
	Desired (RD) bit on.
	(Trac #2796, git 3d291f42cdb186682983aa833a1a67cb9e6a8434)

627.	[func]		tmark
	Logger name for DHCP-DDNS has been changed from "d2_logger" to
	"dhcpddns".  In addition, its log messages now use two suffixes,
	DCTL_ for logs the emanate from the underlying base classes, and
	DHCP_DDNS_ for logs which emanate from DHCP-DDNS specific code
	(Trac #2978, git 5aec5fb20b0486574226f89bd877267cb9116921)

626.	[func]		tmark
	Created the initial implementation of DHCP-DDNS service
	controller class, D2Controller, and the abstract class from
	which it derives, DControllerBase. D2Controller manages the
	lifecycle and BIND10 integration of the DHCP-DDNS application
	process, D2Process. Also note, module name is now
	b10-dhcp-ddns.
	(Trac #2956, git a41cac582e46213c120b19928e4162535ba5fe76)

625.	[bug]*		jinmei
	b10-xfrin/b10-loadzone: b10-xfrin now refers to the unified
	"data_sources" module configuration instead of almost-deprecated
	the Auth/database_file configuration (Note: zonemgr still uses the
	latter, so a secondary server would still need it for the moment).
	Due to this change, b10-xfrin does not auto-generate an initial
	zone for the very first transfer anymore; b10-loadzone has been
	extended with a new -e option for the initial setup.
	(Trac #2946, git 8191aec04c5279c199909f00f0a0b2b8f7bede94)

624.	[bug]		jinmei
	logging: prevented multiple BIND 10 processes from generating
	multiple small log files when they dumped logs to files and try
	to roll over them simultaneously.  This fix relies on a feature of
	underling logging library (log4cplus) version 1.1.0 or higher,
	so the problem can still happen if BIND 10 is built with an older
	version of log4cplus. (But this is expected to happen rarely in
	any case unless a verbose debug level is specified).
	(Trac #1622, git 5da8f8131b1224c99603852e1574b2a1adace236)

623.	[func]		tmark
	Created the initial, bare-bones implementation of DHCP-DDNS
	service process class, D2Process, and the abstract class
	from which it derives, DProcessBase. D2Process will provide
	the DHCP-DDNS specific event loop and business logic.
	(Trac #2955, git dbe4772246039a1257b6492936fda2a8600cd245)

622.	[func]*		jinmei
	b10-xfrin now has tighter control on the choice of IXFR or AXFR
	through zones/request_ixfr configuration item.  It includes
	the new "IXFR only" behavior for some special cases.  b10-xfrin
	now also uses AXFR whenever necessary, so it is now safe to try
	IXFR by default and it's made the default.  The previous
	use_ixfr configuration item was deprecated and triggers startup
	failure if specified; configuration using use_ixfr should be
	updated.
	(Trac #2911, git 8118f8e4e9c0ad3e7b690bbce265a163e4f8767a)

621.	[func]		team
	libdns++: All Rdata classes now use the generic lexer in
	constructors from text. This means that the name fields in such
	RRs in a zone file can now be non-absolute (the origin name in that
	context will be used), e.g., when loaded by b10-loadzone. Note
	that the existing string constructors for these Rdata classes also
	use the generic lexer, and they now expect an absolute name (with
	the trailing '.') in the name fields.
	(Trac #2522, git ea97070cf6b41299351fc29af66fa39c6465d56a)
	(Trac #2521, git c6603decaadcd33ccf9aee4a7b22447acec4b7f6)
	(See also ChangeLog 594, 564, 545)

620.	[bug]		jinmei
	b10-auth now returns SERVFAIL to queries for a zone that is
	configured to be loaded in-memory but isn't due to load time
	errors (missing zone file or errors in the zone file, etc).
	Such zones were previously treated as non existent and would
	result in REFUSED or unintentional match against less specific
	zones.  The revised behavior is also compatible with BIND 9.
	(Trac #2905, git 56ee9810fdfb5f86bd6948e6bf26545ac714edd8)

619.	[bug]		jinmei
	b10-xfrout now uses blocking send for xfr response messages
	to prevent abrupt termination of the stream due to a slower
	client or narrower network bandwidth.
	(Trac #2934, git bde0e94518469557c8b455ccbecc079a38382afd)

618.	[func]*		marcin
	b10-dhcp4: Added the ability for the server to respond to a
	directly connected client which does not yet have an IP address.
	On Linux, the server will unicast the response to the client's
	hardware address and the 'yiaddr' (the client's new IP
	address). Sending a response to the unicast address prevents other
	(not interested) hosts from receiving the server response. This
	capability is not yet implemented on non-Linux Operating Systems
	where, in all cases, the server responds to the broadcast
	address. The logic conforms to section 4.1 of RFC 2131.
	(Trac #2902, git c2d40e3d425f1e51647be6a717c4a97d7ca3c29c)

617.	[bug]		marcin
	b10-dhcp4: Fixed a bug whereby the domain-name option was encoded
	as FQDN (using technique described in RFC1035) instead of a string.
	Also, created new class which represents an option carrying a single
	string value. This class is now used for all standard options of
	this kind.
	(Trac #2786, git 96b1a7eb31b16bf9b270ad3d82873c0bd86a3530)

616.	[doc]		stephen
	Added description to the DHCP "Database Back-Ends" section of the
	BIND 10 Developer's Guide about how to set up a MySQL database for
	testing the DHCP MySQL backend.
	(Trac #2653, git da3579feea036aa2b7d094b1c260a80a69d2f9aa)

615.	[bug]		jinmei
	b10-auth: Avoid referencing to a freed object when authoritative
	server addresses are reconfigured.  It caused a crash on a busy
	server during initial startup time, and the same crash could also
	happen if listen_on parameters are reconfigured at run time.
	(Trac #2946, git d5f2a0d0954acd8bc33aabb220fab31652394fcd)

614.	[func]		tmark
	b10-d2: Initial DHCP-DDNS (a.k.a. D2) module implemented.
	Currently it does nothing useful, except for providing the
	skeleton implementation to be expanded in the future.
	(Trac #2954, git 392c5ec5d15cd8c809bc9c6096b9f2bfe7b8c66a)

613.	[func]		jinmei
	datasrc: Error handling in loading zones into memory is now more
	consistent and convenient: data source configuration does not fail
	due to zones configured to be loaded into memory but not available
	in the data source, just like the case of missing zone file for
	the MasterFiles type of data source.  Also, zones that aren't
	loaded into memory due to errors can now be reloaded for b10-auth
	using the bindctl Auth loadzone command after fixing the error,
	without reconfiguring the entire data source.
	(Trac #2851, git a3d4fe8a32003534150ed076ea0bbf80e1fcc43c)

612.	[func]		tomek
	b10-dhcp6: Support for relayed DHCPv6 traffic has been added.
	(Trac #2898, git c3f6b67fa16a07f7f7ede24dd85feaa7c157e1cb)

611.	[func]		naokikambe
	Added Xfrin statistics items such as the number of successful
	transfers.  These are per-zone type counters.  Their values can be
	obtained with zone names by invoking "Stats show Xfrin" via bindctl
	while Xfrin is running.
	(Trac #2252, git e1a0ea8ef5c51b9b25afa111fbfe9347afbe5413)

bind10-1.1.0beta2 released on May 10, 2013

610.	[bug]		muks
	When the sqlite3 program is not available on the system (in
	PATH), we no longer attempt to run some tests which depend
	on it.
	(Trac #1909, git f85b274b85b57a094d33ca06dfbe12ae67bb47df)

609.	[bug]		jinmei
	Handled some rare error cases in DNS server classes correctly.
	This fix specifically solves occasional crash of b10-auth due to
	errors caused by TCP DNS clients.  Also, as a result of cleanups
	with the fix, b10-auth should now be a little bit faster in
	handling UDP queries: in some local experiments it ran about 5%
	faster.
	(Trac #2903, git 6d3e0f4b36a754248f8a03a29e2c36aef644cdcc)

608.	[bug]		jinmei
	b10-cmdctl: fixed a hangup problem on receiving the shutdown
	command from bindctl.  Note, however, that cmdctl is defined as
	a "needed" module by default, so shutting down cmdctl would cause
	shutdown of the entire BIND 10 system anyway, and is therefore
	still not very useful in practice.
	(Trac #2712, git fa392e8eb391a17d30550d4b290c975710651d98)

607.	[bug]		jinmei
	Worked around some unit test regressions on FreeBSD 9.1 due to
	a binary compatibility issue between standard and system
	libraries (http://www.freebsd.org/cgi/query-pr.cgi?pr=175453).
	While not all tests still pass, main BIND 10 programs should
	generally work correctly.  Still, there can be odd run time
	behavior such as abrupt crash instead of graceful shutdown
	when some fatal event happens, so it's generally discouraged to
	use BIND 10 on FreeBSD 9.1 RELEASE.  According to the above
	bug report for FreeBSD, it seems upgrading or downgrading the
	FreeBSD version will solve this problem.
	(Trac #2887, git 69dfb4544d9ded3c10cffbbfd573ae05fdeb771f)

606.	[bug]		jinmei
	b10-xfrout now correctly stops sending notify requests once it
	receives a valid response.  It previously handled it as if the
	requests are timed out and resent it a few times in a short
	period.
	(Trac #2879, git 4c45f29f28ae766a9f7dc3142859f1d0000284e1)

605.	[bug]		tmark
	Modified perfdhcp to calculate the times displayed for packet sent
	and received as time elapsed since perfdhcp process start time.
	Previously these were times since the start of the epoch.
	However the large numbers involved caused loss of precision
	in the calculation of the test statistics.
	(Trac #2785, git e9556924dcd1cf285dc358c47d65ed7c413e02cf)

604.	[func]		marcin
	libdhcp++: abstracted methods which open sockets and send/receive
	DHCP4 packets to a separate class. Other classes will be derived
	from it to implement OS-specific methods of DHCPv4 packets filtering.
	The primary purpose for this change is to add support for Direct
	DHCPv4 response to a client which doesn't have an address yet on
	different OSes.
	(Trac #991, git 33ffc9a750cd3fb34158ef676aab6b05df0302e2)

603.	[func]		tmark
	The directory in which the b10-dhcp4 and b10-dhcp6 server id files has
	been changed from the local state directory (set by the "configure"
	--localstatedir switch) to the "bind10" subdirectory of it. After an
	upgrade, server id files in the former location will be orphaned and
	should be manually removed.
	(Trac #2770, git a622140d411b3f07a68a1451e19df36118a80650)

602.	[bug]		tmark
	Perfdhcp will now exit gracefully if the command line argument for
	IP version (-4 or -6) does not match the command line argument
	given for the server. Prior to this perfdhcp would core when given
	an IP version of -6 but a valid IPv4 address for server.
	(Trac #2784, git 96b66c0c79dccf9a0206a45916b9b23fe9b94f74)

601.	[bug]*		jinmei, vorner
	The "delete record" interface of the database based data source
	was extended so that the parameter includes reversed name in
	addition to the actual name.  This may help the underlying
	accessor implementation if reversed names are more convenient
	for the delete operation.  This was the case for the SQLite3
	accessor implementation, and it now performs delete operations
	much faster.  At a higher level, this means IXFR and DDNS Updates
	to the sqlite3 database are no longer so slow on large zones as
	they were before.
	(Trac #2877, git 33bd949ac7288c61ed0a664b7329b50b36d180e5)

600.	[bug]		tmark
	Changed mysql_lease_mgr to set the SQL mode option to STRICT. This
	causes mysql it to treat invalid input data as an error. Rather than
	"successfully" inserting a too large value by truncating it, the
	insert will fail, and the lease manager will throw an exception.
	Also, attempts to create a HWAddr (hardware address) object with
	too long an array of data now throw an exception.
	(Trac #2387, git cac02e9290600407bd6f3071c6654c1216278616)

599.	[func]		tomek
	libdhcp++: Pkt6 class is now able to parse and build relayed DHCPv6
	messages.
	(Trac #2827, git 29c3f7f4e82d7e85f0f5fb692345fd55092796b4)

bind10-1.1.0beta1 released on April 4, 2013

598.	[func]*		jinmei
	The separate "static" data source is now deprecated as it can be
	served in the more generic "MasterFiles" type of data source.
	This means existing configuration may not work after an update.
	If "config show data_sources/classes/CH[0]" on bindctl contains a
	"static" type of data source, you'll need to update it as follows:
	> config set data_sources/classes/CH[0]/type MasterFiles
	> config set data_sources/classes/CH[0]/params {"BIND": =>
	  "<the value of current data_sources/classes/CH[0]/params>"}
	> config set data_sources/classes/CH[0]/cache-enable true
	> config commit
	(Same for CH[1], CH[2], IN[0], etc, if applicable, although it
	should be very unlikely in practice.  Also note: '=>' above
	indicates the next line is actually part of the command.  Do
	not type in this "arrow").
	(Part of Trac #2833, git 0363b4187fe3c1a148ad424af39e12846610d2d7)

597.	[func]		tmark
	b10-dhcp6: Added unit tests for handling requests when no
	IPv6 subnets are configured/defined. Testing these conditions
	was overlooked during implementation of Trac #2719.
	(Trac #2721, git ce7f53b2de60e2411483b4aa31c714763a36da64)

596.	[bug]		jinmei
	Added special handling for the case where b10-auth receives a
	NOTIFY message, but zonemgr isn't running. Previously this was
	logged as a communications problem at the ERROR level, resulting
	in increasing noise when zonemgr is intentionally stopped. Other
	than the log level there is no change in externally visible
	behavior.
	(Trac #2562, git 119eed9938b17cbad3a74c823aa9eddb7cd337c2)

595.	[bug]		tomek
	All DHCP components now gracefully refuse to handle too short
	DUIDs and client-id.
	(Trac #2723, git a043d8ecda6aff57922fe98a33c7c3f6155d5d64)

594.	[func]		muks, pselkirk
	libdns++: the NSEC, DS, DLV, and AFSDB Rdata classes now use the
	generic lexer in constructors from text.  This means that the name
	fields in such RRs in a zone file can now be non-absolute (the
	origin name in that context will be used), e.g., when loaded by
	b10-loadzone.
	(Trac #2386, git dc0f34afb1eccc574421a802557198e6cd2363fa)
	(Trac #2391, git 1450d8d486cba3bee8be46e8001d66898edd370c)

593.	[func]		jelte
	Address + port output and logs is now consistent according to our
	coding guidelines, e.g. <address>:<port> in the case of IPv4, and
	[<address>]:<port> in the case of IPv6, instead of <address>#<port>
	(Trac #1086, git bcefe1e95cdd61ee4a09b20522c3c56b315a1acc)

592.	[bug]		jinmei
	b10-auth and zonemgr now handle some uncommon NOTIFY messages more
	gracefully: auth immediately returns a NOTAUTH response if the
	server does not have authority for the zone (the behavior
	compatible with BIND 9) without bothering zonemgr; zonemgr now
	simply skips retransfer if the specified zone is not in its
	secondary zone list, instead of producing noisy error logs.
	(Trac #1938, git 89d7de8e2f809aef2184b450e7dee1bfec98ad14)

591.	[func]		vorner
	Ported the remaining tests from the old shell/perl based system to
	lettuce. Make target `systest' is now gone. Currently, the lettuce
	tests are in git only, not part of the release tarball.
	(Trac #2624, git df1c5d5232a2ab551cd98b77ae388ad568a683ad)

590.	[bug]		tmark
	Modified "include" statements in DHCP MySQL lease manager code to
	fix build problems if MySQL is installed in a non-standard location.
	(Trac #2825, git 4813e06cf4e0a9d9f453890557b639715e081eca)

589.	[bug]		jelte
	b10-cmdctl now automatically re-reads the user accounts file when
	it is updated.
	(Trac #2710, git 16e8be506f32de668699e6954f5de60ca9d14ddf)

588.	[bug]*		jreed
	b10-xfrout: Log message id XFROUT_QUERY_QUOTA_EXCEEDED
	changed to XFROUT_QUERY_QUOTA_EXCEEDED.
	(git be41be890f1349ae4c870a887f7acd99ba1eaac5)

587.	[bug]		jelte
	When used from python, the dynamic datasource factory now
	explicitly loads the logging messages dictionary, so that correct
	logging messages does not depend on incidental earlier import
	statements. Also, the sqlite3-specific log messages have been moved
	from the general datasource library to the sqlite3 datasource
	(which also explicitly loads its messages).
	(Trac #2746, git 1c004d95a8b715500af448683e4a07e9b66ea926)

586.	[func]		marcin
	libdhcp++: Removed unnecessary calls to the function which
	validates option definitions used to create instances of options
	being decoded in the received packets. Eliminating these calls
	lowered the CPU utilization by the server by approximately 10%.
	Also, added the composite search indexes on the container used to
	store DHCP leases by Memfile backend. This resulted in the
	significant performance rise when using this backend to store
	leases.
	(Trac #2701, git b96a30b26a045cfaa8ad579b0a8bf84f5ed4e73f)

585.	[func]		jinmei, muks
	The zone data loader now accepts RRs in any order during load.
	Before it used to reject adding non-consecutive RRsets. It
	expected records for a single owner name and its type to be
	grouped together. These restrictions are now removed.  It now also
	suppresses any duplicate RRs in the zone file when loading them
	into memory.
	(Trac #2440, git 232307060189c47285121f696d4efb206f632432)
	(Trac #2441, git 0860ae366d73314446d4886a093f4e86e94863d4)

584.	[bug]		jinmei
	Fixed build failure with Boost 1.53 (and probably higher) in the
	internal utility library.  Note that with -Werror it may still
	fail, but it's due to a Boost bug that is reportedly fixed in their
	development trunk.  See https://svn.boost.org/trac/boost/ticket/8080
	Until the fix is available in a released Boost version you may need
	to specify the --without-werror configure option to build BIND 10.
	(Trac #2764, git ca1da8aa5de24358d7d4e7e9a4625347457118cf)

583.	[func]*		jelte
	b10-cmdctl-usermgr has been updated and its options and arguments
	have changed; it now defaults to the same accounts file as
	b10-cmdctl defaults to. It can now be used to remove users from the
	accounts file as well, and it now accepts command-line arguments to
	specify the username and password to add or remove, in which case
	it will not prompt for them.
	Note that using a password on the command line is not recommended,
	as this can be viewed by other users.
	(Trac #2713, git 9925af3b3f4daa47ba8c2eb66f556b01ed6f0502)

582.	[func]		naokikambe
	New statistics items related unixdomain sockets added into Xfrout :
	open, openfail, close, bindfail, acceptfail, accept, senderr, and
	recverr.  Their values can be obtained by invoking "Stats show Xfrout"
	via bindctl while Xfrout is running.
	(Trac #2225, git 6df60554683165adacc2d1c3d29aa42a0c9141a1)

581.	[func]*		y-aharen
	Added statistics items in b10-auth based on
	http://bind10.isc.org/wiki/StatisticsItems. Qtype counters are
	dropped as it requires further spec design discussion.
	(Trac #2154, Trac #2155,
	             git 61d7c3959eb991b22bc1c0ef8f4ecb96b65d9325)
	(Trac #2157, git e653adac032f871cbd66cd500c37407a56d14589)

bind10-1.0.0-rc released on February 14, 2013

580.	[func]*		muks
	There is no longer a default user account. The old default account
	with username 'root' has been removed. In a fresh installation of
	BIND 10, the administrator has to configure a user account using
	the b10-cmdctl-usermgr program.
	(Trac #2641, git 54e8f4061f92c2f9e5b8564240937515efa6d934)

579.	[bug]		jinmei
	libdatasrc/b10-auth: corrected some corner cases in query handling
	of in-memory data source that led to the following invalid/odd
	responses from b10-auth:
	- duplicate RRs in answer and additional for type ANY query
	- incorrect NSEC for no error, no data (NXRRSET) response that
	  matches a wildcard
	(Trac #2585, git abe78fae4ba3aca5eb01806dd4e05607b1241745)

578.	[bug]		jinmei
	b10-auth now returns closest encloser NSEC3 proof to queries for
	an empty non terminal derived from an Opt-Out NSEC3 RR, as clarified
	in errata 3441 for RFC5155.  Previously it regarded such case as
	broken zone and returned SERVFAIL.
	(Trac #2659, git 24c235cb1b379c6472772d340e21577c3460b742)

577.	[func]		muks
	Added an SQLite3 index on records(rname, rdtype). This decreases
	insert performance by ~28% and adds about ~20% to the file size,
	but increases zone iteration performance. As it introduces a new
	index, a database upgrade would be required.
	(Trac #1756, git 9b3c959af13111af1fa248c5010aa33ee7e307ee)

576.	[bug]		tmark, tomek
	b10-dhcp6: Fixed bug when the server aborts operation when
	receiving renew and there are no IPv6 subnets configured.
	(Trac #2719, git 3132b8b19495470bbfd0f2ba0fe7da443926034b)

575.	[bug]		marcin
	b10-dhcp6: Fixed the bug whereby the subnet for the incoming
	packet was selected using only its source address. The subnet
	is now selected using either source address or the name of the
	server's interface on which the packet has been received.
	(Trac #2704, git 1cbacf19a28bdae50bb9bd3767bca0147fde37ed)

574.	[func]		tmark
	b10-dhcp4, b10-dhcp6: Composite key indexes were added to the lease
	tables to reduce lease search time. The lease4 table now has two
	additional indexes: a) hwaddr/subnet_id and b) client_id/subnet_id.
	The lease6 now has the one additional index: iaid/subnet_id/duid.
	Adding these indexes significantly improves lease acquisition
	performance.
	(Trac #2699, #2703, git 54bbed5fcbe237c5a49b515ae4c55148723406ce)

573.	[bug]		stephen
	Fixed problem whereby the DHCP server crashed if it ran out of
	addresses.  Such a condition now causes a packet to be returned
	to the client refusing the allocation of an address.
	(Trac #2681, git 87ce14cdb121b37afb5b1931af51bed7f6323dd6)

572.	[bug]		marcin
	perfdhcp: Fixed bug where the command line switches used to
	run the perfdhcp where printed as ASCII codes.
	(Trac #2700, git b8d6b949eb7f4705e32fbdfd7694ca2e6a6a5cdc)

571.	[build]		jinmei
	The ./configure script can now handle output from python-config
	--ldflags that contains a space after -L switches.  This fixes
	failure reported on some Solaris environments.
	(Trac #2661, git e6f86f2f5eec8e6003c13d36804a767a840d96d6)

570.	[bug]		tmark, marcin, tomek
	b10-dhcp4: Address renewal now works properly for DHCPv4 clients
	that do not send client ID.
	(Trac #2702, git daf2abe68ce9c111334a15c14e440730f3a085e2)

569.	[bug]		tomek
	b10-dhcp4: Fix bug whereby a DHCP packet without a client ID
	could crash the MySQL lease database backend.
	(Trac #2697, git b5e2be95d21ed750ad7cf5e15de2058aa8bc45f4)

568.	[func]		muks
	Various message IDs have been renamed to remove the word 'ERROR'
	from them when they are not logged at ERROR severity level.
	(Trac #2672, git 660a0d164feaf055677f375977f7ed327ead893e)

567.	[doc]		marcin, stephen, tomek
	Update DHCP sections of the BIND 10 guide.
	(Trac #2657, git 1d0c2004865d1bf322bf78d13630d992e39179fd)

566.	[func]*		jinmei
	libdns++/Python isc.dns: In Python isc.dns, function style
	constants for RRType, RRClass, Rcode and Opcode were deprecated
	and replaced with straightforward object constants, e.g., from
	RRType.AAAA() to RRType.AAAA.  This is a backward incompatible
	change (see the Trac ticket for a conversion script if needed).
	Also, these constants are now more consistent between C++
	and Python, and RRType constants for all currently standardized
	types are now supported (even if Rdata for these are not yet
	available).
	(Trac #1866 and #2409, git e5005185351cf73d4a611407c2cfcd163f80e428)

565.	[func]*		jelte
	The main initializer script (formerly known as either 'bind10',
	'boss', or 'bob'), has been renamed to b10-init (and Init in
	configuration). Configuring which components are run is henceforth
	done through '/Init/components', and the sbin/bind10 script is now
	simply a shellscript that runs b10-init. Existing configuration is
	automatically updated. NOTE: once configuration with this update
	has been saved (by committing any new change with bindctl), you
	cannot run older versions of BIND 10 anymore with this configuration.
	(Trac #1901, git bae3798603affdb276f370c1ac6b33b011a5ed4f)

564.	[func]		muks
	libdns++: the CNAME, DNAME, MX, NS, PTR and SRV Rdata classes now
	use the generic lexer in constructors from text.  This means that
	the name fields in such RRs in a zone file can now be non-absolute
	(the origin name in that context will be used), e.g., when loaded
	by b10-loadzone. One additional change to the libdns++ API is that
	the existing string constructors for these Rdata classes also use
	the generic lexer, and they now expect an absolute name (with the
	trailing '.') in the name fields.
	(Trac #2390, git a01569277cda3f78b1171bbf79f15ecf502e81e2)
	(Trac #2656, git 5a0d055137287f81e23fbeedd35236fee274596d)

563.	[build]		jinmei
	Added --disable-rpath configure option to avoid embedding library
	paths to binaries.  Patch from Adam Tkac.
	(Trac #2667, git 1c50c5a6ee7e9675e3ab154f2c7f975ef519fca2)

562.	[func]*		vorner
	The b10-xfrin now performs basic sanity check on just received
	zone. It'll reject severely broken zones (such as missing NS
	records).
	(Trac #2439, git 44699b4b18162581cd1dd39be5fb76ca536012e6)

561.	[bug]		kambe, jelte
	b10-stats-httpd no longer dumps request information to the console,
	but uses the bind10 logging system. Additionally, the logging
	identifiers have been changed from STATHTTPD_* to STATSHTTPD_*
	(Trac #1897, git 93716b025a4755a8a2cbf250a9e4187741dbc9bb)

560.	[bug]		jinmei
	b10-auth now sets the TTL of SOA RR for negative responses to
	the minimum of the RR TTL and the minimum TTL of the SOA RDATA
	as specified in RFC2308; previously the RR TTL was always used.
	The ZoneFinder class was extended partly for implementing this
	and partly for allowing further optimization.
	(Trac #2309 and #2635, git ee17e979fcde48b59d91c74ac368244169065f3b)

559.	[bug]		jelte
	b10-cmdctl no longer aborts on basic file issues with its https
	certificate or private key file. It performs additional checks, and
	provides better error logs if these fail. Additionally, bindctl
	provides a better error report if it is unable to connect over
	https connection. This issue could occur if BIND 10 was installed
	with root privileges but then started as a normal user.
	(Trac #2595, git 09b1a2f927483b407d70e98f5982f424cc872149)

558.	[func]		marcin
	b10-dhcp4: server now adds configured options to its
	responses to a client when client requests them.
	A few basic options: Routers, Domain Name, Domain
	Name Servers and Subnet Mask are added regardless
	if client requested them or not.
	(Trac #2591, git aeec2dc1b9c511d17971ac63138576c37e7c5164)

557.	[doc]		stephen
	Update DHCP sections of the BIND 10 guide.
	(Trac #2642, git e5faeb5fa84b7218fde486347359504cf692510e)

556.	[bug]		marcin
	Fixed DHCP servers configuration whereby the servers did not
	receive a configuration stored in the database on their startup.
	Also, the configuration handler function now uses full configuration
	instead of partial to configure the server. This guarantees that
	dependencies between various configuration parameters are
	fulfilled.
	(Trac #2637, git 91aa998226f1f91a232f2be59a53c9568c4ece77)

555.	[func]		marcin
	The encapsulated option space name can be specified for
	a DHCP option. It comprises sub-options being sent within
	an option that encapsulates this option space.
	(Trac #2314, git 27e6119093723a1e46a239ec245a8b4b10677635)

554.	[func]		jinmei
	b10-loadzone: improved completion log message and intermediate
	reports: It now logs the precise number of loaded RRs on
	completion, and intermediate reports show additional information
	such as the estimated progress in percentage and estimated time
	to complete.
	(Trac #2574, git 5b8a824054313bdecb8988b46e55cb2e94cb2d6c)

553.	[func]		stephen
	Values of the parameters to access the DHCP server lease database
	can now be set through the BIND 10 configuration mechanism.
	(Trac #2559, git 6c6f405188cc02d2358e114c33daff58edabd52a)

552.	[bug]		shane
	Build on Raspberry PI.
	The main issue was use of char for reading from input streams,
	which is incorrect, as EOF is returned as an int -1, which would
	then get cast into a char -1.
	A number of other minor issues were also fixed.
	(Trac #2571, git 525333e187cc4bbbbde288105c9582c1024caa4a)

551.	[bug]		shane
	Kill msgq if we cannot connect to it on startup.
	When the boss process was unable to connect to the msgq, it would
	exit. However, it would leave the msgq process running. This has
	been fixed, and the msgq is now stopped in this case.
	(Trac #2608, git 016925ef2437e0396127e135c937d3a55539d224)

550.	[func]		tomek
	b10-dhcp4: The DHCPv4 server now generates a server identifier
	the first time it is run. The identifier is preserved in a file
	across server restarts.
	b10-dhcp6: The server identifier is now preserved in a file across
	server restarts.
	(Trac #2597, git fa342a994de5dbefe32996be7eebe58f6304cff7)

549.	[func]		tomek
	b10-dhcp6: It is now possible to specify that a configured subnet
	is reachable locally over specified interface (see "interface"
	parameter in Subnet6 configuration).
	(Trac #2596, git a70f6172194a976b514cd7d67ce097bbca3c2798)

548.	[func]		vorner
	The message queue daemon now appears on the bus. This has two
	effects, one is it obeys logging configuration and logs to the
	correct place like the rest of the modules. The other is it
	appears in bindctl as module (but it doesn't have any commands or
	configuration yet).
	(Trac #2582, git ced31d8c5a0f2ca930b976d3caecfc24fc04634e)

547.	[func]*		vorner
	The b10-loadzone now performs more thorough sanity check on the
	loaded data.  Some of the checks are now fatal and zone failing
	them will be rejected.
	(Trac #2436, git 48d999f1cb59f308f9f30ba2639521d2a5a85baa)

546.	[func]		marcin
	DHCP option definitions can be now created using the
	Configuration Manager. The option definition specifies
	the option code, name and the types of the data being
	carried by the option.  The Configuration Manager
	reports an error on attempt to override standard DHCP
	option definition.
	(Trac #2317, git 71e25eb81e58a695cf3bad465c4254b13a50696e)

545.	[func]		jinmei
	libdns++: the SOA Rdata class now uses the generic lexer in
	constructors from text.  This means that the MNAME and RNAME of an
	SOA RR in a zone file can now be non absolute (the origin name
	in that context will be used), e.g., when loaded by b10-loadzone.
	(Trac #2500, git 019ca218027a218921519f205139b96025df2bb5)

544.	[func]		tomek
	b10-dhcp4: Allocation engine support for IPv4 added. Currently
	supported operations are server selection (Discover/Offer),
	address assignment (Request/Ack), address renewal (Request/Ack),
	and address release (Release). Expired leases can be reused.
	Some options (e.g. Router Option) are still hardcoded, so the
	DHCPv4 server is not yet usable, although its address allocation
	is operational.
	(Trac #2320, git 60606cabb1c9584700b1f642bf2af21a35c64573)

543.	[func]*		jelte
	When calling getFullConfig() as a module, , the configuration is now
	returned as properly-structured JSON.  Previously, the structure had
	been flattened, with all data being labelled by fully-qualified
	element names.
	(Trac #2619, git bed3c88c25ea8f7e951317775e99ebce3340ca22)

542.	[func]		marcin
	Created OptionSpace and OptionSpace6 classes to represent DHCP
	option spaces. The option spaces are used to group instances
	and definitions of options having unique codes. A special type
	of option space is the so-called "vendor specific option space"
	which groups sub-options sent within Vendor Encapsulated Options.
	The new classes are not used yet but they will be used once
	the creation of option spaces by configuration manager is
	implemented.
	(Trac #2313, git 37a27e19be874725ea3d560065e5591a845daa89)

541.	[func]		marcin
	Added routines to search for configured DHCP options and their
	definitions using name of the option space they belong to.
	New routines are called internally from the DHCPv4 and DHCPv6
	servers code.
	(Trac #2315, git 741fe7bc96c70df35d9a79016b0aa1488e9b3ac8)

540.	[func]		marcin
	DHCP Option values can be now specified using a string of
	tokens separated with comma sign. Subsequent tokens are used
	to set values for corresponding data fields in a particular
	DHCP option. The format of the token matches the data type
	of the corresponding option field: e.g. "192.168.2.1" for IPv4
	address, "5" for integer value etc.
	(Trac #2545, git 792c129a0785c73dd28fd96a8f1439fe6534a3f1)

539.	[func]		stephen
	Add logging to the DHCP server library.
	(Trac #2524, git b55b8b6686cc80eed41793c53d1779f4de3e9e3c)

538.	[bug]		muks
	Added escaping of special characters (double-quotes, semicolon,
	backslash, etc.) in text-like RRType's toText() implementation.
	Without this change, some TXT and SPF RDATA were incorrectly
	stored in SQLite3 datasource as they were not escaped.
	(Trac #2535, git f516fc484544b7e08475947d6945bc87636d4115)

537.	[func]		tomek
	b10-dhcp6: Support for RELEASE message has been added. Clients
	are now able to release their non-temporary IPv6 addresses.
	(Trac #2326, git 0974318566abe08d0702ddd185156842c6642424)

536.	[build]		jinmei
	Detect a build issue on FreeBSD with g++ 4.2 and Boost installed via
	FreeBSD ports at ./configure time.  This seems to be a bug of
	FreeBSD	ports setup and has been reported to the maintainer:
	http://www.freebsd.org/cgi/query-pr.cgi?pr=174753
	Until it's fixed, you need to build BIND 10 for FreeBSD that has
	this problem with specifying --without-werror, with clang++
	(development version), or with manually extracted Boost header
	files (no compiled Boost library is necessary).
	(Trac #1991, git 6b045bcd1f9613e3835551cdebd2616ea8319a36)

535.	[bug]		jelte
	The log4cplus internal logging mechanism has been disabled, and no
	output from the log4cplus library itself should be printed to
	stderr anymore. This output can be enabled by using the
	compile-time option --enable-debug.
	(Trac #1081, git db55f102b30e76b72b134cbd77bd183cd01f95c0)

534.	[func]*		vorner
	The b10-msgq now uses the same logging format as the rest
	of the system. However, it still doesn't obey the common
	configuration, as due to technical issues it is not able
	to read it yet.
	(git 9e6e821c0a33aab0cd0e70e51059d9a2761f76bb)

bind10-1.0.0-beta released on December 20, 2012

533.	[build]*		jreed
	Changed the package name in configure.ac from bind10-devel
	to bind10. This means the default sub-directories for
	etc, include, libexec, share, share/doc, and var are changed.
	If upgrading from a previous version, you may need to move
	and update your configurations or change references for the
	old locations.
	(git bf53fbd4e92ae835280d49fbfdeeebd33e0ce3f2)

532.	[func]		marcin
	Implemented configuration of DHCPv4 option values using
	the configuration manager. In order to set values for the
	data fields carried by a particular option, the user
	specifies a string of hexadecimal digits that is converted
	to binary data and stored in the option buffer. A more
	user-friendly way of specifying option content is planned.
	(Trac #2544, git fed1aab5a0f813c41637807f8c0c5f8830d71942)

531.	[func]		tomek
	b10-dhcp6: Added support for expired leases. Leases for IPv6
	addresses that are past their valid lifetime may be recycled, i.e.
	relocated to other clients if needed.
	(Trac #2327, git 62a23854f619349d319d02c3a385d9bc55442d5e)

530.	[func]*		team
	b10-loadzone was fully overhauled.  It now uses C++-based zone
	parser and loader library, performing stricter checks, having
	more complete support for master file formats, producing more
	helpful logs, is more extendible for various types of data
	sources, and yet much faster than the old version.  In
	functionality the new version should be generally backwards
	compatible to the old version, but there are some
	incompatibilities: name fields of RDATA (in NS, SOA, etc) must
	be absolute for now; due to the stricter checks some input that was
	(incorrectly) accepted by the old version may now be rejected;
	command line options and arguments are not compatible.
	(Trac #2380, git 689b015753a9e219bc90af0a0b818ada26cc5968)

529.	[func]*		team
	The in-memory data source now uses a more complete master
	file parser to load textual zone files.  As of this change
	it supports multi-line RR representation and more complete
	support for escaped and quoted strings.  It also produces
	more helpful log messages when there is an error in the zone
	file.  It will be enhanced as more specific tasks in the
	#2368 meta ticket are completed.  The new parser is generally
	backward compatible to the previous one, but due to the
	tighter checks some input that has been accepted so far
	could now be rejected, so it's advisable to check if you
	use textual zone files directly loaded to memory.
	(Trac #2470, git c4cf36691115c15440b65cac16f1c7fcccc69521)

528.	[func]		marcin
	Implemented definitions for DHCPv4 option definitions identified
	by option codes: 1 to 63, 77, 81-82, 90-92, 118-119, 124-125.
	These definitions are now used by the DHCPv4 server to parse
	options received from a client.
	(Trac #2526, git 50a73567e8067fdbe4405b7ece5b08948ef87f98)

527.	[bug]		jelte
	Fixed a bug in the synchronous UDP server code where unexpected
	errors from ASIO or the system libraries could cause b10-auth to
	stop. In asynchronous mode these errors would be ignored
	completely. Both types have been updated to report the problem with
	an ERROR log message, drop the packet, and continue service.
	(Trac #2494, git db92f30af10e6688a7dc117b254cb821e54a6d95)

526.	[bug]		stephen
	Miscellaneous fixes to DHCP code including rationalisation of
	some methods in LeaseMgr and resolving some Doxygen/cppcheck
	issues.
	(Trac #2546, git 0140368ed066c722e5d11d7f9cf1c01462cf7e13)

525.	[func]		tomek
	b10-dhcp4: DHCPv4 server is now able to parse configuration. It
	is possible to specify IPv4 subnets with dynamic pools within
	them. Although configuration is accepted, it is not used yet. This
	will be implemented shortly.
	(Trac #2270, git de29c07129d41c96ee0d5eebdd30a1ea7fb9ac8a)

524.	[func]		tomek
	b10-dhcp6 is now able to handle RENEW messages. Leases are
	renewed and REPLY responses are sent back to clients.
	(Trac #2325, git 7f6c9d057cc0a7a10f41ce7da9c8565b9ee85246)

523.	[bug]		muks
	Fixed a problem in inmem NSEC3 lookup (for, instance when using a
	zone with no non-apex names) which caused exceptions when the zone
	origin was not added as an explicit NSEC3 record.
	(Trac #2503, git 6fe86386be0e7598633fe35999112c1a6e3b0370)

522.	[func]*		jelte
	Configuration of TSIG keys for b10-xfrin has changed; instead of
	specifying the full TSIG key (<name>:<base64>:<algo>) it now expects
	just the name, and uses the global TSIG Key Ring like all the other
	components (configuration list /tsig_keys/keys).
	Note: this is not automatically updated, so if you use TSIG in
	xfrin, you need to update your configuration.
	(Trac #1351, git e65b7b36f60f14b7abe083da411e6934cdfbae7a)

521.	[func]		marcin
	Implemented definitions for DHCPv6 standard options identified
	by codes up to 48. These definitions are now used by the DHCPv6
	server to create instances of options being sent to a client.
	(Trac #2491, git 0a4faa07777189ed9c25211987a1a9b574015a95)

520.	[func]		jelte
	The system no longer prints initial log messages to stdout
	regardless of what logging configuration is present, but it
	temporarily stores any log messages until the configuration is
	processed. If there is no specific configuration, or if the
	configuration cannot be accessed, it will still fall back to stdout.
	Note that there are still a few instances where output is printed,
	these shall be addressed separately.
	Note also that, currently, in case it falls back to stdout (such as
	when it cannot connect to b10-cfgmgr), all log messages are always
	printed (including debug messages), regardless of whether -v was
	used. This shall also be addressed in a future change.
	(Trac #2445, git 74a0abe5a6d10b28e4a3e360e87b129c232dea68)

519.	[bug]		muks
	Fixed a problem in inmem NSEC lookup which caused returning an
	incorrect NSEC record or (in rare cases) assert failures
	when a non-existent domain was queried, which was a sub-domain of
	a domain that existed.
	(Trac #2504, git 835553eb309d100b062051f7ef18422d2e8e3ae4)

518.	[func]		stephen
	Extend DHCP MySQL backend to handle IPv4 addresses.
	(Trac #2404, git ce7db48d3ff5d5aad12b1da5e67ae60073cb2607)

517.	[func]		stephen
	Added IOAddress::toBytes() to get byte representation of address.
	Also added convenience methods for V4/V6 address determination.
	(Trac #2396, git c23f87e8ac3ea781b38d688f8f7b58539f85e35a)

516.	[bug]		marcin
	Fixed 'make distcheck' failure when running perfdhcp unit tests.
	The unit tests used to read files from the folder specified
	with the path relative to current folder, thus when the test was
	run from a different folder the files could not be found.
	(Trac #2479, git 4e8325e1b309f1d388a3055ec1e1df98c377f383)

515.	[bug]		jinmei
	The in-memory data source now accepts an RRSIG provided without
	a covered RRset in loading.  A subsequent query for its owner name
	of the covered type would generally result in NXRRSET; if the
	covered RRset is of type NSEC3, the corresponding NSEC3 processing
	would result in SERVFAIL.
	(Trac #2420, git 6744c100953f6def5500bcb4bfc330b9ffba0f5f)

514.	[bug]		jelte
	b10-msgq now handles socket errors more gracefully when sending data
	to clients. It no longer exits with 'broken pipe' errors, and is
	also better at resending data on temporary error codes from send().
	(Trac #2398, git 9f6b45ee210a253dca608848a58c824ff5e0d234)

513.	[func]		marcin
	Implemented the OptionCustom class for DHCPv4 and DHCPv6.
	This class represents an option which has a defined
	structure: a set of data fields of specific types and order.
	It is used to represent those options that can't be
	represented by any other specialized class.
	(Trac #2312, git 28d885b457dda970d9aecc5de018ec1120143a10)

512.	[func]		jelte
	Added a new tool b10-certgen, to check and update the self-signed
	SSL certificate used by b10-cmdctl. The original certificate
	provided has been removed, and a fresh one is generated upon first
	build. See the b10-certgen manpage for information on how to update
	existing installed certificates.
	(Trac #1044, git 510773dd9057ccf6caa8241e74a7a0b34ca971ab)

511.	[bug]		stephen
	Fixed a race condition in the DHCP tests whereby the test program
	spawned a subprocess and attempted to read (without waiting) from
	the interconnecting pipe before the subprocess had written
	anything.  The lack of output was being interpreted as a test
	failure.
	(Trac #2410, git f53e65cdceeb8e6da4723730e4ed0a17e4646579)

510.	[func]		marcin
	DHCP option instances can be created using a collection of strings.
	Each string represents a value of a particular data field within
	an option. The data field values, given as strings, are validated
	against the actual types of option fields specified in the options
	definitions.
	(Trac #2490, git 56cfd6612fcaeae9acec4a94e1e5f1a88142c44d)

509.	[func]		muks
	Log messages now include the pid of the process that logged the
	message.
	(Trac #1745, git fc8bbf3d438e8154e7c2bdd322145a7f7854dc6a)

508.	[bug]		stephen
	Split the DHCP library into two directories, each with its own
	Makefile.  This properly solves the problem whereby a "make"
	operation with multiple threads could fail because of the
	dependencies between two libraries in the same directory.
	(Trac #2475, git 834fa9e8f5097c6fd06845620f68547a97da8ff8)

bind10-devel-20121115 released on November 15, 2012

507.	[doc]		jelte
	Added a chapter about the use of the bindctl command tool to
	to the BIND 10 guide.
	(Trac #2305, git c4b0294b5bf4a9d32fb18ab62ca572f492788d72)

506.	[security]		jinmei
	Fixed a use-after-free case in handling DNAME record with the
	in-memory data source.  This could lead to a crash of b10-auth
	if it serves a zone containing a DNAME RR from the in-memory
	data source.  This bug was introduced at bind10-devel-20120927.
	(Trac #2471, git 2b1793ac78f972ddb1ae2fd092a7f539902223ff)

505.	[bug]		jelte
	Fixed a bug in b10-xfrin where a wrong call was made during the
	final check of a TSIG-signed transfer, incorrectly rejecting the
	transfer.
	(Trac #2464, git eac81c0cbebee72f6478bdb5cda915f5470d08e1)

504.	[bug]*		naokikambe
	Fixed an XML format viewed from b10-stats-httpd. Regarding
	per-zone counters as zones of Xfrout, a part of the item
	values wasn't an exact XML format. A zone name can be
	specified in URI as
	/bind10/statistics/xml/Xfrout/zones/example.org/xfrreqdone.
	XSD and XSL formats are also changed to constant ones due
	to these changes.
	(Trac #2298, git 512d2d46f3cb431bcdbf8d90af27bff8874ba075)

503.	[func]		Stephen
	Add initial version of a MySQL backend for the DHCP code.  This
	implements the basic IPv6 lease access functions - add lease, delete
	lease and update lease.  The backend is enabled by specifying
	--with-dhcp-mysql on the "configure" command line: without this
	switch, the MySQL code is not compiled, so leaving BIND 10 able to
	be built on systems without MySQL installed.
	(Trac #2342, git c7defffb89bd0f3fdd7ad2437c78950bcb86ad37)

502.	[func]		vorner
	TTLs can be specified with units as well as number of seconds now.
	This allows specifications like "1D3H".
	(Trac #2384, git 44c321c37e17347f33ced9d0868af0c891ff422b)

501.	[func]		tomek
	Added DHCPv6 allocation engine, now used in the processing of DHCPv6
	messages.
	(Trac #2414, git b3526430f02aa3dc3273612524d23137b8f1fe87)

500.	[bug]		jinmei
	Corrected the autoconf example in the examples directory so it can
	use the configured path to Boost to check availability of the BIND 10
	library.  Previously the sample configure script could fail if
	Boost is installed in an uncommon place.  Also, it now provides a
	helper m4 function and example usage for embedding the library
	path to executable (using linker options like -Wl,-R) to help
	minimize post-build hassles.
	(Trac #2356, git 36514ddc884c02a063e166d44319467ce6fb1d8f)

499.	[func]		team
	The b10-auth 'loadzone' command now uses the internal thread
	introduced in 495 to (re)load a zone in the background, so that
	query processing isn't blocked while loading a zone.
	(Trac #2213, git 686594e391c645279cc4a95e0e0020d1c01fba7e)

498.	[func]		marcin
	Implemented DHCPv6 option values configuration using configuration
	manager. In order to set values for data fields carried by the
	particular option, user specifies the string of hexadecimal digits
	that is in turn converted to binary data and stored into option
	buffer. More user friendly way of option content specification is
	planned.
	(Trac #2318, git e75c686cd9c14f4d6c2a242a0a0853314704fee9)

497.	[bug]		jinmei
	Fixed several issues in isc-sysinfo:
	- make sure it doesn't report a negative value for free memory
	  size (this happened on FreeBSD, but can possibly occur on other
	  BSD variants)
	- correctly identifies the SMP support in kernel on FreeBSD
	- print more human readable uptime as well as the time in seconds
	(Trac #2297, git 59a449f506948e2371ffa87dcd19059388bd1657)

496.	[func]		tomek
	DHCPv6 Allocation Engine implemented. It allows address allocation
	from the configured subnets/pools. It currently features a single
	allocator: IterativeAllocator, which assigns addresses iteratively.
	Other allocators (hashed, random) are planned.
	(Trac #2324, git 8aa188a10298e3a55b725db36502a99d2a8d638a)

495.	[func]		team
	b10-auth now handles reconfiguration of data sources in
	background using a separate thread.  This means even if the new
	configuration includes a large amount of data to be loaded into
	memory (very large zones and/or a very large number of zones),
	the reconfiguration doesn't block query handling.
	(Multiple Trac tickets up to #2211)

494.	[bug]		jinmei
	Fixed a problem that shutting down BIND 10 kept some of the
	processes alive.  It was two-fold: when the main bind10 process
	started as a root, started b10-sockcreator with the privilege, and
	then dropped the privilege, the bind10 process cannot kill the
	sockcreator via signal any more (when it has to), but it kept
	sending the signal and didn't stop.  Also, when running on Python
	3.1 (or older), the sockcreator had some additional file
	descriptor open, which prevented it from exiting even after the
	bind10 process terminated.  Now the bind10 process simply gives up
	killing a subprocess if it fails due to lack of permission, and it
	makes sure the socket creator is spawned without any unnecessary
	FDs open.
	(Trac #1858, git 405d85c8a0042ba807a3a123611ff383c4081ee1)

493.	[build]		jinmei
	Fixed build failure with newer versions of clang++.  These
	versions are stricter regarding "unused variable" and "unused
	(driver) arguments" warnings, and cause fatal build error
	with -Werror.  The affected versions of clang++ include Apple's
	customized version 4.1 included in Xcode 4.5.1.  So this fix
	will solve build errors for Mac OS X that uses newer versions of
	Xcode.
	(Trac #2340, git 55be177fc4f7537143ab6ef5a728bd44bdf9d783,
	3e2a372012e633d017a97029d13894e743199741 and commits before it
	with [2340] in the commit log)

492.	[func]		tomek
	libdhcpsrv: The DHCP Configuration Manager is now able to store
	information about IPv4 subnets and pools. It is still not possible
	to configure that information. Such capability will be implemented
	in a near future.
	(Trac #2237, git a78e560343b41f0f692c7903c938b2b2b24bf56b)

491.	[func]		tomek
	b10-dhcp6: Configuration for DHCPv6 has been implemented.
	Currently it is possible to configure IPv6 subnets and pools
	within those subnets, global and per subnet values of renew,
	rebind, preferred and valid lifetimes. Configured parameters
	are accepted, but are not used yet by the allocation engine yet.
	(Trac #2269, git 028bed9014b15facf1a29d3d4a822c9d14fc6411)

490.	[func]		tomek
	libdhcpsrv: An abstract API for lease database has been
	implemented. It offers a common interface to all concrete
	database backends.
	(Trac #2140, git df196f7609757253c4f2f918cd91012bb3af1163)

489.	[func]		muks
	The isc::dns::RRsetList class has been removed. It was now unused
	inside the BIND 10 codebase, and the interface was considered
	prone to misuse.
	(Trac #2266, git 532ac3d0054f6a11b91ee369964f3a84dabc6040)

488.	[build]		jinmei
	On configure, changed the search order for Python executable.
	It first tries more specific file names such as "python3.2" before
	more generic "python3".  This will prevent configure failure on
	Mac OS X that installs Python3 via recent versions of Homebrew.
	(Trac #2339, git 88db890d8d1c64de49be87f03c24a2021bcf63da)

487.	[bug]		jinmei
	The bind10 process now terminates a component (subprocess) by the
	"config remove Boss/components" bindctl command even if the
	process crashes immediately before the command is sent to bind10.
	Previously this led to an inconsistent state between the
	configuration and an internal component list of bind10, and bind10
	kept trying to restart the component.  A known specific case of
	this problem is that b10-ddns could keep failing (due to lack of
	dependency modules) and the administrator couldn't stop the
	restart via bindctl.
	(Trac #2244, git 7565788d06f216ab254008ffdfae16678bcd00e5)

486.	[bug]*		jinmei
	All public header files for libb10-dns++ are now installed.
	Template configure.ac and utility AC macros for external projects
	using the library are provided under the "examples" directory.
	The src/bin/host was moved as part of the examples (and not
	installed with other BIND 10 programs any more).
	(Trac #1870, git 4973e638d354d8b56dcadf71123ef23c15662021)

485.	[bug]		jelte
	Several bugs have been fixed in bindctl; tab-completion now works
	within configuration lists, the problem where sometimes the
	completion added a part twice has been solved, and it no longer
	suggests the confusing value 'argument' as a completion-hint for
	configuration items. Additionally, bindctl no longer crashes upon
	input like 'config remove Boss'.
	(Trac #2254, git 9047de5e8f973e12e536f7180738e6b515439448)

484.	[func]		tomek
	A new library (libb10-dhcpsrv) has been created. At present, it
	only holds the code for the DHCP Configuration Manager. Currently
	this object only supports basic configuration storage for the DHCPv6
	server, but that capability will be expanded.
	(Trac #2238, git 6f29861b92742da34be9ae76968e82222b5bfd7d)

bind10-devel-20120927 released on September 27, 2012

483.	[func]		marcin
	libdhcp++: Added new parameter to define sub-second timeout
	for DHCP packet reception. The total timeout is now specified
	by two parameters:  first specifies integral number of
	seconds, second (which defaults to 0) specifies fractional
	seconds with microsecond resolution.
	(Trac #2231, git 15560cac16e4c52129322e3cb1787e0f47cf7850)

482.	[func]		team
	Memory footprint of the in-memory data source has been
	substantially improved.  For example, b10-auth now requires much
	less memory than BIND 9 named for loading and serving the same
	zone in-memory.  This is a transparent change in terms of user
	operation; there's no need to update or change the configuration
	to enable this feature.
	Notes: multiple instances of b10-auth still make separate copies
	of the memory image.  Also, loading zones in memory still suspends
	query processing, so manual reloading or reloading after incoming
	transfer may cause service disruption for huge zones.
	(Multiple Trac tickets, Summarized in Trac #2101)

481.	[bug]		vorner
	The abbreviated form of IP addresses in ACLs is accepted
	(eg. "from": ["127.0.0.1", "::1"] now works).
	(Trac #2191, git 48b6e91386b46eed383126ad98dddfafc9f7e75e)

480.	[doc]		vorner
	Added documentation about global TSIG key ring to the Guide.
	(Trac #2189, git 52177bb31f5fb8e134aecb9fd039c368684ad2df)

479.	[func]		marcin
	Refactored perfdhcp tool to C++, added missing unit tests and removed
	the old code. The new code uses libdhcp++ (src/lib/dhcp) for DHCP
	packet management, network interface management and packet
	transmission.
	(Trac #1954, git 8d56105742f3043ed4b561f26241f3e4331f51dc)
	(Trac #1955, git 6f914bb2c388eb4dd3e5c55297f8988ab9529b3f)
	(Trac #1956, git 6f914bb2c388eb4dd3e5c55297f8988ab9529b3f)
	(Trac #1957, git 7fca81716ad3a755bf5744e88c3adeef15b04450)
	(Trac #1958, git 94e17184270cda58f55e6da62e845695117fede3)
	(Trac #1959, git a8cf043db8f44604c7773e047a9dc2861e58462a)
	(Trac #1960, git 6c192e5c0903f349b4d80cf2bb6cd964040ae7da)

478.	[func]		naokikambe
	New statistics items added into b10-xfrout: ixfr_running and
	axfr_running.  Their values can be obtained by invoking "Stats show
	Xfrout" via bindctl while b10-xfrout is running.
	(Trac #2222, git 91311bdbfea95f65c5e8bd8294ba08fac12405f1)

477.	[bug]		jelte
	Fixed a problem with b10-msgq on OSX when using a custom Python
	installation, that offers an unreliable select.poll() interface.
	(Trac #2190, git e0ffa11d49ab949ee5a4ffe7682b0e6906667baa)

476.	[bug]		vorner
	The Xfrin now accepts transfers with some TSIG signatures omitted, as
	allowed per RFC2845, section 4.4. This solves a compatibility
	issues with Knot and NSD.
	(Trac #1357, git 7ca65cb9ec528118f370142d7e7b792fcc31c9cf)

475.	[func]		naokikambe
	Added Xfrout statistics counters: notifyoutv4, notifyoutv6,
	xfrrej, and xfrreqdone. These are per-zone type counters.
	The value of these counters can be seen with zone name by
	invoking "Stats show Xfrout" via bindctl.
	(Trac #2158, git e68c127fed52e6034ab5309ddd506da03c37a08a)

474.	[func]		stephen
	DHCP servers now use the BIND 10 logging system for messages.
	(Trac #1545, git de69a92613b36bd3944cb061e1b7c611c3c85506)

473.	[bug]		jelte
	TCP connections now time out in b10-auth if no (or not all) query
